'
'  Function and Subprogram declarations for Graphics Library (GRAPHLIB.BAS)
'
'  Last Update: 3 Jan 93
'
DECLARE FUNCTION VideoMode% ()
DECLARE FUNCTION TextScreen% ()
DECLARE SUB SetTextScreen ()
DECLARE SUB BOX (IX1%, IY1%, IX2%, IY2%, IC%)
DECLARE SUB TextBox (IR1%, IC1%, IR2%, IC2%, ICL%, IBCL%)
DECLARE SUB PixelPosition (IR%, IC%, NCPIX%, NRPIX%, IX%, IY%)
DECLARE SUB LineClip (IX1%, IY1%, IX2%, IY2%, I1%, I2%, J1%, J2%, JFL%)
DECLARE SUB DrawCross (IX%, IY%, J%, IC%)
DECLARE SUB ExpansionBox (IX1%, IY1%, IX2%, IY2%, IXMAX%, IYMAX%, IMODE%)
'
'  Mouse utility subroutines
'
DECLARE SUB MOUSE (M1%, M2%, M3%, M4%)
DECLARE SUB HideMouse ()
DECLARE SUB ShowMouse ()
DECLARE SUB ButtonRelease ()
DECLARE SUB PutMouse (IX%, IY%)
DECLARE SUB MouseReset (ISTAT%)
DECLARE SUB MouseLimits (IX1%, IY1%, IX2%, IY2%)
DECLARE SUB MouseWait (IX%, IY%, IB%)
DECLARE SUB GetMousePosition (IX%, IY%, BS%)
DECLARE SUB GetButtonPress (BN%, IX%, IY%, BS%)
DECLARE SUB SetMouseShape (IX%, IY%)
DECLARE SUB ArrowCursor ()
DECLARE SUB CrosshairCursor ()
DECLARE SUB HourglassCursor ()
DECLARE SUB SetTextCursor ()
DECLARE SUB ConvertToRC (J1%, J2%)
DECLARE SUB ShowButton (BU AS ANY)


DECLARE SUB ClearTopLine ()
DECLARE SUB KeyWait (KEY$)
DECLARE SUB PROMPT ()
DECLARE FUNCTION FormL$ (X1!, X2!, AXIS$)
DECLARE FUNCTION FormD$ (X1!, X2!)
DECLARE FUNCTION FormFSF$ (X1!, X2!)
DECLARE FUNCTION FormISF$ (X1!, X2!)
DECLARE FUNCTION TRIM$ (A$)
DECLARE FUNCTION BlankLine% (A$)

'
'  Other utilities
'
DECLARE SUB GetWord (J1%, J2%, Word$)
DECLARE FUNCTION AlphaNumeric% (J%)
DECLARE FUNCTION WordCharacter% (J%)
DECLARE FUNCTION Delimiter% (Sym AS STRING)
'
' Data type for mouse activated buttons
'
TYPE ActionButton
  Active AS INTEGER                   ' button active flag
  TopRow AS INTEGER                   ' top row of box
  LeftCol AS INTEGER                  ' left col of box
  NCOLS AS INTEGER                    ' column width of box
  NROWS AS INTEGER                    ' row width of box
  Background AS INTEGER               ' background color
  Foreground AS INTEGER               ' foreground color
  Border AS INTEGER                   ' border type
  ButtonText AS STRING * 10           ' text of button
END TYPE
'
' Data type for menus
'
TYPE GraphicsMenu
  IR1 AS INTEGER                      ' first row
  IR2 AS INTEGER                      ' last row
  IC1 AS INTEGER                      ' first column
  IC2 AS INTEGER                      ' last column
  NOPT AS INTEGER                     ' number of options
  Selection AS INTEGER                ' selected item
END TYPE
'
'  Cursor array
'
'  $STATIC
        DIM ICURSOR (16, 2) AS INTEGER
'  $DYNAMIC

        COMMON SHARED /GRAPHVARS/ ICURSOR() AS INTEGER, _
          CANCbutn AS ActionButton, OKbutn AS ActionButton, _
          HELPbutn AS ActionButton, CONTbutn AS ActionButton, _
          NEXTbutn AS ActionButton, PREVbutn AS ActionButton

