'  XYPLOT.INC
'
'    Include file for XYPLOT and associated files.
'
' Copyright (c) 1993 Creative Consulting for Research & Education
'
'    Last Update: 24 Oct 93
'
DECLARE SUB ViewFile (F$)
DECLARE SUB ScreenTitle (T$, TC%)
DECLARE SUB DisplayHeader (HDR$, MODE$, IR1%, IR2%)
DECLARE SUB DisplayFile (FL$)
DECLARE SUB Message1 ()
DECLARE SUB Message2 ()
DECLARE SUB KeyHelp (KEY$)
DECLARE SUB ErrorDisplay (NUMBER%)
DECLARE SUB DirectorySet (DIR$)
'
DECLARE SUB SelectFile (FSpec$, MODE%, P$, FL$, IX%, IY%, BS%)
DECLARE SUB FileView ()
DECLARE SUB ShowDir (FSpec$)
DECLARE SUB DisplayDirectory (FileSpec$, IR%, NLINES%, IFC%, IBC%, IAC%)
DECLARE SUB ViewHeader ()
DECLARE SUB XColor (COL%)

DECLARE SUB MenuBox (GM AS ANY, OPT$())
DECLARE SUB MenuSelection (KEY$)
DECLARE SUB HighlightOption (GM AS ANY, Opt%)
DECLARE SUB ShowMenu (KEY$)
DECLARE SUB FileMenu (KEY$)
DECLARE SUB SetMenu (KEY$)
DECLARE SUB IncludeMenu (KEY$)
DECLARE SUB SaveMenu (KEY$)
DECLARE SUB PlotMenu (KEY$)
DECLARE SUB SymbolMenu (KEY$)
DECLARE SUB MathMenu (KEY$)
DECLARE SUB ArithmeticMenu (KEY$)
DECLARE SUB FitMenu (KEY$)
DECLARE SUB MathMenu2 (KEY$)
DECLARE SUB FFTMenu (KEY$)
DECLARE SUB ComplexMenu (KEY$)
DECLARE SUB ExitMenu (KEY$)
DECLARE SUB ButtonMenu (N%, KEY$)
DECLARE SUB SetSaveOptions ()

DECLARE FUNCTION IBOUND% (IX%, IY%)
DECLARE FUNCTION IBOUND2% (IX%, IY%)
DECLARE SUB CmpToReal (X!(), Y!(), NS%, JP%)
DECLARE SUB RealToCmp (X!(), Y!(), NS%)
DECLARE SUB PolynomialFit (X!(), Y!(), NS%)
DECLARE SUB PlotArithmetic (X!(), Y!(), NS1%, NS2%, KEY$)
DECLARE SUB Template (X!(), Y!())
DECLARE SUB SetDataToZero (X!(), Y!(), NS1%)
DECLARE SUB XScale (X!(), Y!(), NS%)
DECLARE SUB XSmooth (Y!(), NS%)
DECLARE SUB XArea (X!(), Y!(), NS%)
DECLARE SUB XDeriv (X!(), Y!(), NS%)
DECLARE SUB XFFT (X!(), Y!(), NS%, KEY$)
DECLARE SUB XMAG (X!(), Y!(), NS%)
DECLARE SUB XPHASE (X!(), Y!(), NS%)
DECLARE SUB XCONJ (X!(), Y!(), NS%)
DECLARE SUB SortDataSet (X!(), Y!(), NS%)

DECLARE SUB SpecialKey (KEY$)
DECLARE SUB GetKey (Key$, BS%)
DECLARE SUB GetInput (REQ$)
DECLARE SUB KMouse (KEY$)
DECLARE SUB KeypadMouse (KEY$)
DECLARE SUB SetCursor ()
DECLARE SUB DataCursor (X!(), Y!(), NP%)

DECLARE SUB Overlap (NS1%, NS2%, X1!, X2!)
DECLARE SUB CopyrightNotice ()

DECLARE SUB FileRead (X!(), Y!(), FType%)
DECLARE SUB StoreData (X!(), Y!(), NS%)
DECLARE SUB ReadWork (X!(), Y!(), FL$)
DECLARE SUB SaveWork (X!(), Y!())
DECLARE SUB SaveWK1 (X!(), Y!())
DECLARE SUB XYREAD (X!(), Y!(), NPTS%, PlotType%, JS%, JE%, IERR%, F$, HDR$)
DECLARE SUB SelectColumns (N%, NC%, IXC%, IYRC%, IYIC%)
DECLARE SUB ReadHeader (F$, HDR$, A$)
DECLARE SUB ReadIniFile (Pcolors$, Wcolors$)

DECLARE SUB DropPlot (NP%)
DECLARE SUB AddNewPlot (NS%, SYM$, NP%)
DECLARE SUB AddNewSet (X!(), Y!(), J1%, J2%, CMPLX%, FL$, HDR$, NS%)
DECLARE SUB IncludeSet (NS%)
DECLARE SUB DeleteSet (X!(), Y!(), NS%)
DECLARE SUB DeletePoint (X!(), Y!(), NS%, J%)
DECLARE SUB InsertPoint (X!(), Y!(), NS%, XX!, YY!)
DECLARE SUB ShiftValues (X!(), Y!(), J1%, M%)
DECLARE SUB XDuplicate (X!(), Y!(), NS%)
DECLARE SUB CopySet (X!(), Y!(), NS%)
DECLARE SUB JoinSets (X!(), Y!(), NS1%, NS2%)
DECLARE SUB PruneSet (X!(), Y!(), NS%)
DECLARE SUB Expand ()
DECLARE SUB Extrema (X!(), Y!(), NS%)
DECLARE SUB FullWindow ()

DECLARE SUB SetColors (P$, W$)
DECLARE SUB InitializeGraphics ()
DECLARE SUB InitParameters ()
DECLARE SUB NewSpace (JFL%)

DECLARE SUB PlotList ()
DECLARE SUB SelectColor (N%)
DECLARE SUB Labels ()
DECLARE SUB Grid ()
DECLARE SUB Coordinates (XX!, YY!, IX%, IY%, JFL%)
DECLARE FUNCTION PlotVisible% (NP%)
DECLARE SUB PXY (X!(), Y!(), NP%)
DECLARE SUB ScreenPlot (X!(), Y!())
DECLARE SUB PointPlot (X!(), Y!(), JX1%, JX2%, JY1%, ISIZE%, IC%)
DECLARE SUB LinePlot (X!(), Y!(), JX1%, JX2%, JY1%, ISTYLE%, IC%)
DECLARE SUB StickPlot (X!(), Y!(), JX1%, JX2%, JY1%, IC%)
DECLARE SUB ExitXYPLOT ()
DECLARE SUB SetCorners ()

DECLARE SUB XShell ()

'  $DYNAMIC

' --------------------------------------------------------------------
'                       GLOBAL CONSTANTS
' --------------------------------------------------------------------
'
        CONST YES = -1
        CONST NO = 0
        CONST RET = 13
        CONST ESC = 27
        CONST DefaultSymbol$ = "L"

'
' --------------------------------------------------------------------
'               CONFIGURABLE CONSTANTS
' --------------------------------------------------------------------

        CONST MaxPoints = 16000         ' maximum points in data base
        CONST MaxDataSets = 10          ' number of allowed data sets
        CONST MaxPlots = 9              ' number of plots
        CONST MaxTerms = 10             ' max terms in fitting matrix
        CONST MaxOpts = 10              ' max menu options
        CONST HeaderLength = 4096       ' length of header text
        CONST Version$ = "4.1"          ' current version number

' --------------------------------------------------------------------
'               XYPLOT DATA STRUCTURES
' --------------------------------------------------------------------
'
'  Define data structure DataSet containing data set information
'
	TYPE DataSet
    JSr AS INTEGER                ' starting index in X(), Y() for real part
    JEr AS INTEGER                ' ending index for real part
    JSi AS INTEGER                ' starting index for imaginary part
    JEi AS INTEGER                ' ending index for imaginary part
	  CMPLX AS INTEGER              ' complex data flag
	  NPTS AS INTEGER               ' number of points
    XMIN AS SINGLE                ' extrema for real part of x
	  XMAX AS SINGLE                '   "               "
    iXMIN AS SINGLE               ' extrema for imag part of x
    iXMAX AS SINGLE               '   "               "
    YMIN AS SINGLE                ' extrema for real part of y
	  YMAX AS SINGLE                '   "               "
    iYMIN AS SINGLE               ' extrema for imag part of y
	  iYMAX AS SINGLE               '   "               "
	  FNAME AS STRING * 25          ' file name for source of data set
	  HDR AS STRING * HeaderLength  ' file header for plot
	END TYPE

'
'  Define structure to keep track of data base
'
	TYPE DataBase
	  NSETS AS INTEGER              ' number of data sets
	  NVALS AS INTEGER              ' total number of x, y pairs
    HDR AS STRING * HeaderLength  ' workspace header
  END TYPE

'
'  Define data structure ScreenInfo containing screen information
'
	TYPE ScreenInfo
	  N AS INTEGER                  ' screen number
	  NROWS AS INTEGER              ' number of rows
	  NCOLS AS INTEGER              ' number of columns
	  NCOLORS AS INTEGER            ' number of colors
	  XRES AS INTEGER               ' resolution in x
	  YRES AS INTEGER               ' resolution in y
	  NCPIX AS INTEGER              ' number of pixels per column
	  NRPIX AS INTEGER              ' number of pixels per row
	  IX1 AS INTEGER                ' min. x physical coordinate
	  IX2 AS INTEGER                ' max. x physical coordinate
	  IY1 AS INTEGER                ' etc.
	  IY2 AS INTEGER                ' etc.
	  YINV AS INTEGER               ' inversion coordinate
	  MFLAG AS INTEGER              ' monochrome monitor flag
	END TYPE
'
'
'  Define data structure PlotInfo containing plot information
'
	TYPE PlotInfo
	  SET AS INTEGER                ' data set number for plot
	  SYM AS STRING * 1             ' plotting symbol (e.g. line, point)
	  COL AS INTEGER                ' color of real data of plot
    VIS AS INTEGER                ' plot visibility (0, 1, or 2)
	END TYPE
'
'
'  Define data structure DisplayInfo containing display information
'
	TYPE DisplayInfo
	  NPLOTS AS INTEGER             ' number of plots
	  PLIST AS INTEGER              ' first number in plot list
    SP1 AS INTEGER                ' selected plot 1
    SP2 AS INTEGER                ' selected plot 2
	  SCALE AS INTEGER              ' 0 for linear, -1 for log
	  XMIN AS SINGLE                ' minimum x for display
	  XMAX AS SINGLE                ' maximum x
	  YMIN AS SINGLE                ' etc.
	  YMAX AS SINGLE                '
	  CSIZE AS INTEGER              ' cursor size
	  CMODE AS INTEGER              ' cursor mode
	  LEVEL AS INTEGER              ' expansion level
	  Grid AS INTEGER               ' grid lines switch
	  IB AS INTEGER                 ' last mouse button pressed
	  IX AS INTEGER                 ' cursor last x
	  IY AS INTEGER                 ' cursor last y
	  XSF AS SINGLE                 ' pixels/unit in x
	  YSF AS SINGLE                 ' pixels/unit in y
	  YLSF AS SINGLE                ' pixels/log(unit) in y
	  LYMIN AS SINGLE               ' log(d.ymin)
	END TYPE
'
'  Define data structure to keep track of color information
'

    TYPE ColorInfo
       DWB AS INTEGER       ' directory background
       DWF AS INTEGER       ' directory foreground
       DWA AS INTEGER       ' directory alternate
       FWB AS INTEGER       ' file view background
       FWF AS INTEGER       ' file view foreground
       FWA AS INTEGER       ' file view alternate
       HWB AS INTEGER       ' header view background
       HWF AS INTEGER       ' header view foreground
       HWA AS INTEGER       ' header view alternate
       GWB AS INTEGER       ' graphics window background
       GBC AS INTEGER       ' grid box color
       CLC AS INTEGER       ' coordinate labels color
       CCC AS INTEGER       ' cursor coordinates color
       MIC AS INTEGER       ' menu items color
    END TYPE
'
'  Data type to store math operations info
'
    TYPE MathInfo
      ErrType AS INTEGER    ' type of error (0 = statistical, 1 = specified)
      Sigma AS SINGLE       ' specified uncertianty
      Corr AS SINGLE        ' correlation coefficient
      ChisqR AS SINGLE      ' chi-square for fit (real)
      ChisqI AS SINGLE      '    "  " (imaginary)
    END TYPE
'
'  Data type to store file save options
'
    TYPE SaveInfo
      HS AS INTEGER         ' save header flag
      FM AS STRING*1        ' number format ("E", "F", or "I")
      DL AS STRING*1        ' character delimiter (" ", or ",")
    END TYPE

'
'  Define corner information type CornerInfo
'
	TYPE CornerInfo
	  N AS INTEGER
	  XMIN AS SINGLE
	  XMAX AS SINGLE
	  YMIN AS SINGLE
	  YMAX AS SINGLE
	END TYPE
'
' Lotus 1-2-3 worksheet data types
'
  TYPE WksBOF
    TypeCode AS INTEGER
    BodyLength AS INTEGER
    Revision AS INTEGER
  END TYPE

  TYPE WksEOF
    TypeCode AS INTEGER
    BodyLength AS INTEGER
  END TYPE

  TYPE WksRange
    TypeCode AS INTEGER
    BodyLength AS INTEGER
    StartCol AS INTEGER
    StartRow AS INTEGER
    EndCol AS INTEGER
    EndRow AS INTEGER
  END TYPE

  TYPE WksNumHeader
    TypeCode AS INTEGER
    BodyLength AS INTEGER
    Fmt AS STRING*1
  END TYPE

  TYPE WksNumber
    Col AS INTEGER
    Row AS INTEGER
    Value AS DOUBLE
  END TYPE

' ---------------------------------------------------------------
'      XYPLOT GLOBAL VARIABLES
' ---------------------------------------------------------------
'
'

        COMMON SHARED /XYVARS/ DS() AS DataSet, PV() AS PlotInfo, _
          DI AS DisplayInfo, SI AS ScreenInfo, MI AS MathInfo,_
          CI AS ColorInfo, VI AS SaveInfo, CORNERS() AS CornerInfo,_
          DB AS DataBase, AlphaR() AS DOUBLE, AlphaI() AS DOUBLE,_
          Ar() AS SINGLE, Ai() AS SINGLE, StartFile$, Dsym$,_
          IGC() AS INTEGER, IAREA() AS INTEGER, WKSaved

        DIM DS(1 TO MaxDataSets) AS DataSet
        DIM PV(1 TO MaxPlots) AS PlotInfo
        DIM CORNERS(1 TO 5) AS CornerInfo
        DIM AlphaR (MaxTerms, MaxTerms) AS DOUBLE
        DIM AlphaI (MaxTerms, MaxTerms) AS DOUBLE
        DIM Ar (MaxTerms) AS SINGLE
        DIM Ai (MaxTerms) AS SINGLE
        DIM IGC (500) AS INTEGER
        DIM IAREA (500) AS INTEGER
