'
' ---------------------------------------------------------------
'
SUB SpecifyErrors
'
'  Set weighting for least-squares fit.
'
        SetTextScreen
        LOCATE 4, 20
        PRINT "Choose error type:"
        LOCATE 6, 25
        PRINT "(0) Statistical"
        LOCATE 8, 25
        PRINT "(1) Equal"
        LOCATE 10, 25
        PRINT "(2) Estimate"

        LOCATE 14, 20
        PRINT "Choice";
        INPUT MI.ErrType
        IF MI.ErrType = 1 THEN
          LOCATE 14, 20
          PRINT "Enter uncertainty sigma: ";
          INPUT S
          MI.Sigma = ABS(S)
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB LCFit (X(), Y(), NP)
'
'  Compute fit of active plot as a linear combination of all other
'    plots.
'
        DIM JA(MaxTerms) AS INTEGER

        NS = PV(NP).SET
        JS = DS(NS).JSr
        NPTS = DS(NS).NPTS
        NTERMS = DI.NPLOTS - 1
        J = 1
        FOR K = 1 TO DI.NPLOTS
          IF K <> NP THEN
            JA(J) = DS(PV(K).SET).JSr
            J = J + 1
          END IF
        NEXT K

        LinearLeastSquares Y(), JA(), Ar(), JS, NPTS, AlphaR(),_
           NTERMS, MI.ErrType, MI.Sigma, IERR

'
'  Compute the fitted function.
'
        J1 = DS(DB.NSETS).JEi + 1
        J2 = J1 + NPTS - 1
        IF J2 > MaxPoints THEN
          ErrorDisplay 238
          EXIT SUB
        END IF
        FOR J = 1 TO NPTS
          JN = J1 + J - 1
          X(JN) = X(JS + J - 1)
          S = 0!
          FOR K = 1 TO NTERMS
            S = S + Ar(K)*Y(JA(K) + J - 1)
          NEXT K
          Y(JN) = S
        NEXT J

        HDR$ = "==XYPLOT==> LCFIT OF " + RTRIM$(DS(NS).FNAME) + CHR$(RET)

        AddNewSet X(), Y(), J1, J2, NO, "LCFIT", HDR$, NS1
        AddNewPlot NS1, PV(DI.SP1).SYM, NP

END SUB
