'
'  Graphics Library  19 May 1989
'
'  Copyright (c) 1990-1993 Creative Consulting for Research & Education
'  Last Revision: 6 Nov 1993
'
'  $INCLUDE: 'c:\xyplot\devqb\include\graphlib.inc'
'  $INCLUDE: 'c:\qb45\include\qb.bi'
'
' ---------------------------------------------------------------
'
DEFINT I-N
'
' ---------------------------------------------------------------
'
FUNCTION TRIM$ (A$)
'
'  Trim leading and trailing blanks and tabs
'
	IF LEN(A$) <> 0 THEN
	  DO
	    L = LEN(A$)
	    B = ASC(MID$(A$, 1, 1))

	    IF B = 32 OR B = 9 THEN
	      A$ = MID$(A$, 2, L - 1)
	    ELSE
	      EXIT DO
	    END IF
	  LOOP WHILE LEN(A$) <> 0

	  IF LEN(A$) <> 0 THEN
	    DO
	      L = LEN(A$)
	      B = ASC(MID$(A$, L, 1))

	      IF B = 32 OR B = 9 THEN
		A$ = MID$(A$, 1, L - 1)
	      ELSE
		 EXIT DO
	      END IF
	    LOOP WHILE LEN(A$) <> 0
	   END IF
	END IF

	TRIM$ = A$

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION Delimiter% (Sym AS STRING)
'
'  Return True if Sym is a delimiter character (space, comma, or tab).
'
        Delimiter% = ((Sym = CHR$(32)) OR (Sym = CHR$(44)) OR (Sym = CHR$(9)))

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION AlphaNumeric% (J)
'
'  Return TRUE (-1) if J is the ASCII value of an alphanumeric character,
'    FALSE (0), otherwise.
'
        K = (J < 48) OR ((J > 57) AND (J < 65))
        K = K OR ((J > 90) AND (J < 97)) OR (J > 122)
        AlphaNumeric% = NOT K

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION BlankLine% (A$)
'
'  Determine if A$ is a blank line or not
'
	A$ = TRIM$(A$)
	IF LEN(A$) = 0 THEN
	  BlankLine = YES
	ELSE
	  BlankLine = NO
	END IF

END FUNCTION
'
' ---------------------------------------------------------------
'
SUB ClearTopLine
'
' Clear first row and position cursor at location 1, 1
'
	LOCATE 1, 1
	PRINT STRING$(80, 32);
	LOCATE 1, 1

END SUB
'
' ---------------------------------------------------------------
'
SUB BOX (IX1, IY1, IX2, IY2, IC)
'
'  Draw a box with opposite corners at (IX1, IY1) and (IX2, IY2)
'    with color IC
'
        LINE (IX1, IY1)-(IX2, IY2), IC, B
END SUB
'
' ---------------------------------------------------------------
'
SUB ConvertToRC (J1, J2)
'
'  Convert text mouse cursor coordinates to row and column numbers.
'
'  J1 -- horizontal coordinate converted to column number
'  J2 -- vertical coordinate converted to row number
'
        J1 = INT(J1 / 8) + 1
        J2 = INT(J2 / 8) + 1

END SUB
'
' ---------------------------------------------------------------
'
SUB DrawCross (IX, IY, J, IC)
'
'  Draw cross to mark position
'
	LINE (IX - J, IY - J)-(IX + J, IY + J), IC
	LINE (IX - J, IY + J)-(IX + J, IY - J), IC

END SUB
'
' ---------------------------------------------------------------
'
SUB ExpansionBox (IX1, IY1, IX2, IY2, IXMAX, IYMAX, IMODE)
'
'  Use mouse or keypad to draw an expansion box and return
'    the diagonal corners.
'
'    Input Variables:
'
'       IX1, IY1      -- one corner of box
'       IXMAX, IYMAX  -- maximum screen coordinates in x and y
'       IMODE         -- set = -1 for mouse; 0 for keypad
'
'    Output Variables:
'
'       IX2, IY2 -- opposite corner of box
'

        DIM ST1(1000) AS INTEGER
        DIM ST2(1000) AS INTEGER
        DIM ST3(1000) AS INTEGER
        DIM ST4(1000) AS INTEGER

        IX2 = IX1
        IY2 = IY1
        IX3 = IX2
        IY3 = IY2

	DO

' Store region under which box is to be drawn.

          GET (IX1, IY1)-(IX1, IY2), ST1
          GET (IX1, IY2)-(IX2, IY2), ST2
          GET (IX2, IY2)-(IX2, IY1), ST3
          GET (IX1, IY1)-(IX2, IY1), ST4

' Draw box

          LINE (IX1, IY1)-(IX2, IY2), 7, B

' Wait for mouse coordinates to change or button to be released.

	  DO
            IF IMODE THEN
              GetMousePosition IX3, IY3, BS%
            ELSE
              BS% = 1
              KeyPress$ = INKEY$
              IF KeyPress$ <> "" THEN
                IF LEN(KeyPress$) = 2 THEN
                  JSK = ASC(MID$(KeyPress$, 2, 1))
                  SELECT CASE JSK
                    CASE 72
                      IY3 = IY2 - 9
                    CASE 75
                      IX3 = IX2 - 12
                    CASE 77
                      IX3 = IX2 + 12
                    CASE 80
                      IY3 = IY2 + 9
                    CASE ELSE
                      '
                  END SELECT
                  IF IX3 >= IXMAX THEN IX3 = IXMAX - 1
                  IF IX3 < 1 THEN IX3 = 1
                  IF IY3 >= IYMAX THEN IY3 = IYMAX - 1
                  IF IY3 < 1 THEN IY3 = 1
                ELSE
                  IF KeyPress$ = CHR$(13) OR KeyPress$ = CHR$(27) THEN
                    BS% = 0
                  END IF
                END IF
              END IF
            END IF
          LOOP WHILE ((IX3 = IX2) AND (IY3 = IY2) AND ((BS% AND 1) = 1))


' Restore background region

          IF IY2 < IY1 THEN
            PUT (IX1, IY2), ST1, PSET
            PUT (IX2, IY2), ST3, PSET
	  ELSE
            PUT (IX1, IY1), ST1, PSET
            PUT (IX2, IY1), ST3, PSET
	  END IF

          IF IX2 < IX1 THEN
            PUT (IX2, IY2), ST2, PSET
            PUT (IX2, IY1), ST4, PSET
	  ELSE
            PUT (IX1, IY2), ST2, PSET
            PUT (IX1, IY1), ST4, PSET
	  END IF

' Update opposite corner

          IF (IX3 < IXMAX) AND (IY3 < IYMAX) THEN
             IX2 = IX3
             IY2 = IY3
	  END IF

' Loop while button is still being held down.

	LOOP WHILE ((BS% AND 1) = 1)

END SUB
'
' ---------------------------------------------------------------
'
SUB GetWord (J1, J2, Word$)
'
'  Return word falling on row J1, column J2.
'
	Word$ = ""
        J = SCREEN(J1, J2)

        IF (NOT WordCharacter(J)) THEN EXIT SUB

        Word$ = CHR$(J)
'    
'  Find left portion of word
'
        K = J2

	DO
           K = K - 1
           IF K = 0 THEN EXIT DO
           J = SCREEN(J1, K)
           IF (NOT WordCharacter(J)) THEN EXIT DO
           Word$ = CHR$(J) + Word$
	LOOP
'
'  Find the right portion of word
'
        K = J2

	DO
           K = K + 1
           IF K = 81 THEN EXIT DO
           J = SCREEN(J1, K)
           IF (NOT WordCharacter(J)) THEN EXIT DO
           Word$ = Word$ + CHR$(J)
	LOOP

END SUB
'
' ---------------------------------------------------------------
'
SUB LineClip (IX1, IY1, IX2, IY2, I1, I2, J1, J2, JFL)
'
'  Purpose: Clip the line defined by the two points (IX1, IY1) and
'           (IX2, IY2).
'  Syntax: LineClip IX1, IY1, IX2, IY2, I1, I2, J1, J2, JFL
'  Input Parameters:
'       IX1, IY1        -- coordinates of first point
'       IX2, IY2        -- coordinates of second point
'       I1, I2          -- x boundaries; I1 is minimum, I2 is maximum
'       J1, J2          -- y boundaries; J1 is minimum, J2 is maximum
'                          (I1, J1) defines the lower left corner, and
'                          (I2, J2) defines the upper right corner of
'                          the clipping window.
'  Output Parameters:
'       IX1, IY1        -- clipped coordinates of first point
'       IX2, IY2        --    "            "      second point
'       JFL             -- integer flag has the following meaning:
'                            0 -- line connecting points is not visible
'                                 inside clipping window.
'                            1 -- connecting line visible, coordinates
'                                 have been clipped.
'  Author: K. Myneni
'  Date: 21 Jan 90; Revised: 29 Aug 92
'

	K1 = (IX1 < I1)
	K2 = (IX1 > I2)
	K3 = (IY1 < J1)
	K4 = (IY1 > J2)
	L1 = (IX2 < I1)
	L2 = (IX2 > I2)
	L3 = (IY2 < J1)
	L4 = (IY2 > J2)

	M = (K1 OR K2 OR K3 OR K4)
	N = (L1 OR L2 OR L3 OR L4)

	IF (NOT M) AND (NOT N) THEN   ' both points are inside of boundary
	  JFL = -1
	  EXIT SUB
	END IF

	MM = (K1 AND L1) OR (K2 AND L2)
	NN = (K3 AND L3) OR (K4 AND L4)

	IF MM OR NN THEN       ' both points are outside and no line visible
	  JFL = 0
	  EXIT SUB
	END IF

	JFL = -1

	IF IX1 = IX2 THEN
	   IF K3 THEN                  ' vertical line clipping
	      IY1 = J1
	   ELSE
	      IF K4 THEN IY1 = J2
	   END IF
	   IF L3 THEN
	      IY2 = J1
	   ELSE
	      IF L4 THEN IY2 = J2
	   END IF

	   EXIT SUB

	ELSE
	   IF IY1 = IY2 THEN
	      IF K1 THEN               ' horizontal line clipping
		 IX1 = I1
	      ELSE
		 IF K2 THEN IX1 = I2
	      END IF
	      IF L1 THEN
		 IX2 = I1
	      ELSE
		 IF L2 THEN IX2 = I2
	      END IF

	      EXIT SUB
	  
	   ELSE
	      S = (IY2 - IY1) / (IX2 - IX1)      ' compute slope
	   END IF
	END IF

        IX3 = IX1
        IY3 = IY1
        IX4 = IX2
        IY4 = IY2

'  Bring first point to boundary

	IF K1 OR K2 THEN
	  IF K1 THEN
            IX3 = I1
	  ELSE
            IX3 = I2
	  END IF
          IY3 = IY2 - S * (IX2 - IX3)
          K1 = 0
          K2 = 0
          K3 = (IY3 < J1)
          K4 = (IY3 > J2)
	END IF
	IF K3 OR K4 THEN
	  IF K3 THEN
            IY3 = J1
	  ELSE
            IY3 = J2
	  END IF
          IX3 = (IY3 - IY2) / S + IX2
          K1 = (IX3 < I1)
          K2 = (IX3 > I2)
          K3 = 0
          K4 = 0
	END IF

        IF K1 OR K2 OR K3 OR K4 THEN            ' no visible line
          JFL = 0
          EXIT SUB
         END IF

'  Bring second point to boundary

	IF L1 OR L2 THEN
	  IF L1 THEN
            IX4 = I1
	  ELSE
            IX4 = I2
	  END IF
          IY4 = IY2 - S * (IX2 - IX4)
          L1 = 0
          L2 = 0
          L3 = (IY4 < J1)
          L4 = (IY4 > J2)
	END IF
	IF L3 OR L4 THEN
	  IF L3 THEN
            IY4 = J1
	  ELSE
            IY4 = J2
	  END IF
          IX4 = (IY4 - IY2) / S + IX2
          L1 = (IX4 < I1)
          L2 = (IX4 > I2)
          L3 = 0
          L4 = 0
	END IF

        IF L1 OR L2 OR L3 OR L4 THEN            ' no visible line
          JFL = 0
          EXIT SUB
         END IF

        IX1 = IX3
        IY1 = IY3
        IX2 = IX4
        IY2 = IY4

END SUB
'
' ---------------------------------------------------------------
'
SUB PixelPosition (IR, IC, NCPIX, NRPIX, IX, IY)
'
'  Convert row and column number IR, IC to pixel coordinate IX, IY
'
        IX = (IC - 1) * NCPIX
        IY = (IR - 1) * NRPIX

END SUB
'
' ---------------------------------------------------------------
'
SUB SetTextScreen
'
'  Set text screen
'
	SCREEN 0
	WIDTH 80

END SUB
'
' ---------------------------------------------------------------
'
SUB ShowButton (BU AS ActionButton)
'
' Display an action button on the text screen
'
        IF NOT TextScreen THEN EXIT SUB
        IR1 = BU.TopRow
        IR2 = IR1 + BU.NROWS
        IC1 = BU.LeftCol
        IC2 = IC1 + BU.NCOLS

        IF BU.Active THEN
          TextBox IR1, IC1, IR2, IC2, BU.Foreground, BU.Background
        ELSE
          TextBox IR1, IC1, IR2, IC2, 0, 0
          COLOR 7, 0
          EXIT SUB
        END IF

        MR = (IR1 + IR2) / 2
        MC = (IC1 + IC2) / 2
        A$ = BU.ButtonText
        A$ = LTRIM$(RTRIM$(A$))
        L = LEN(A$)
        MC = MC - L / 2
        IF MC < 1 THEN MC = 1
        LOCATE MR, MC
        PRINT A$;

END SUB
'
' ---------------------------------------------------------------
'
SUB TextBox (IR1, IC1, IR2, IC2, ICL, IBCL)
'
'  **************************************************************
'  **                                                          **
'  **  Module: TextBox                                         **
'  **  Purpose: Draw a box on a text screen using graphics     **
'  **           characters.                                    **
'  **  Syntax: TextBox IR1, IC1, IR2, IC2, ICL, IBCL           **
'  **  Input Parameters:                                       **
'  **           IR1, IC1 -- row and column position of upper   **
'  **                       left corner.                       **
'  **           IR2, IC2 -- row and column position of lower   **
'  **                       right corner.                      **
'  **           ICL      -- color of box.                      **
'  **           IBCL     -- background color inside of box.    **
'  **                                                          **
'  **  Output Parameters: None                                 **
'  **  Author: K. Myneni                                       **
'  **  Date: 27 Dec 89                                         **
'  **                                                          **
'  **************************************************************
'
        IF NOT TextScreen THEN EXIT SUB

        IF IR2 < IR1 THEN SWAP IR1, IR2
	IF IC2 < IC1 THEN SWAP IC1, IC2
	COLOR ICL, IBCL
	LOCATE IR1, IC1
	PRINT CHR$(201);
	LOCATE IR1, IC2
	PRINT CHR$(187);
	LOCATE IR2, IC1
	PRINT CHR$(200);
	LOCATE IR2, IC2
	PRINT CHR$(188);
	LOCATE IR1, IC1 + 1
	PRINT STRING$(IC2 - IC1 - 1, CHR$(205));
	LOCATE IR2, IC1 + 1
	PRINT STRING$(IC2 - IC1 - 1, CHR$(205));
        FOR J = IR1 + 1 TO IR2 - 1
           LOCATE J, IC1
	   PRINT CHR$(186);
           LOCATE J, IC2
	   PRINT CHR$(186);
        NEXT J

' Fill box with spaces so that background color appears.

        FOR J = IR1 + 1 TO IR2 - 1
           LOCATE J, IC1 + 1
	   PRINT SPACE$(IC2 - IC1 - 1);
        NEXT J

END SUB
'
' ---------------------------------------------------------------
'
FUNCTION TextScreen%
'
'  Return true (-1) if video display is in text mode, false (0) if in
'  graphics mode.
'
	IMODE% = VideoMode
	IF ((IMODE% < 4) OR (IMODE% = 7)) THEN
	  TextScreen = -1
	ELSE
	  TextScreen = 0
	END IF
'
END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION VideoMode%
'
'  Return current video mode
'
	DIM InRegs AS RegTypeX, OutRegs AS RegTypeX

	InRegs.ax = &HF00
	CALL INTERRUPTX(&H10, InRegs, OutRegs)
	VideoMode = OutRegs.ax AND 255

END FUNCTION
'
' ---------------------------------------------------------------
'
SUB KeyWait (KeyPress$)
'
'  +++++++++       Wait for key input      +++++++++
'
	DO
           KeyPress$ = INKEY$
        LOOP WHILE KeyPress$ = ""

END SUB
'
' ---------------------------------------------------------------
'
SUB PROMPT
'
	PRINT "<< Press any key to continue >>";
        KeyWait A$

END SUB
'
' ---------------------------------------------------------------
'
FUNCTION WordCharacter% (J%)
'
'  Return true if character with ASCII value J% is an alphanumeric
'    character, or a specially recognized character (see below string).
'
        SpecialChars$ = "!@#$%^&*()-_+={}[]\:;'<>.?/"

	IF AlphaNumeric%(J%) THEN
	  WordCharacter% = -1
	ELSE
	  IF INSTR(SpecialChars$, CHR$(J%)) THEN
	    WordCharacter% = -1
	  ELSE
	    WordCharacter% = 0
	  END IF
	END IF

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION FormFSF$ (X1, X2)
'
'  Determine floating point save format for range X1, X2.
'
        A1 = ABS(X1)
        A2 = ABS(X2)
        IF A2 > A1 THEN VMAX = A2 ELSE VMAX = A1

        SELECT CASE VMAX
          CASE IS < 1!
            FM$ = "#.#######"
	  CASE 1! TO 10!
            FM$ = "###.#####"
	  CASE 10! TO 100!
            FM$ = "####.####"
	  CASE 100! TO 1000!
            FM$ = "#####.###"
	  CASE 1000! TO 10000!
            FM$ = "######.##"
	  CASE 10000! TO 100000!
            FM$ = "#######.#"
          CASE IS > 100000!
            FM$ = "########."
	END SELECT

        FormFSF$ = FM$

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION FormISF$ (X1, X2)
'
'  Determine integer save format for range X1, X2.
'
        A1 = ABS(X1)
        A2 = ABS(X2)
        IF A2 > A1 THEN VMAX = A2 ELSE VMAX = A1

        SELECT CASE CLNG(VMAX)
          CASE 0&
            FM$ = "##"
          CASE 1& TO 10&
            FM$ = "###"
          CASE 10& TO 100&
            FM$ = "####"
          CASE 100& TO 1000&
            FM$ = "#####"
          CASE 1000& TO 10000&
            FM$ = "######"
          CASE 10000& TO 100000&
            FM$ = "#######"
          CASE 100000& TO 1000000&
            FM$ = "########"
          CASE IS > 1000000&
            FM$ = "#########"
	END SELECT

        FormISF$ = FM$

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION FormD$ (X1, X2)
'
'  Determine display format for range of numbers between x1 and x2.
'
        DIFF = ABS(X2 - X1)
        A1 = ABS(X1)
        A2 = ABS(X2)
        IF A2 > A1 THEN VMAX = A2 ELSE VMAX = A1

	SELECT CASE DIFF
	  CASE IS < .01, IS > 100000!
	    FM$ = "##.####^^^^"
	  CASE .01 TO .1
	    FM$ = "#.#####"
	  CASE .1 TO 1!
	    FM$ = "##.####"
	  CASE 1! TO 10!
	    FM$ = "###.###"
	  CASE 10! TO 100!
	    FM$ = "####.##"
	  CASE 100! TO 1000!
	    FM$ = "#####.#"
	  CASE 1000! TO 10000!
	    FM$ = "######"
	  CASE 10000! TO 100000!
	    FM$ = "#######"
	END SELECT

        A3 = VMAX / DIFF
        IF A3 >= 10 THEN
          I = INT(LOG(A3) / LOG(10)) - 1
          IF X1 < 0! OR X2 < 0! THEN I = I + 1
          A$ = STRING$(I, 35)
	  FM$ = A$ + FM$
	END IF
        FormD$ = FM$

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION FormL$ (X1, X2, AXIS$)
'
'  Determine label output format for range of numbers between x1 and x2.
'
        IF AXIS$ = "X" THEN
          FM$ = FormD$(X1, X2)
        ELSE
          A1 = ABS(X1)
          A2 = ABS(X2)
          IF A2 > A1 THEN VMAX = A2 ELSE VMAX = A1
          SELECT CASE VMAX
            CASE IS < .001, IS > 10000!
              FM$ = "##^^^^"
            CASE .001 TO 1!
              FM$ = "##.###"
            CASE 1! TO 10!
              FM$ = "###.##"
            CASE 10! TO 100!
              FM$ = "####.#"
            CASE 100! TO 1000!
              FM$ = "#####."
            CASE 1000! TO 10000!
              FM$ = "######"
          END SELECT
        END IF

        FormL$ = FM$

END FUNCTION
'
' ---------------------------------------------------------------
'                  MOUSE SUBROUTINES AND FUNCTIONS
' ---------------------------------------------------------------
'
SUB CrosshairCursor
'
'   Set mouse cursor pattern to rectangular cross-hairs.
'
'
'
'       screen mask
'
        ICURSOR(1, 1) = &HFC7F
        ICURSOR(2, 1) = &HFC7F
        ICURSOR(3, 1) = &HFC7F
        ICURSOR(4, 1) = &HFC7F
        ICURSOR(5, 1) = &HFC7F
        ICURSOR(6, 1) = 0
        ICURSOR(7, 1) = 0
        ICURSOR(8, 1) = 0
        ICURSOR(9, 1) = &HFC7F
        ICURSOR(10, 1) = &HFC7F
        ICURSOR(11, 1) = &HFC7F
        ICURSOR(12, 1) = &HFC7F
        ICURSOR(13, 1) = &HFC7F
        ICURSOR(14, 1) = &HFFFF
        ICURSOR(15, 1) = &HFFFF
        ICURSOR(16, 1) = &HFFFF
'
'       cursor mask
'
        ICURSOR(1, 2) = 0
        ICURSOR(2, 2) = 256
        ICURSOR(3, 2) = 256
        ICURSOR(4, 2) = 256
        ICURSOR(5, 2) = 256
        ICURSOR(6, 2) = 256
        ICURSOR(7, 2) = &H7FFC
        ICURSOR(8, 2) = 256
        ICURSOR(9, 2) = 256
        ICURSOR(10, 2) = 256
        ICURSOR(11, 2) = 256
        ICURSOR(12, 2) = 256
        ICURSOR(13, 2) = 0
        ICURSOR(14, 2) = 0
        ICURSOR(15, 2) = 0
        ICURSOR(16, 2) = 0

        SetMouseShape 7, 6
END SUB
'
' ---------------------------------------------------------------
'
SUB HourglassCursor
'
'   Set mouse cursor pattern to hourglass.
'
'
'
'       screen mask
'
        ICURSOR(1, 1) = &H0000
        ICURSOR(2, 1) = &H0000
        ICURSOR(3, 1) = &H0000
        ICURSOR(4, 1) = &H0000
        ICURSOR(5, 1) = &H8001
        ICURSOR(6, 1) = &HC003
        ICURSOR(7, 1) = &HE007
        ICURSOR(8, 1) = &HF00F
        ICURSOR(9, 1) = &HE007
        ICURSOR(10, 1) = &HC003
        ICURSOR(11, 1) = &H8001
        ICURSOR(12, 1) = &H0000
        ICURSOR(13, 1) = &H0000
        ICURSOR(14, 1) = &H0000
        ICURSOR(15, 1) = &H0000
        ICURSOR(16, 1) = &HFFFF
'
'       cursor mask
'
        ICURSOR(1, 2) = &H0000
        ICURSOR(2, 2) = &H7FFE
        ICURSOR(3, 2) = &H6006
        ICURSOR(4, 2) = &H300C
        ICURSOR(5, 2) = &H1818
        ICURSOR(6, 2) = &H0C30
        ICURSOR(7, 2) = &H0660
        ICURSOR(8, 2) = &H03C0
        ICURSOR(9, 2) = &H0660
        ICURSOR(10, 2) = &H0C30
        ICURSOR(11, 2) = &H1998
        ICURSOR(12, 2) = &H33CC
        ICURSOR(13, 2) = &H67E6
        ICURSOR(14, 2) = &H7FFE
        ICURSOR(15, 2) = &H0000
        ICURSOR(16, 2) = &H0000

        SetMouseShape 7, 7
END SUB
'
' ---------------------------------------------------------------
'
SUB ArrowCursor
'
'  Set mouse cursor pattern to standard arrow shape.
'
'
'
'       screen mask
'
        ICURSOR(1, 1) = &H3FFF
        ICURSOR(2, 1) = &H1FFF
        ICURSOR(3, 1) = &HFFF
        ICURSOR(4, 1) = &H7FF
        ICURSOR(5, 1) = &H3FF
        ICURSOR(6, 1) = &H1FF
        ICURSOR(7, 1) = &HFF
        ICURSOR(8, 1) = &H7F
        ICURSOR(9, 1) = &H3F
        ICURSOR(10, 1) = &H1F
        ICURSOR(11, 1) = &H1FF
        ICURSOR(12, 1) = &H10FF
        ICURSOR(13, 1) = &H30FF
        ICURSOR(14, 1) = &HF87F
        ICURSOR(15, 1) = &HF87F
        ICURSOR(16, 1) = &HFC3F
'
'       cursor mask
'
        ICURSOR(1, 2) = 0
        ICURSOR(2, 2) = &H4000
        ICURSOR(3, 2) = &H6000
        ICURSOR(4, 2) = &H7000
        ICURSOR(5, 2) = &H7800
        ICURSOR(6, 2) = &H7C00
        ICURSOR(7, 2) = &H7E00
        ICURSOR(8, 2) = &H7F00
        ICURSOR(9, 2) = &H7F80
        ICURSOR(10, 2) = &H78C0
        ICURSOR(11, 2) = &H7C00
        ICURSOR(12, 2) = &H4600
        ICURSOR(13, 2) = &H600
        ICURSOR(14, 2) = &H300
        ICURSOR(15, 2) = &H300
        ICURSOR(16, 2) = &H180

        SetMouseShape -1, -1

END SUB
'
' ---------------------------------------------------------------
'
SUB SetMouseShape (IX, IY)
'
'  Set the mouse shape according to that defined in ICURSOR,
'    and set the hotspot to IX, IY : range -16 to 16.
'
	DIM InRegs AS RegTypeX, OutRegs AS RegTypeX

        InRegs.ax = &H09
        InRegs.bx = IX
        InRegs.cx = IY
        InRegs.es = VARSEG(ICURSOR(1, 1))
        InRegs.dx = VARPTR(ICURSOR(1, 1))
        CALL INTERRUPTX(&H33, InRegs, OutRegs)
END SUB
'
' ---------------------------------------------------------------
'
SUB ButtonRelease
'
'  wait for mouse button(s) to be released to avoid repetition
'
        M1 = 3
        M2 = 1
        DO WHILE (M2 <> 0)
          CALL MOUSE(M1, M2, M3, M4)
	LOOP

END SUB
'
' ---------------------------------------------------------------
'
SUB GetMousePosition (IX, IY, BS%)
'
'  Read mouse coordinates and return in IX, IY.
'  Return button status in BS:
'       bit 0 is left button
'       bit 1 is right button
'               bits set to 1 if button is down; 0 if up.
'
        M1 = 3
        CALL MOUSE(M1, M2, M3, M4)
        IX = M3
        IY = M4
        BS% = M2

END SUB
'
' ---------------------------------------------------------------
'
SUB GetButtonPress (BN%, IX, IY, BS%)
'
'  Get button press information on button BN% (0 for left; 1 for right)
'    IX, IY are coordinates at last press.
'    BS% is number of button presses since last call to this func.
'
        M1 = 5
        M2 = BN%
        CALL MOUSE (M1, M2, M3, M4)
        BS% = M2
        IX = M3
        IY = M4

END SUB
'
' ---------------------------------------------------------------
'
SUB HideMouse
'
        M1 = 2
        CALL MOUSE(M1, M2, M3, M4)

END SUB
'
' ---------------------------------------------------------------
'
SUB MouseLimits (IX1, IY1, IX2, IY2)
'
        M1 = 7
        CALL MOUSE(M1, M2, IX1, IX2)
        M1 = 8
        CALL MOUSE(M1, M2, IY1, IY2)

END SUB
'
' ---------------------------------------------------------------
'
SUB MouseReset (ISTAT)
'
        M1 = 0
        CALL MOUSE(M1, M2, M3, M4)
        ISTAT = M1

END SUB
'
' ---------------------------------------------------------------
'
SUB MouseWait (IX, IY, IB)
'
'
        M1 = 1
        CALL MOUSE(M1, M2, M3, M4)
        M2 = 99
        WHILE (M2 <> 1)
           M1 = 3
           CALL MOUSE(M1, M2, M3, M4)
	WEND
        IB = M2
        IX = M3
        IY = M4
        M1 = 2
        CALL MOUSE(M1, M2, M3, M4)
	ButtonRelease

END SUB
'
' ---------------------------------------------------------------
'
SUB PutMouse (IX, IY)
'
        M1 = 4
        CALL MOUSE(M1, M2, IX, IY)

END SUB
'
' ---------------------------------------------------------------
'
SUB SetTextCursor
'   
' Set Mouse Text Cursor
'
        M1 = 10
        M2 = 0
        M3 = &HFFFF
        M4 = &H7700

        CALL MOUSE(M1, M2, M3, M4)

END SUB
'
' ---------------------------------------------------------------
'
SUB ShowMouse
'
        M1 = 1
        CALL MOUSE(M1, M2, M3, M4)

END SUB
