'
' ---------------------------------------------------------------
'
SUB LFIT (X(), Y(), A(), LISTA(), Alpha() AS DOUBLE, FType%, EType%, Sigma, _
          Chisqr, J1, J2, NTERMS, NFIT, IERR)
'
'  Modified version of subroutine LFIT in Numerical Recipes.
'
        DIM Beta(10) AS DOUBLE
        DIM AFUNC(10) AS DOUBLE
        DIM SIG2 AS DOUBLE
        DIM WT AS DOUBLE
        DIM SUM AS DOUBLE
        DIM PROD AS DOUBLE

        IERR = 0
        Sigma2 = Sigma * Sigma
        Norder = NFIT

        KK = NFIT + 1
        FOR J = 1 TO NTERMS
          IHIT = 0
          FOR K = 1 TO NFIT
            IF (LISTA(K) = J) THEN IHIT = IHIT + 1
          NEXT K
          IF IHIT = 0 THEN
            LISTA(KK) = J
            KK = KK + 1
          ELSEIF IHIT > 1 THEN
            IERR = 1
            EXIT SUB
          ELSE
            '
          END IF
        NEXT J

        IF KK <> (MA + 1) THEN
          IERR = 1
          EXIT SUB
        END IF

'  Initialize symmetric matrix, alpha (also known as curvature matrix).

        FOR J = 1 TO NFIT
          FOR K = 1 TO NFIT
            Alpha(J, K) = 0#
          NEXT K
          BETA(J) = 0#
        NEXT J

'   Only need to fill in lower half since matrix is symmetric.

              SELECT CASE FType%
                CASE 0
                  AFUNC(1) = 1#
                  XM = CDBL(X(I))
                  FOR L = 2 TO NTERMS
                    AFUNC(L) = XM*AFUNC(L - 1)
                  NEXT L
                CASE ELSE
                  FOR L = 1 TO NTERMS
                    AFUNC(L) = 1#
                  NEXT L
              END SELECT

'       Set up alpha matrix for polynomial fit.

            FOR I = J1 TO J2
              AFUNC(1) = 1#

              YM = CDBL(Y(I))
              IF NFIT < NTERMS THEN
                FOR L = NFIT + 1 TO NTERMS
                  YM = YM - A(LISTA(L))*AFUNC(LISTA(L))
                NEXT L
              END IF

'  Determine weighting

              SELECT CASE EType%
                CASE 0
                  SIG2 = 1# / CDBL(YM)       ' statistical errors
                CASE 1
                  SIG2 = 1# / CDBL(Sigma2)   ' fixed error
                CASE ELSE
                  SIG2 = 1#                  ' estimate error
              END SELECT
              XJ = Y(IJ)
              XK = Y(IK)
              PROD = XJ * XK
              PROD = PROD / WEIGHT
              SUM = SUM + PROD
            NEXT I
            Alpha(J, K) = SUM
          NEXT K
        NEXT J


          FOR J = 1 TO NFIT
            WT = AFUNC(LISTA(J))*SIG2
            FOR K = 1 TO J
              Alpha(J, K) = Alpha(J, K) + WT*AFUNC(LISTA(K))
            NEXT K
            Beta(J) = Beta(J) + WT*CDBL(YM)
          NEXT J
        NEXT I

'  Fill in upper half of matrix.

        IF NFIT > 1 THEN
          FOR J = 2 TO NFIT
            FOR K = 1 TO J - 1
              Alpha(K, J) = Alpha(J, K)
            NEXT K
          NEXT J
        END IF

'
'  Invert symmetric matrix alpha
'
        MATINV Alpha(), Norder, DET

        IF DET = 0# THEN
          IERR = 2
          EXIT SUB
        END IF
'
'  Compute vector BETA
'
        FOR J = 1 TO Norder
          SUM = 0#
          FOR I = 1 TO NPTS
            IJ = JA(J) + I - 1
            XJ = Y(IJ)
            YI = Y(JS + I - 1)
            PROD = CDBL(YI*XJ)
            IF ErrType% = 0 THEN
              WT = CDBL(1!/YI)
            ELSEIF ErrType% = 1 THEN
              WT = CDBL(Sigma2)
            ELSE
              WT = 1#
            END IF
            PROD = PROD / WT
            SUM = SUM + PROD
          NEXT I
          BETA(J) = SUM
        NEXT J
'
'  Compute coefficient vector A()
'
        FOR J = 1 TO Norder
          SUM = 0#
          FOR K = 1 TO Norder
            SUM = SUM + ARR#(J, K)*BETA(K)
          NEXT K
          A(J) = CSNG(SUM)
        NEXT J

