'  Utilities for XYPLOT
'
'  These routines were parsed out of XYPLOT.BAS because the file
'    became too long for the QuickBasic 4.5 compiler.
'
'  Last Revision: 23 October 1993
'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\MATHLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\GRAPHLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\DOSLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\XYPLOT.INC'
'
'
' ---------------------------------------------------------------
'
DEFINT I-N
'
' ---------------------------------------------------------------
'            XYPLOT MATH ROUTINES
' ---------------------------------------------------------------
'
SUB Template (X(), Y())
'
'  Create template data set for function generation. Also adds
'    plot.

        DIM B(5) AS SINGLE

        IF TextScreen THEN
          TextBox 1, 1, 3, 80, 0, 7
          LOCATE 2, 5
        ELSE
          ClearTopLine
        END IF

        PRINT "Enter X1, X2, and DELTA X: ";
	GetInput NV$
	IF (ASC(NV$) = 27) THEN EXIT SUB

	B(1) = DI.XMIN: B(2) = DI.XMAX: B(3) = (DI.XMAX - DI.XMIN) / 100!
        NumberParse B(), NN%, NV$
	X1 = B(1): X2 = B(2): DX = B(3)
	IF X2 < X1 THEN SWAP X1, X2
        IF X2 = X1 THEN
          X1 = X1 - 1!
          X2 = X2 + 1!
        END IF
        IF DX = 0! THEN DX = (X2 - X1) / 100!
        IF DX < 0! THEN DX = ABS(DX)
	NPTS = INT((X2 - X1)/DX) + 1
        IF DB.NVALS + NPTS > MaxPoints THEN
          ErrorDisplay 238
          EXIT SUB
        END IF
        J1 = DS(DB.NSETS).JEi + 1
	J2 = J1 + NPTS - 1
	X(J1) = X1 : Y(J1) = X1
	FOR J = J1 + 1 TO J2
	  X(J) = X(J - 1) + DX
	  Y(J) = X(J)
	NEXT J

	HDR$ = "==XYPLOT==> TEMPLATE [" + STR$(X1) + "," + STR$(X2) + "]"
	HDR$ = HDR$ + CHR$(RET)

	AddNewSet X(), Y(), J1, J2, NO, "TEMPLATE", HDR$, NS1
	AddNewPlot NS1, "P", NP

END SUB
'
' ---------------------------------------------------------------
'
SUB Overlap (NS1, NS2, X1, X2)
'
'  Find region of overlap between two data sets.
       
        X1 = FMAX(DS(NS1).XMIN, DS(NS2).XMIN)
        X2 = FMIN(DS(NS1).XMAX, DS(NS2).XMAX)
	IF X2 < X1 THEN
          ErrorDisplay 222
	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB PlotArithmetic (X(), Y(), NS1, NS2, KeyPress$)
'
'  Plot arithmetic
'
        JF = DS(DB.NSETS).JEi

        IC1 = DS(NS1).CMPLX
        IC2 = DS(NS2).CMPLX
        IC = IC1 OR IC2

        Overlap NS1, NS2, X1, X2
	IF X2 < X1 THEN EXIT SUB

        IF IC THEN A$ = "COMPLEX " ELSE A$ = ""

        SELECT CASE KeyPress$
          CASE "*"
            A$ = A$ + "PRODUCT"
          CASE "/"
            A$ = A$ + "QUOTIENT"
          CASE "+"
            A$ = A$ + "SUM"
          CASE "-"
            A$ = A$ + "DIFFERENCE"
        END SELECT

        ClearTopLine
        PRINT "COMPUTING "; A$; " - One Moment Please. . ."

        JSr1 = DS(NS1).JSr
        JEr1 = DS(NS1).JEr
        JSi1 = DS(NS1).JSi
        JEi1 = DS(NS1).JEi
        JSr2 = DS(NS2).JSr
        JEr2 = DS(NS2).JEr
        JSi2 = DS(NS2).JSi
        JEi2 = DS(NS2).JEi

        IndexLimits X(), X1, X2, JSr1, JEr1, J1, J2, IERR
	 
        IF J2 < J1 THEN SWAP J1, J2
        NPTS = J2 - J1 + 1

        FOR J = 1 TO NPTS
          JX = J1 + J - 1
          XXr = X(JX)
          YYr = Y(JX)
          IF IC1 THEN
            Ji = JSi1 + JX - JSr1
            XXi = X(Ji)
            YYi = Y(Ji)
          ELSE
            XXi = 0! : YYi = 0!
          END IF

          J3 = JFIND(X(), XXr, JSr2, JEr2)

          XPr = X(J3)
          YPr = Y(J3)
          IF IC2 THEN
            Ji = JSi2 + J3 - JSr2
            XPi = X(Ji)
            YPi = Y(Ji)
          ELSE
            XPi = 0! : YPi = 0!
          END IF

          IF XPr <> XXr THEN
            IF J3 = JSr2 THEN
              J4 = J3 + 1
            ELSE
              IF J3 = JEr2 THEN
                J4 = J3 - 1
              ELSE
                IF ((XXr > X(J3 - 1)) AND (XXr < X(J3))) THEN
                  J4 = J3 - 1
                ELSE
                  J4 = J3 + 1
                END IF
              END IF
            END IF

            LinearInterp X(J4), Y(J4), X(J3), Y(J3), XXr, YPr, JFL
            IF IC2 THEN
              Ji = JSi2 + J4 - JSr2
              YPPi = Y(Ji)
              LinearInterp X(J4), YPPi, X(J3), YPi, XXr, Y2i, JFL
              YPi = Y2i
            ELSE
              YPi = 0!
            END IF
          END IF

          Jr = JF + J
          Ji = JF + NPTS + J
          X(Jr) = XXr
          IF IC THEN X(Ji) = XXi

          SELECT CASE KeyPress$
            CASE "+"
              Y(Jr) = YYr + YPr
              IF IC THEN Y(Ji) = YYi + YPi
            CASE "-"
              Y(Jr) = YYr - YPr
              IF IC THEN Y(Ji) = YYi - YPi
            CASE "*"
              IF IC THEN
                Y(Jr) = YYr*YPr - YYi*YPi
                Y(Ji) = YYi*YPr + YYr*YPi
              ELSE
                Y(Jr) = YYr * YPr
              END IF
            CASE "/"
              YP2 = YPr*YPr + YPi*YPi
              IF YP2 = 0! THEN
                ErrorDisplay 11
                EXIT SUB
              ELSE
                IF IC THEN
                  Y(Jr) = (YYr*YPr + YYi*YPi) / YP2
                  Y(Ji) = (YYi*YPr - YYr*YPi) / YP2
                ELSE
                  Y(Jr) = YYr / YPr
                END IF
              END IF
          END SELECT
        NEXT J

        J1 = JF + 1
        IF IC THEN
          J2 = J1 + 2 * NPTS - 1
        ELSE
          J2 = J1 + NPTS - 1
        END IF

        F1$ = RTRIM$(DS(NS2).FNAME)
        IF F1$ = "XYPLOT" THEN F1$ = "SET" + STR$(NS2)
        F2$ = RTRIM$(DS(NS1).FNAME)
        IF F2$ = "XYPLOT" THEN F2$ = "SET" + STR$(NS1)
	HDR$ = "==XYPLOT==> " + A$ + " OF " + F1$ + " AND " + F2$
	HDR$ = HDR$ + CHR$(RET)

' Update data set, data base, and plot information

        AddNewSet X(), Y(), J1, J2, IC, A$, HDR$, NS3
        AddNewPlot NS3, PV(DI.SP1).SYM, NP

END SUB
'
' ---------------------------------------------------------------
'
SUB XScale (X(), Y(), NS)

        JSr = DS(NS).JSr : JEr = DS(NS).JEr : IC = DS(NS).CMPLX

        ClearTopLine
        PRINT "RESCALE >> ";
        GetInput E$
        IF ASC(E$) = RET OR ASC(E$) = ESC THEN EXIT SUB
	ClearTopLine
	PRINT "RESCALING - One Moment Please. . . "

        ReScale X(), Y(), JSr, JEr, IC, E$, IERR

        IF IERR <> 0 THEN
          ErrorDisplay IERR
        ELSE

'  Update header

          DS(NS).HDR = "==XYPLOT==> RESCALE  " + E$ + CHR$(13) + _
                          DS(NS).HDR
          Extrema X(), Y(), NS
        END IF
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB XSmooth (Y(), NS)
'
'  Use three-point smoothing routine on current plot
'
	ClearTopLine
	PRINT "Smoothing ..."

        SMOOTH Y(), DS(NS).JSr, DS(NS).JEr
        IF DS(NS).CMPLX THEN
          SMOOTH Y(), DS(NS).JSi, DS(NS).JEi
        END IF

        DS(NS).HDR = "==XYPLOT==> SMOOTHED" + CHR$(13) + DS(NS).HDR
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB SetDataToZero (X(), Y(), NS)
'
'  Set data visible in plot window to zero.
'
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr

'  No portion visible? Then, leave.

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, J1, J2, IERR
        IF IERR <> 0 THEN EXIT SUB

        ClearTopLine
        PRINT "Zeroing data ... "

        FOR J = J1 TO J2
          Y(J) = 0!
        NEXT J

        IF DS(NS).CMPLX THEN
          J3 = J1 + DS(NS).NPTS
          J4 = J2 + DS(NS).NPTS
          FOR J = J3 TO J4
            Y(J) = 0!
          NEXT J
        END IF

        A$ = "==XYPLOT==> DATA ZEROED [" + STR$(DI.XMIN) + ", " + _
               STR$(DI.XMAX) + "]" + CHR$(RET)
        DS(NS).HDR = A$ + DS(NS).HDR

        Extrema X(), Y(), NS
        WKSaved = NO
'
END SUB
'
' ---------------------------------------------------------------
'
SUB XMAG (X(), Y(), NS)
'
'  Compute magnitude of complex or real data set. Add new REAL
'    data set to database.
'
        JSr = DS(NS).JSr : JSi = DS(NS).JSi
        NPTS = DS(NS).NPTS
        J1 = DS(DB.NSETS).JEi + 1
        J2 = J1 + NPTS - 1
        IF J2 > MaxPoints THEN
          ErrorDisplay 238
          EXIT SUB
        END IF

	ClearTopLine
        PRINT "COMPUTING MAGNITUDE - One Moment Please..."

        FOR J = 1 TO NPTS
          X(J1 + J - 1) = X(JSr + J - 1)
        NEXT J

        IF DS(NS).CMPLX THEN
          FOR J = 1 TO NPTS
            Y(J1 + J - 1) = SQR (Y(JSr + J - 1)^2 + Y(JSi + J - 1)^2)
          NEXT J
        ELSE
          FOR J = 1 TO NPTS
            Y(J1 + J - 1) = ABS(Y(JSr + J - 1))
          NEXT J
        END IF

        HDR$ = "==XYPLOT==> MAGNITUDE OF " + RTRIM$(DS(NS).FNAME) + CHR$(RET)

        AddNewSet X(), Y(), J1, J2, NO, "MAGNITUDE", HDR$, NS1
        AddNewPlot NS1, PV(DI.SP1).SYM, NP

END SUB
'
' ---------------------------------------------------------------
'
SUB XPHASE (X(), Y(), NS)
'
'  Compute phase of complex data set. Add new REAL
'    data set to database.
'
        IF NOT DS(NS).CMPLX THEN
          ErrorDisplay 239
          EXIT SUB
        END IF
        JSr = DS(NS).JSr : JSi = DS(NS).JSi
        NPTS = DS(NS).NPTS
        J1 = DS(DB.NSETS).JEi + 1
        J2 = J1 + NPTS - 1
        IF J2 > MaxPoints THEN
          ErrorDisplay 238
          EXIT SUB
        END IF

	ClearTopLine
        PRINT "COMPUTING PHASE - One Moment Please..."

        FOR J = 1 TO NPTS
          X(J1 + J - 1) = X(JSr + J - 1)
        NEXT J

        FOR J = 1 TO NPTS
          A = Y(JSr + J - 1)
          B = Y(JSi + J - 1)
          IF A = 0! THEN
            P = 0.15707963
            IF B < 0! THEN P = -P
          ELSE
            P = ATN (B / A)
          END IF
          Y(J1 + J - 1) = P
        NEXT J

        HDR$ = "==XYPLOT==> PHASE OF " + RTRIM$(DS(NS).FNAME) + CHR$(RET)

        AddNewSet X(), Y(), J1, J2, NO, "PHASE", HDR$, NS1
        AddNewPlot NS1, PV(DI.SP1).SYM, NP

END SUB
'
' ---------------------------------------------------------------
'
SUB XCONJ (X(), Y(), NS)
'
'  Take complex conjugate of a complex data set.
'

        IF NOT DS(NS).CMPLX THEN EXIT SUB
        JSi = DS(NS).JSi
        NPTS = DS(NS).NPTS

	ClearTopLine
        PRINT "COMPUTING COMPLEX CONJUGATE - One Moment Please..."

        FOR J = 1 TO NPTS
          Ji = JSi + J - 1
          Y(Ji) =  -Y(Ji)
        NEXT J

	HDR$ = RTRIM$(DS(NS).HDR)
        HDR$ = "==XYPLOT==> COMPLEX CONJUGATE " + CHR$(RET) + HDR$
        DS(NS).HDR = HDR$
        Extrema X(), Y(), NS
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB CmpToReal (X(), Y(), NS, JP)
'
'  Convert complex data set to real data set.
'      JP = -1 to use real part of set.
'      JP =  0 to use imaginary part.
'
        IF NOT DS(NS).CMPLX THEN
          ErrorDisplay 241
          EXIT SUB
        END IF

        ClearTopLine

        NPTS = DS(NS).NPTS
        IF JP THEN
          IF NS < DB.NSETS THEN
            J1 = DS(NS + 1).JSr
            ShiftValues X(), Y(), J1, -NPTS
          ELSE
            DB.NVALS = DB.NVALS - NPTS
          END IF
        ELSE
          J1 = DS(NS).JSi
          CopyXImag X(), DS(NS).JSr, NPTS
          ShiftValues X(), Y(), J1, -NPTS
          DS(NS).YMIN = DS(NS).iYMIN
          DS(NS).YMAX = DS(NS).iYMAX
        END IF


        DS(NS).CMPLX = NO
        DS(NS).iYMIN = 0!
        DS(NS).iYMAX = 0!
        DS(NS).JSi = DS(NS).JSr
        DS(NS).JEi = DS(NS).JEr

        A$ = "==XYPLOT==> "
        IF JP THEN
          A$ = A$ + "Real (Y)" + CHR$(RET)
        ELSE
          A$ = A$ + "Imag (Y)" + CHR$(RET)
        END IF

        DS(NS).HDR = A$ + DS(NS).HDR
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB RealToCmp (X(), Y(), NS)
'
'  Convert real data set to a complex data set.
'
        IF DS(NS).CMPLX THEN EXIT SUB

        NPTS = DS(NS).NPTS
        J1 = DS(NS + 1).JSr
        ClearTopLine

        ShiftValues X(), Y(), J1, NPTS

        DS(NS).CMPLX = YES
        JSi = DS(NS).JEr + 1
        DS(NS).JSi = JSi
        DS(NS).JEi = DS(NS).JSi + NPTS - 1

'  Fill imaginary part with 0s.

        FOR J = 1 TO NPTS
          JN = JSi + J - 1
          X(JN) = 0!
          Y(JN) = 0!
        NEXT J

        A$ = "==XYPLOT==> Cmpl(Y)" + CHR$(RET)
        DS(NS).HDR = A$ + DS(NS).HDR
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB SortDataSet (X(), Y(), NS)
'
' Perform ascending sort on data set NS
'
        IF DS(NS).CMPLX THEN
          CopyXImag X(), DS(NS).JSr, DS(NS).NPTS
        END IF

        Sort2 X(), Y(), DS(NS).JSr, DS(NS).JEr

        IF DS(NS).CMPLX THEN
          Sort2 X(), Y(), DS(NS).JSi, DS(NS).JEi
          ZeroXImag X(), DS(NS).JSr, DS(NS).NPTS
        END IF

        A$ = "==XYPLOT==> SORTED" + CHR$(RET)
        DS(NS).HDR = A$ + DS(NS).HDR
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB PolynomialFit (X(), Y(), NS)
'
	DIM B(5) AS SINGLE

        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        NPTS = DS(NS).NPTS
        IC = DS(NS).CMPLX
        JF = DS(DB.NSETS).JEi

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, J1, J2, IERR
        IF IERR <> 0 THEN
          ErrorDisplay 233
          EXIT SUB
        END IF

	JD = J2 - J1 + 1

	ClearTopLine
	PRINT "ENTER ORDER OF POLYNOMIAL TO BE FITTED: ";
	GetInput NV$

	IF (ASC(NV$) = 13) OR (ASC(NV$) = 27) THEN EXIT SUB

	NORDER = VAL(NV$)
	NTERMS = NORDER + 1
        IF (NTERMS < 1) OR (NTERMS > 10) THEN
          ErrorDisplay 229
          EXIT SUB
        END IF
        IF NTERMS > JD THEN
          ErrorDisplay 230
          EXIT SUB
        END IF

	ClearTopLine
	PRINT "ENTER X1, X2, AND DELTA X FOR COMPUTING FITTED DATA: ";
	GetInput NV$
	IF (ASC(NV$) = 27) THEN EXIT SUB

	B(1) = DI.XMIN: B(2) = DI.XMAX: B(3) = 0!
        NumberParse B(), NN, NV$
	X1 = B(1): X2 = B(2): DX = B(3)
	X3 = X(J1): X4 = X(J2)
	IF X4 < X3 THEN SWAP X3, X4

	ClearTopLine
	PRINT "FITTING - One Moment Please. . . ";

        IF IC THEN
          CopyXImag X(), JSr, NPTS
          J3 = J1 + NPTS
          J4 = J2 + NPTS
        END IF

        POLFIT X(), Y(), J1, J2, NTERMS, AlphaR (), Ar(), MI.ErrType,_
          MI.Sigma, MI.ChisqR

        IF IC THEN
          POLFIT X(), Y(), J3, J4, NTERMS, AlphaI (), Ai(), MI.ErrType,_
            MI.Sigma, MI.ChisqI
          ZeroXImag X(), JSr, NPTS
        END IF

	IF DX = 0! THEN
          NPT2 = J2 - J1 + 1
          FOR J = 1 TO NPT2
            JO = J1 + J - 1
            JNr = JF + J
            XJ = X(JO)
            X(JNr) = XJ
            Y(JNr) = Horner(Ar(), NTERMS, XJ)
            IF IC THEN
              JNi = JNr + NPT2
              X(JNi) = 0!
              Y(JNi) = Horner(Ai(), NTERMS, XJ)
            END IF
          NEXT J
	ELSE
          K = 1
          FOR XX = X1 TO X2 STEP DX
            X(JF + K) = XX
            Y(JF + K) = Horner(Ar(), NTERMS, XX)
            K = K + 1
          NEXT XX
          NPT2 = K - 1
          IF IC THEN
            FOR J = 1 TO NPT2
              Jr = JF + J
              Ji = Jr + NPT2
              X(Ji) = 0!
              Y(Ji) = Horner(Ai(), NTERMS, X(Jr))
            NEXT J
          END IF
        END IF

        HDR$ = "==XYPLOT==>   REDUCED CHI SQUARE IS "
        IF IC THEN
          HDR$ = HDR$ + "(" + STR$(MI.ChisqR) + ", " + STR$(MI.ChisqI) + ")"
        ELSE
          HDR$ = HDR$ + STR$(MI.ChisqR)
        END IF

	FOR K = NTERMS TO 1 STEP -1
           B$ = "==XYPLOT==>" + CHR$(9) + STR$(K - 1) + CHR$(9)
           IF IC THEN
             B$ = B$ + "(" + STR$(Ar(K)) + ", " + STR$(Ai(K)) + ")"
           ELSE
             B$ = B$ + STR$(Ar(K))
           END IF
	   HDR$ = B$ + CHR$(13) + HDR$
	NEXT K

	F$ = DS(NS).FNAME
	B$ = "==XYPLOT==>   DOMAIN OF FIT IS [" + STR$(X3) + ", " + STR$(X4)
	B$ = B$ + "]"
	HDR$ = B$ + CHR$(13) + HDR$
	B$ = "==XYPLOT==> POLYNOMIAL FIT OF ORDER " + STR$(NORDER) + " TO " + F$
	HDR$ = B$ + CHR$(13) + HDR$

        J1 = JF + 1
        IF IC THEN
          J2 = J1 + 2*NPT2 - 1
        ELSE
          J2 = J1 + NPT2 - 1
        END IF

        AddNewSet X(), Y(), J1, J2, IC, "POLYNOMIAL FIT", HDR$, NS1
        AddNewPlot NS1, "L", NP

END SUB
'
' ---------------------------------------------------------------
'
SUB XArea (X(), Y(), NS)
'
'  Find the area under the set of points in the current display window
'    for the currently selected plot.
'
'  Updated 17 April 90 to use new parabolic area finding routine.
'  Updated 26 Jan 92 to use Simpson's routine for equally spaced points.
'
        DIM AreaR AS DOUBLE
        DIM AreaI AS DOUBLE
        DIM ESP AS INTEGER

        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        NPTS = DS(NS).NPTS

' Find index limits

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, J1, J2, IERR
        IF IERR <> 0 THEN
          ErrorDisplay 233
          EXIT SUB
        END IF

        X1 = X(J1)
	X2 = X(J2)
	IF X2 < X1 THEN SWAP X1, X2
        ESP = EquallySpaced (X(), J1, J2, (X2 - X1)/1000.)

	ClearTopLine
	LOCATE 1, 1
	PRINT "COMPUTING AREA UNDER INTERVAL ("; X1; ", "; X2; ") ...";

        IF DS(NS).CMPLX THEN
          CopyXImag X(), JSr, NPTS
          J3 = J1 + NPTS
          J4 = J2 + NPTS
        END IF

' Compute area. Use Simpson's rule for equally spaced points; otherwise
'   use parabolic fit area finding.

        IF ESP THEN
          AreaR = Simpson (X(), Y(), J1, J2)
          IF DS(NS).CMPLX THEN
            AreaI = Simpson (X(), Y(), J3, J4)
          END IF
        ELSE
          AreaR = ParabArea (X(), Y(), J1, J2)
          IF DS(NS).CMPLX THEN
            AreaI = ParabArea (X(), Y(), J3, J4)
          END IF
        END IF

	ClearTopLine
        PRINT "AREA ("; X1; ", "; X2; ") = ";
        IF DS(NS).CMPLX THEN
          PRINT "(";CSNG(AreaR);", ";CSNG(AreaI);")"
          ZeroXImag X(), JSr, NPTS
        ELSE
          PRINT CSNG(AreaR)
        END IF


' Prompt to continue

        ButtonMenu 0, KeyPress$

END SUB
'
' ---------------------------------------------------------------
'
SUB XDeriv (X(), Y(), NS)
'
'  Driver routine for computing derivative of specified data set.
'  Complex data sets implemented.
'
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        JEi = DS(NS).JEi
        NVALS = JEi - JSr + 1
        IC = DS(NS).CMPLX
        JN = DS(DB.NSETS).JEi + 1

        IF (JN + NVALS - 1) > MaxPoints THEN
          ErrorDisplay 238
          EXIT SUB
        END IF

	ClearTopLine
	PRINT "COMPUTING DERIVATIVE - One Moment Please..."

        Derivative X(), Y(), JSr, JEi, JN, IC, IFLG

	IF IFLG THEN

' Derivative computation successful -- add new data set and plot.


          HDR$ = "==XYPLOT==> DERIVATIVE OF " + RTRIM$(DS(NS).FNAME) + CHR$(RET)
          J1 = JN
          J2 = JN + NVALS - 1

          AddNewSet X(), Y(), J1, J2, IC, "DERIVATIVE", HDR$, NS1
          AddNewPlot NS1, PV(DI.SP1).SYM, NP
        ELSE
          ErrorDisplay 232
	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB XFFT (X(), Y(), NS, KeyPress$)
'
'  Compute the Discrete Fourier Transform of complex data in
'    window domain.
'
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, J1, J2, IERR
        IF IERR <> 0 THEN
          ErrorDisplay 233
          EXIT SUB
        END IF

        NPTS = DS(NS).NPTS
        NPT1 = J2 - J1 + 1
        JF = DS(DB.NSETS).JEi

        NPT2 = Pad2 (NPT1)
        IF NPT2 = 0  OR ((JF + 2*NPT2 + 2) > MaxPoints) THEN
          ErrorDisplay 238
          EXIT SUB
        END IF

        TOL = ABS(X(J2) - X(J1))/1000.
        IF NOT EquallySpaced (X(), J1, J2, TOL) THEN
          ErrorDisplay 237
          EXIT SUB
        END IF

        J3 = JF + 1
        J4 = J3 + 2*NPT2 - 1
        J5 = J3 + NPT2 - 1

        IF KeyPress$ <> "<FFT0>" AND KeyPress$ <> "<FFT1>" THEN EXIT SUB
        IF KeyPress$ = "<FFT0>" THEN ISIGN = 1 ELSE ISIGN = -1

        ClearTopLine
        PRINT "COMPUTING ";
        A$ = "FFT"
        IF ISIGN = -1 THEN A$ = "INVERSE " + A$
        PRINT A$; " . . ."

'  Sort for correct complex data ordering

        FOR J = 1 TO NPT1
          JOr = J1 + J - 1
          JNr = J3 + 2*(J - 1)
          JNi = JNr + 1
          Y(JNr) = Y(JOr)
          IF DS(NS).CMPLX THEN
            JOi = JOr + NPTS
            Y(JNi) = Y(JOi)
          ELSE
            Y(JNi) = 0!
          END IF
        NEXT J
'
'  Pad up to a power of 2 number of points.
'
        IF NPT2 > NPT1 THEN
          FOR J = NPT1 + 1 TO NPT2
            JNr = J3 + 2*(J - 1)
            Y(JNr) = 0!
            Y(JNr + 1) = 0!
          NEXT J
        END IF

'
'  Sort for correct frequency ordering for inverse fft.
'
        IF ISIGN = -1 THEN
          FOR J = J3 TO J5
            SWAP Y(J + NPT2), Y(J)
          NEXT J
        END IF

'  Compute discrete fft

        Four1 Y(), J3, J4, ISIGN

'  Scale Y by DELTA.

        DELTA = ABS(X(JSr + 1) - X(JSr))

        FOR J = J3 TO J4
          Y(J) = Y(J)*DELTA
        NEXT J

'  Sort Y in order of increasing frequency after performing forward fft.

        IF ISIGN = 1 THEN
          FOR J = J3 TO J5
            SWAP Y(J), Y(J + NPT2)
          NEXT J
        END IF

'  Set up X array for new data set.

        DN = 1!/ (NPT2 * DELTA)
        F0 = -1!/(2!*DELTA)
        FOR J = J3 TO J5
          X(J) = F0
          F0 = F0 + DN
        NEXT J

'  Resort Y to separate real and imaginary parts.

        SortComplex1 X(), Y(), J3, J5

        HDR$ = "==XYPLOT==> " + A$ + " of " + RTRIM$(DS(NS).FNAME) + CHR$(RET)

        AddNewSet X(), Y(), J3, J4, YES, A$, HDR$, NS1
'
'  Replace old plot with FFT
'
        PV(DI.SP1).SET = NS1

END SUB
'
' ---------------------------------------------------------------
'
SUB DirectorySet (DIR$)
'
'    Set current directory
'
        IF SI.MFLAG THEN
          TextBox 7, 10, 11, 70, 7, 0
        ELSE
          TextBox 7, 10, 11, 70, 1, 3
        END IF
        LOCATE 9, 12
        PRINT "Enter the new drive and path >> ";
        GetInput DIR$
        SpecialKey DIR$
        IF DIR$ = CHR$(RET) OR DIR$ = CHR$(ESC) OR DIR$ = "CANCEL" THEN EXIT SUB

        DIR$ = UCASE$(DIR$)

        IF MID$(DIR$, 2, 1) = ":" THEN
          ID% = ASC(MID$(DIR$, 1, 1)) - 65
          SetDrive ID%
          DIR$ = MID$(DIR$, 3, LEN(DIR$) - 2)
        END IF

        SetDirectory DIR$
END SUB
'
' ---------------------------------------------------------------
'            XYPLOT DISPLAY ROUTINES
' ---------------------------------------------------------------
'
SUB DisplayHeader (HDR$, MODE$, IR1, IR2)
'
'  Display HDR$
'
        DIM IPAGE(30) AS INTEGER

        TextBox IR1, 1, IR2, 80, CI.HWF, CI.HWB

	IF HDR$ = "" THEN
	  LOCATE (IR1 + IR2) / 2, 35
          PRINT "<<NO HEADER>>"
          GetKey KeyPress$, BS%
          MODE$ = KeyPress$
          EXIT SUB
        END IF
        LHDR = LEN(HDR$)
        LPAGE = 1
        IPAGE(1) = 1
       
        DO
          COLOR CI.HWB, CI.HWF
          LOCATE IR1, 65
          PRINT "PgUp"
          LOCATE IR2, 65
          PRINT "PgDn"
          COLOR CI.HWF, CI.HWB
          L = IPAGE(LPAGE)
	  ILINE = IR1 + 1
	  DO
            J = INSTR(L, HDR$, CHR$(RET))
            IF J = 0  THEN
	      A$ = MID$(HDR$, L)
              L = LHDR
	    ELSE
	      A$ = MID$(HDR$, L, J - L)
              L = J + 1
	    END IF
	    LOCATE ILINE, 3
            PRINT A$;
	    ILINE = ILINE + 1
            IF L >= LHDR THEN EXIT DO
          LOOP WHILE ILINE < IR2

          GetKey KeyPress$, BS%
          IF LEN(KeyPress$) = 2 THEN
            SpecialKey KeyPress$
          END IF
          SELECT CASE KeyPress$
            CASE "PgUp"
              IF LPAGE > 1 THEN
		LPAGE = LPAGE - 1
	      END IF
            CASE "PgDn"
              IF L < LEN(HDR$) THEN
		LPAGE = LPAGE + 1
		IPAGE(LPAGE) = L
	      END IF
            CASE "<HOME>"
              LPAGE = 1
            CASE ELSE
              MODE$ = KeyPress$
              EXIT DO
	  END SELECT
          TextBox IR1, 1, IR2, 80, CI.HWF, CI.HWB
        LOOP
END SUB
'
' ---------------------------------------------------------------
'
SUB ErrorDisplay (NUMBER)
'
'  This subroutine displays the error message corresponding to NUMBER
'
'    First close all open files in case error occured during i/o
'
        CLOSE
        SOUND 500, 3

	IF TextScreen THEN
          IF SI.MFLAG THEN
            TextBox 1, 1, 4, 80, 7, 0
          ELSE
            TextBox 1, 1, 4, 80, 15, 4
          END IF
	  LOCATE 2, 5
        ELSE
          ClearTopLine
        END IF

	PRINT "ERROR: ";

	SELECT CASE NUMBER

	  CASE 5
	    PRINT "Illegal function call."
	  CASE 6
	    PRINT "Overflow."
	  CASE 11
	    PRINT "Divide by zero."
	  CASE 52, 64
	    PRINT "Bad file name."
	  CASE 58
	    PRINT "File already exists."
	  CASE 53
	    PRINT "File was not found."
	  CASE 61
	    PRINT "Disk is full."
	  CASE 71
	    PRINT "Disk is not ready."
	  CASE 76
	    PRINT "Path was not found."

'  Defined error codes

	  CASE 220
	    PRINT "Log function is invalid:  y <= 0."
	  CASE 221
	    PRINT "Plot does not exist."
	  CASE 222
            PRINT "Data sets do not overlap."
	  CASE 223
	    PRINT "Cannot find first line of data in file."
	  CASE 224
	    PRINT "Command line option not recognized."
	  CASE 225
	    PRINT "Rescale expression not recognized."
	  CASE 226
	    PRINT "Mark opposite corner."
	  CASE 227
	    PRINT "Mouse is not present."
	  CASE 228
	    PRINT "Mark two corners for expansion."
	  CASE 229
	    PRINT "Polynomial order must be from 0 TO 9."
	  CASE 230
	    PRINT "Insufficient number of points for fit."
	  CASE 231
	    PRINT "Too many plots ("; MaxPlots; "  maximum)."
	  CASE 232
            PRINT "Two points have the same abscissa."
	  CASE 233
	    PRINT "No data for plot in window domain."
	  CASE 234
	    PRINT "Too many data sets ("; MaxDataSets; " maximum)."
          CASE 235
            PRINT "Select NEW before loading workspace."
          CASE 236
            PRINT "Incorrect workspace version."
          CASE 237
            PRINT "FFT requires uniformly spaced abscissas."
          CASE 238
            PRINT "Too many points -- Exceeding storage limit."
          CASE 239
            PRINT "Phase = 0 for real data set."
          CASE 240
            PRINT "Function not available for complex data."
          CASE 241
            PRINT "Complex rescale only allowed for complex Y data."
          CASE 242
            PRINT "Insufficient space in database for operation."
          CASE 243
            PRINT "Invalid database function."
          CASE 244
            PRINT "Zero operand not allowed."
          CASE 245
            PRINT "Fractional power not allowed for negative operand."
          CASE 246
            PRINT "Expansion window too small."
          CASE 247
            PRINT "Set Data Cursor mode first."
          CASE 248
            PRINT "File contains more than 3 columns of data."
          CASE ELSE
	    PRINT "Error # "; NUMBER

	END SELECT

        IF TextScreen THEN
          LOCATE 3, 5 : PROMPT
	  TextBox 1, 1, 3, 80, 0, 0
	  COLOR 7, 0
        ELSE
          ButtonMenu 0, KeyPress$
          ClearTopLine
          IF DI.CMODE THEN
            ShowMouse
            ArrowCursor
          END IF
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB SpecialKey (KeyPress$)
'
'  Determine if special key was pressed and reset KeyPress$
'
        IF LEN(KeyPress$) = 2 AND MID$(KeyPress$, 1, 1) = CHR$(0) THEN
          JSK = ASC(MID$(KeyPress$, 2, 1))
	  SELECT CASE JSK
            CASE 20
              KeyPress$ = "<FFT_MENU>"               ' Alt-T
            CASE 21
              KeyPress$ = "<SYMBOL_MENU>"            ' Alt-Y
            CASE 23
              KeyPress$ = "<FIT_MENU>"               ' Alt-I
            CASE 25
              KeyPress$ = "<PLOT_MENU>"              ' Alt-P
            CASE 27
              KeyPress$ = "<BASE>"
            CASE 30
              KeyPress$ = "<ARITHMETIC_MENU>"        ' Alt-A
	    CASE 31
              KeyPress$ = "<SET_MENU>"               ' Alt-S
            CASE 33
              KeyPress$ = "<FILE_MENU>"              ' Alt-F
            CASE 45
              KeyPress$ = "<EXIT_MENU>"              ' Alt-X
            CASE 46
              KeyPress$ = "<COMPLEX_MENU>"           ' Alt-C
            CASE 47
              KeyPress$ = "<SAVE_MENU>"              ' Alt-V
            CASE 50
              KeyPress$ = "<MATH_MENU>"              ' Alt-M
	    CASE 59
              KeyPress$ = "<KEY_HELP>"               ' F1
	    CASE 60
              KeyPress$ = "<DIR>"                    ' F2
	    CASE 61
              KeyPress$ = "<VIEW>"                   ' F3
	    CASE 67
              KeyPress$ = "<WORK>"                   ' F9
	    CASE 68
              KeyPress$ = "<STORE>"                  ' F10
	    CASE 71
              KeyPress$ = "<HOME>"
	    CASE 72
              KeyPress$ = "<UP>"
	    CASE 73
              KeyPress$ = "PgUp"
	    CASE 75
              KeyPress$ = "<LEFT>"
	    CASE 77
              KeyPress$ = "<RIGHT>"
	    CASE 79
              KeyPress$ = "<END>"
	    CASE 80
              KeyPress$ = "<DOWN>"
	    CASE 81
              KeyPress$ = "PgDn"
            CASE 82
              KeyPress$ = "<INSERT>"
            CASE 83
              KeyPress$ = "<DELETE>"
            CASE 120 TO 128                     ' Alt 1 - Alt 9
              KeyPress$ = CHR$(JSK + 80)
	    CASE ELSE
	      '
	  END SELECT
	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB KeyHelp (KeyPress$)
'
'   Key Menu
'
	SetTextScreen
	CLS
        TextBox 1, 1, 3, 80, CI.DWF, CI.DWB
        LOCATE 2, 30
        PRINT "XYPLOT "; Version$

        ' Menus

        TextBox 4, 1, 15, 25, CI.DWF, CI.DWB
        LOCATE  5, 3: PRINT "Alt-F  File Menu"
        LOCATE  6, 3: PRINT "Alt-P  Plot Menu"
        LOCATE  7, 3: PRINT "Alt-M  Math Menu"
        LOCATE  8, 3: PRINT "Alt-S  Set Menu"
        LOCATE  9, 3: PRINT "Alt-V  Save Menu"
        LOCATE 10, 3: PRINT "Alt-Y  Symbol Menu"
        LOCATE 11, 3: PRINT "Alt-A  Arithmetic Menu"
        LOCATE 12, 3: PRINT "Alt-I  Fit Menu"
        LOCATE 13, 3: PRINT "Alt-T  FFT Menu"
        LOCATE 14, 3: PRINT "Alt-X  Exit"

        ' File operations

        TextBox 4, 27, 15, 55, CI.FWF, 0
        LOCATE  5, 29: PRINT "  N   New"
        LOCATE  6, 29: PRINT "  F   Load"
        LOCATE  7, 29: PRINT " F9   Save Workspace"
        LOCATE  8, 29: PRINT "F10   Save Set"
        LOCATE  9, 29: PRINT " ^O   Save Options"
        LOCATE 10, 29: PRINT "  H   Set Header"
        LOCATE 11, 29: PRINT " ^D   Duplicate Set"
        LOCATE 12, 29: PRINT " ^X   Delete Set"
        LOCATE 13, 29: PRINT " ^J   Join Sets"
        LOCATE 14, 29: PRINT " ^Y   Prune Data"

        ' Plot operations

        TextBox 4, 57, 15, 80, CI.DWF, 0
        LOCATE  5, 59: PRINT "  E   Expand "
        LOCATE  6, 59: PRINT "  I   Include"
        LOCATE  7, 59: PRINT "  D   Drop "
        LOCATE  8, 59: PRINT "  C   Color"
        LOCATE  9, 59: PRINT "  G   Grid"
        LOCATE 10, 59: PRINT "  L   Log/linear "
        LOCATE 11, 59: PRINT "  M   Mouse Toggle"
        LOCATE 12, 59: PRINT "<   Set corner"
        LOCATE 13, 59: PRINT "Esc   Unexpand"


        ' Math operations

        TextBox 16, 1, 22, 55, CI.HWF, 0
        LOCATE 17, 3: PRINT "R  ReScale "
        LOCATE 18, 3: PRINT "S  Smooth"
        LOCATE 19, 3: PRINT "P  Poly Fit"
        LOCATE 20, 3: PRINT "V  Derivative"
        LOCATE 21, 3: PRINT "A  Area"

        LOCATE 17, 22: PRINT "+  Add"
        LOCATE 18, 22: PRINT "-  Subtract"
        LOCATE 19, 22: PRINT "*  Multiply"
        LOCATE 20, 22: PRINT "/  Divide"
        LOCATE 21, 22: PRINT "T  Template"

        LOCATE 17, 41: PRINT "^Z  Zero Data"

        TextBox 16, 57, 22, 80, CI.DWF, 0
        LOCATE 17, 59: PRINT "' '  Data Cursor"
        LOCATE 18, 59: PRINT "Del  Point Delete"
        LOCATE 19, 59: PRINT "Ins  Point Insert"
        IF DI.CMODE THEN
          CONTbutn.TopRow = 23
          CONTbutn.LeftCol = 35
          CONTbutn.Nrows = 2
          CONTbutn.Active = YES
          ShowButton CONTbutn
        ELSE
          LOCATE 23, 20
          PRINT "<<SELECT AN ITEM OR PRESS Esc>>"
        END IF

        DO
          GetKey KeyPress$, BS%
          IF BS% <> 0 AND INSTR(KeyPress$, "CONT") <> 0 THEN
            KeyPress$ = CHR$(ESC)
          END IF
          SpecialKey KeyPress$
        LOOP WHILE KeyPress$ = ""

END SUB
'
' ---------------------------------------------------------------
'
SUB Message1
'
'  Display function choices for file name entry.
'
        IF SI.MFLAG THEN
          TextBox 1, 1, 3, 80, 7, 0
        ELSE
          TextBox 1, 1, 3, 80, 1, 2
        END IF
	LOCATE 2, 2
	COLOR 15
	PRINT TAB(5); "F2"; TAB(35); "F3"; TAB(60); "ESC"
        IF SI.MFLAG THEN COLOR 7 ELSE COLOR 1
	LOCATE 2, 9
	PRINT "Set directory"
	LOCATE 2, 39
	PRINT "View File"
	LOCATE 2, 64
	PRINT "Exit"
	COLOR 7, 0

END SUB
'
' ---------------------------------------------------------------
'
SUB Message2
'
'  Print error message that graphics screen is not valid.
'
  PRINT "   Invalid graphics mode. Set the graphics mode"
  PRINT "   supported by your system using the 'screen = ' setting"
  PRINT "   in the initialization file XYPLOT.INI."
  PRINT
  PRINT "        CGALO        320x200 "
  PRINT "        CGA          640x200 "
  PRINT "        EGALO        320x200 "
  PRINT "        EGAMED       640x200 "
  PRINT "        EGA          640x350 "
  PRINT "        EGAMON       EGA w/ Monochrome display "
  PRINT "        MCGALO       320x200 "
  PRINT "        MCGA         640x480 "
  PRINT "        VGA          640x480 "
  PRINT
  PRINT "   For example, to use the VGA 640x480 graphics mode, the"
  PRINT "   following line should be placed in XYPLOT.INI:
  PRINT
  PRINT "   'screen = vga' "
  PRINT
END SUB
'
' ---------------------------------------------------------------
'
SUB ScreenTitle (T$, TC%)
'
'  Print a centered title on the Text Screen
'
	J = (80 - LEN(T$) - 6) / 2

	IF J > 0 THEN
	  LOCATE 2, J
	  COLOR 15
	  PRINT "== ";
	  COLOR TC%
	  PRINT T$;
	  COLOR 15
	  PRINT " ==";
	END IF
END SUB
'
' ---------------------------------------------------------------
'
SUB SelectFile (FSpec$, KMODE, P$, FL$, IX, IY, BS%)
'
'  Display directory and allow user to select file with mouse
'    or keyboard; return filename (or special code), button code,
'    mouse coordinates.
'
'  Input Parameters:
'               FSpec$     -- directory mask (e.g. "*.dat")
'               KMODE      --  -1 for mouse; 0 for no mouse
'               P$         -- prompt string for keyboard input
'               IX, IY     -- column and row for printing prompt
'  Returned Parameters:
'               IX, IY     -- mouse coordinates if mouse used
'               FL$        -- selected filename (or ESC or other key)
'               BS%        -- mouse button pressed (0 for key input)
'
        JR = IY
        JC = IX

STARTOVER:

        FL$ = ""
        BS% = 0
	ShowDir FSpec$

        IF KMODE THEN
          GetButtonPress 0, IX0, IY0, BSLeft%
          GetButtonPress 1, IX1, IY1, BSRight%
        END IF

        DO
          COLOR 7, 0
          LOCATE JR, JC
          PRINT P$;
          GetInput FL$
          SpecialKey FL$
          IF KMODE THEN
            GetButtonPress 0, IX0, IY0, BSLeft%
            GetButtonPress 1, IX1, IY1, BSRight%
            IF BSLeft% <> 0 THEN
              BS% = 1
              IX = IX0
              IY = IY0
            END IF
            IF BSRight% <> 0 THEN
              BS% = 2
              IX = IX1
              IY = IY1
            END IF
            ConvertToRC IX, IY
          ENDIF
        LOOP WHILE FL$ = ""

        IF FL$ = "<DIR>" OR (BS% <> 0 AND (IY = 4 AND _
                         (IX > 25 AND IX < 60))) THEN
          DirectorySet DIR$
          FSpec$ = "*.*"
        ELSEIF FL$ = "PgUp" OR FL$ = "PgDn" OR FL$ = "<HOME>" THEN
          FSpec$ = FL$
        ELSEIF INSTR(FL$, "[") THEN
          L = LEN(FL$)
          DIR$ = MID$(FL$, 2, L - 2)
          SetDirectory DIR$
          FSpec$ = "*.*"
        ELSEIF BS% = 2 THEN
          DisplayFile FL$
          FSpec$ = "*.*"
        ELSE
          COLOR 7, 0
          LOCATE JR, JC
          PRINT SPACE$(50);
          EXIT SUB
        END IF

        GOTO STARTOVER

END SUB
'
' ---------------------------------------------------------------
'
SUB ExitXYPLOT
'
'  Exit from XYPLOT
'
        IF TextScreen THEN
          IF SI.MFLAG THEN
            TextBox 1, 1, 3, 80, 7, 0
          ELSE
            TextBox 1, 1, 3, 80, 12, 0
          END IF
          LOCATE 2, 4
          PRINT "Exit XYPLOT ( Y / S / N )? "
          GetKey KeyPress$, BS%
          KeyPress$ = UCASE$(KeyPress$)
        ELSE
          ExitMenu KeyPress$
        END IF
        SELECT CASE KeyPress$
          CASE "Y", "<EXIT>"
            SetTextScreen
            COLOR 7, 0
            CLS
            END
          CASE "S", "<SHELL>"
            XShell
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB XShell
'
'  Shell to DOS
'
	SetTextScreen
	CLS
	LOCATE 1, 1
	COLOR 15
	PRINT TAB(25); "Type ";
	COLOR 10
	PRINT "EXIT ";
	COLOR 15
	PRINT "to return to XYPLOT"
	SHELL

END SUB
'
' ---------------------------------------------------------------
'            XYPLOT SET ROUTINES
' ---------------------------------------------------------------
'
SUB ShiftValues (X(), Y(), J1, M)
'
'  Shift values in the X and Y arrays by a specified number of
'    positions (M), starting at index J1. M can be positive
'    or negative. Data sets that start at J1 or higher will have
'    their index mapping updated.

        IF M = 0 THEN EXIT SUB
        JL = DS(DB.NSETS).JEi   ' last index
        NV = JL - J1 + 1        ' number of values to be moved
        IF M > 0 THEN
          IF DB.NVALS + M > MaxPoints THEN
            ErrorDisplay 242
            EXIT SUB
          END IF
          JF = JL + M
          FOR J = 1 TO NV
            JN = JF - J + 1
            JO = JL - J + 1
            X(JN) = X(JO)
            Y(JN) = Y(JO)
          NEXT J
        ELSE
          IF DB.NVALS + M < 1 THEN
            ErrorDisplay 243
            EXIT SUB
          END IF
          JF = J1 + M
          FOR J = 1 TO NV
            JN = JF + J - 1
            JO = J1 + J - 1
            X(JN) = X(JO)
            Y(JN) = Y(JO)
          NEXT J
        END IF

'  Update data set index mapping

        FOR K = 1 TO DB.NSETS
          IF DS(K).JSr >= J1 THEN
            DS(K).JSr = DS(K).JSr + M
            DS(K).JEr = DS(K).JEr + M
            DS(K).JSi = DS(K).JSi + M
            DS(K).JEi = DS(K).JEi + M
          END IF
        NEXT K

        DB.NVALS = DB.NVALS + M
        WKSaved = NO
'
END SUB
'
' ---------------------------------------------------------------
'
SUB DeleteSet (X(), Y(), NS)
'
'  Delete data set NS from database.
'
        JSr = DS(NS).JSr
        JEi = DS(NS).JEi
        NVALS = JEi - JSr + 1
	NSETS = DB.NSETS

	IF NS <> NSETS THEN
          JF = DS(NSETS).JEi
          JM = JF - JEi            ' number of values to move

	  FOR K = 1 TO JM     ' move data up to fill vacated space in array
            J4 = JSr + K - 1
            J5 = JEi + K
	    X(J4) = X(J5)
	    Y(J4) = Y(J5)
	  NEXT K

	  FOR K = NS TO NSETS - 1   ' move data sets to fill vacated space
	    DS(K) = DS(K + 1)
            DS(K).JSr = DS(K).JSr - NVALS
            DS(K).JEr = DS(K).JEr - NVALS
            DS(K).JSi = DS(K).JSi - NVALS
            DS(K).JEi = DS(K).JEi - NVALS
	  NEXT K
	END IF

	DB.NSETS = NSETS - 1
	DB.NVALS = DB.NVALS - NVALS

'
' Check plot list to remove any plots belonging to data set NS
'

	FOR J = 1 TO DI.NPLOTS
	  IF PV(J).SET = NS THEN
	    DropPlot J
	  END IF
	NEXT J
'
'  Plots bound to set numbers > NS should have set number updated.
'
        FOR J = 1 TO DI.NPLOTS
          IF PV(J).SET > NS THEN PV(J).SET = PV(J).SET - 1
        NEXT J

        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB CopySet (X(), Y(), NS)
'
'  Copy data set NS as a new set at end of database. Return NS
'    as the set number of the new set.
'
        NSETS = DB.NSETS
        JSr = DS(NS).JSr
        JEi = DS(NS).JEi
        NVALS = JEi - JSr + 1
        IF DB.NVALS + NVALS > MaxPoints THEN
          ErrorDisplay 242                      ' not enough space
          EXIT SUB
        END IF
        IF NSETS = MaxDataSets THEN
          ErrorDisplay 242
          EXIT SUB
        END IF
        J1 = DS(NSETS).JEi + 1
        J2 = J1 + NVALS - 1

        FOR J = 1 TO NVALS
          JO = JSr + J - 1
          JN = J1 + J - 1
          X(JN) = X(JO)
          Y(JN) = Y(JO)
        NEXT J

        AddNewSet X(), Y(), J1, J2, DS(NS).CMPLX, _
          DS(NS).FNAME, DS(NS).HDR, NS2
        NS = NS2

END SUB
'
' ---------------------------------------------------------------
'
SUB XDuplicate (X(), Y(), NS)
'
'  Make a duplicate copy of data set NS in the database.
'
        ClearTopLine
        PRINT "Making duplicate copy of set # "; NS; " . . ."

        CopySet X(), Y(), NS
        AddNewPlot NS, PV(DI.SP1).SYM, NP
'
END SUB
'
' ---------------------------------------------------------------
'
SUB JoinSets (X(), Y(), NS1, NS2)
'
'  Join two data sets one set (set concatenation).
'  Ascending sort on X is performed.
'
        IF NS1 = NS2 THEN EXIT SUB

        IF DS(NS1).CMPLX OR DS(NS2).CMPLX THEN
          ErrorDisplay 240                      ' no complex
          EXIT SUB
        END IF

	ClearTopLine
        PRINT "Joining sets - One Moment Please. . . ";

        CopySet X(), Y(), NS1           ' copy set 1 to end of database
        CopySet X(), Y(), NS2           ' copy set 2 to end

        NS1 = DB.NSETS - 1
        NS2 = DB.NSETS

        ' Merge the last two data sets into one set and perform
        '   ascending sort on X.

        J1 = DS(NS1).JSr : J2 = DS(NS2).JEi
        Sort2 X(), Y(), J1, J2

        A$ = "UNION"
        F1$ = RTRIM$(DS(NS1).FNAME)
        IF F1$ = "XYPLOT" THEN F1$ = "SET" + STR$(NS1)
        F2$ = RTRIM$(DS(NS2).FNAME)
        IF F2$ = "XYPLOT" THEN F2$ = "SET" + STR$(NS2)
        HDR$ = "==XYPLOT==> " + A$ + " OF " + F1$ + " AND " + F2$

' Remove last two sets, combine as one new set, and create plot.

        DB.NSETS = DB.NSETS - 2
        AddNewSet X(), Y(), J1, J2, NO, A$, HDR$, NS3
        AddNewPlot NS3, PV(DI.SP1).SYM, NP

END SUB
'
' ---------------------------------------------------------------
'
SUB DeletePoint (X(), Y(), NS, J)
'
'  Delete X(J), Y(J); J is the X index of the point.
'
        IF (J < DS(NS).JSr) OR (J > DS(NS).JEi) THEN EXIT SUB
        XX = X(J)
        YY = Y(J)
        ShiftValues X(), Y(), J + 1, -1
        DS(NS).JEr = DS(NS).JEr - 1
        DS(NS).NPTS = DS(NS).NPTS - 1
        DS(NS).JEi = DS(NS).JEi - 1
        DS(NS).JSi = DS(NS).JSi - 1
        A$ = "==XYPLOT==> POINT DELETED (" + STR$(XX) + ", " + _
               STR$(YY) + ")" + CHR$(RET)
        DS(NS).HDR = A$ + DS(NS).HDR
        Extrema X(), Y(), NS
END SUB
'
' ---------------------------------------------------------------
'
SUB InsertPoint (X(), Y(), NS, XX, YY)
'
'  Insert the point XX, YY into data set NS
'
        J1 = DS(NS).JSr
        ShiftValues X(), Y(), J1, 1
        X(J1) = XX
        Y(J1) = YY
        DS(NS).NPTS = DS(NS).NPTS + 1
        DS(NS).JSr = J1
        J2 = DS(NS).JEr
        Sort2 X(), Y(), J1, J2
        A$ = "==XYPLOT==> POINT INSERTED (" + STR$(XX) + ", " + _
               STR$(YY) + ")" + CHR$(RET)
        DS(NS).HDR = A$ + DS(NS).HDR
        Extrema X(), Y(), NS

END SUB
'
' ---------------------------------------------------------------
'
SUB PruneSet (X(), Y(), NS)
'
'  Prune data set to delete portion visible in plot window.
'
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        JSi = DS(NS).JSi
        JEi = DS(NS).JEi

'  No portion visible? Then, leave.

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, J1, J2, IERR
        IF IERR <> 0 THEN EXIT SUB

        ClearTopLine
        PRINT "Pruning data ... "

        M = J1 - J2 - 1
        ShiftValues X(), Y(), J2 + 1, M
        DS(NS).JEr = DS(NS).JEr + M
        DS(NS).JEi = DS(NS).JEi + M
        DS(NS).NPTS = DS(NS).NPTS + M
        IF DS(NS).CMPLX THEN
          DS(NS).JSi = DS(NS).JSi + M
          J3 = J2 + DS(NS).NPTS + 1
          ShiftValues X(), Y(), J3, M
          DS(NS).JEi = DS(NS).JEi + M
        END IF

       A$ = "==XYPLOT==> PRUNED [" + STR$(DI.XMIN) + ", " + _
              STR$(DI.XMAX) + "]" + CHR$(RET)
       DS(NS).HDR = A$ + DS(NS).HDR

       Extrema X(), Y(), NS
'
END SUB
'
' ---------------------------------------------------------------
'
SUB SetSaveOptions
'
'  Allow user to set the options for saving a data file.
'
        SetTextScreen
        CLS
        TextBox 1, 1, 3, 80, CI.FWF, CI.FWB
        LOCATE 2, 35: PRINT "SAVE OPTIONS"
        IF DI.CMODE THEN
          OKbutn.NROWS = 2: OKbutn.TopRow = 23: OKbutn.LeftCol = 30
          ShowButton OKbutn
        END IF

        DO
          TextBox 8, 15, 16, 55, CI.DWF, CI.DWB
          LOCATE 10, 17 : PRINT "[1] Write Header:  ";
          IF VI.HS THEN PRINT "YES" ELSE PRINT "NO"
          LOCATE 12, 17 : PRINT "[2] Number Format: ";
          IF VI.FM = "F" THEN
            PRINT "FLOATING POINT"
          ELSEIF VI.FM = "I" THEN
            PRINT "INTEGER"
          ELSE
            PRINT "EXPONENTIAL"
          END IF
          LOCATE 14, 17 : PRINT "[3] Delimiter:     ";
          IF VI.DL = "," THEN
            PRINT "COMMA"
          ELSE
            PRINT "SPACE"
          END IF
          LOCATE 18, 15
          COLOR 7, 0
          PRINT "Item to Change? ";
          GetKey KeyPress$, BS%
          KeyPress$ = UCASE$(KeyPress$)
          IF KeyPress$ = CHR$(ESC) OR KeyPress$ = CHR$(RET) THEN EXIT DO
          SELECT CASE KeyPress$
            CASE "1", "[1]", "YES", "NO"
              VI.HS = NOT VI.HS
            CASE "2", "[2]", "FLOATING", "POINT", "EXPONENTIAL", "INTEGER"
              IF VI.FM = "F" THEN
                VI.FM = "I"
              ELSEIF VI.FM = "I" THEN
                VI.FM = "E"
              ELSE
                VI.FM = "F"
              END IF
            CASE "3", "[3]", "SPACE", "COMMA"
              IF VI.DL = "," THEN
                VI.DL = " "
              ELSE
                VI.DL = ","
              END IF
            CASE "OK"
              EXIT DO
            CASE ELSE
              '
          END SELECT
        LOOP

        EXIT SUB

END SUB
'
'
' ---------------------------------------------------------------
'            XYPLOT GRAPHICS ROUTINES
' ---------------------------------------------------------------
'
SUB XColor (COL AS INTEGER)
'
'  Set color COL as the foreground color, making sure that the
'    COLOR statement is valid for current graphics screen mode SI.N.
'
        J = ((SI.N = 1) OR (SI.N = 2) OR (SI.N = 3) OR (SI.N = 11))
        IF (NOT J) AND (NOT SI.MFLAG) THEN
	  COLOR COL
	END IF

END SUB
'
' ---------------------------------------------------------------
'
FUNCTION PlotVisible (NP)
'
'  Return true if plot NP is visible in current display window.
'
'       Determine plot bounds
	
        NS = PV(NP).SET
        XMIN = DS(NS).XMIN
	XMAX = DS(NS).XMAX

        IF PV(NP).VIS > 1 THEN
	  YMIN = DS(NS).iYMIN
	  YMAX = DS(NS).iYMAX
	ELSE
	  YMIN = DS(NS).YMIN
	  YMAX = DS(NS).YMAX
	END IF
        J = ((XMIN > DI.XMAX) OR (XMAX < DI.XMIN))
        K = ((YMIN > DI.YMAX) OR (YMAX < DI.YMIN))
        PlotVisible = NOT (J OR K)

END FUNCTION
'
' ---------------------------------------------------------------
'
SUB Coordinates (XX, YY, IX%, IY%, IFL%)
'
'  Compute the logical coordinates X, and Y from the physical coordinates
'    IX, and IY.
'
	IF IFL THEN
	  XX = DI.XMIN + (IX - SI.IX1) / DI.XSF
	  IYY = SI.YINV - IY

	  IF DI.SCALE THEN
	    YY = EXP(IYY / DI.YLSF + DI.LYMIN)
	  ELSE
	    YY = IYY / DI.YSF + DI.YMIN
	  END IF
	ELSE

'  Compute the physical coordinates from the logical coordinates

	  IX = SI.IX1 + (XX - DI.XMIN) * DI.XSF
	  IF DI.SCALE THEN
            IF YY > 0! THEN
              IY = (LOG(YY) - DI.LYMIN) * DI.YLSF
            ELSE
              IY = 0
            END IF
	  ELSE
	    IY = (YY - DI.YMIN) * DI.YSF
	  END IF
	  IY = SI.YINV - IY
	END IF

END SUB
'
' ---------------------------------------------------------------
'
FUNCTION IBOUND (IX, IY)
'
'   Return true if coordinates IX, IY are within
'   plotting window, false otherwise.
'
        J = (IX >= SI.IX1) AND (IX <= SI.IX2)
        K = (IY >= SI.IY1) AND (IY <= SI.IY2)
        IBOUND = J AND K

END FUNCTION
'
' ---------------------------------------------------------------
'
FUNCTION IBOUND2 (IX, IY)
'
        J = (IX >= (SI.IX1 - 5)) AND (IX <= (SI.IX2 + 5))
        K = (IY >= (SI.IY1 - 5)) AND (IY <= (SI.IY2 + 5))
        IBOUND2 = J AND K

END FUNCTION
'
' ---------------------------------------------------------------
'
SUB DataCursor (X(), Y(), NP)
'
'  Track data points with cursor
'
        DIM Ordering AS INTEGER
        DIM V(4) AS SINGLE

        IF NOT IBOUND2 (DI.IX, DI.IY) THEN EXIT SUB

        NS = PV(NP).SET
        NVis = PV(NP).VIS
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, JX1, JX2, IERR
        IF IERR <> 0 THEN EXIT SUB
        IF SI.NCOLS > 40 THEN
          IC = 20
          FF$ = "i:  ####      "
        ELSE
          IC = 1
          FF$ = "i: ####  "
        END IF
        XF$ = FormD$(DI.XMIN, DI.XMAX)
        YF$ = FormD$(DI.YMIN, DI.YMAX)
        FF$ = FF$ + "X: " + XF$
        IF DS(NS).CMPLX THEN
          IF NVis = 1 THEN
            FF$ = FF$ + "    Re(Y): " + YF$
          ELSE
            FF$ = FF$ + "    Im(Y): " + YF$
          END IF
        ELSE
          FF$ = FF$ + "    Y: " + YF$
        END IF
        IF X(JX2) < X(JX1) THEN
          Ordering = 0
        ELSE
          Ordering = -1
        END IF
        IX = DI.IX
        IY = DI.IY
        ICS = DI.CSIZE
        IF DI.CMODE THEN
          SetCursor
        ELSE
          PUT (DI.IX - ICS, DI.IY - ICS), IAREA, PSET
        END IF

        DO
          Coordinates X1, Y1, IX, IY, -1
          J = JFIND(X(), X1, JSr, JEr)
          J2 = J
          IF SI.NCOLS > 40 THEN
            ClearTopLine
            LOCATE 1, 1
            XColor PV(NP).COL
            PRINT "[DATA CURSOR]"
          END IF
          XColor 7
          DO
            J = J2
            JC = J - JSr + 1
            PUT (IX - ICS, IY - ICS), IAREA, PSET
            XN = X(J)
            IF DS(NS).CMPLX AND NVis = 2 THEN
              YY = Y(J + DS(NS).NPTS)
            ELSE
              YY = Y(J)
            END IF
            YN = FMAX (DI.YMIN, YY)
            YN = FMIN (DI.YMAX, YN)
            Coordinates XN, YN, IX, IY, 0
            GET (IX - ICS, IY - ICS)-(IX + ICS, IY + ICS), IAREA
            PUT (IX - ICS, IY - ICS), IGC, OR
            LOCATE 1, IC
            PRINT USING FF$; JC; XN; YY
            KeyWait KeyPress$
            SpecialKey KeyPress$
            SELECT CASE KeyPress$
              CASE "<LEFT>"
                IF Ordering THEN
                  J2 = MAX(JX1, J - 1)
                ELSE
                  J2 = MIN(JX2, J + 1)
                END IF
              CASE "<RIGHT>"
                IF Ordering THEN
                  J2 = MIN(JX2, J + 1)
                ELSE
                  J2 = MAX(JX1, J - 1)
                END IF
              CASE "<DELETE>"
                IF DS(NS).CMPLX THEN
                  ErrorDisplay 240
                ELSE
                  ClearTopLine
                  PRINT "DELETE POINT: (";XN; ","; YY;") ?"
                  ButtonMenu 1, A$
                  IF INSTR(A$, "Y") <> 0 THEN
                    DeletePoint X(), Y(), NS, J
                    IF J = JEr THEN J2 = J - 1
                  END IF
                END IF
                EXIT DO
              CASE "<INSERT>"
                IF DS(NS).CMPLX THEN
                  ErrorDisplay 240
                ELSE
                  ClearTopLine
                  PRINT "INSERT POINT -- Enter x, y : ";
                  GetInput A$
                  IF A$ <> CHR$(ESC) AND A$ <> "" THEN
                    NumberParse V(), M, A$
                    InsertPoint X(), Y(), NS, V(1), V(2)
                  END IF
                END IF
                EXIT DO
              CASE "<HOME>"
                IF Ordering THEN
                  J2 = JX1
                ELSE
                  J2 = JX2
                END IF
              CASE "<END>"
                IF Ordering THEN
                  J2 = JX2
                ELSE
                  J2 = JX1
                END IF
              CASE ELSE
                J2 = J
            END SELECT
          LOOP WHILE (KeyPress$ <> CHR$(ESC)) AND (KeyPress$ <> CHR$(32))
          PUT (IX - ICS, IY - ICS), IAREA, PSET
          IF KeyPress$ = CHR$(ESC) OR KeyPress$ = CHR$(32) THEN EXIT DO
          ScreenPlot X(), Y()
          DI.IX = IX
          DI.IY = IY
          SetCursor
          JSr = DS(NS).JSr
          JEr = DS(NS).JEr
          IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, JX1, JX2, IERR
          IF IERR <> 0 THEN EXIT DO
        LOOP
        DI.IX = IX
        DI.IY = IY

END SUB
'
' ---------------------------------------------------------------
'
SUB SetCursor
'
'  draw keypad controlled cursor and store image in IGC
'
        XColor 15
        J = DI.CSIZE
        IX = DI.IX
        IY = DI.IY
	GET (IX - J, IY - J)-(IX + J, IY + J), IAREA

	FOR K = IY - J TO IY + J
	   LINE (IX - J, K)-(IX + J, K), 0
	NEXT K

	LINE (IX - J, IY - J)-(IX + J, IY + J)
	LINE (IX - J, IY + J)-(IX + J, IY - J)
	GET (IX - J, IY - J)-(IX + J, IY + J), IGC
	PUT (IX - J, IY - J), IAREA, PSET

END SUB
'
' ---------------------------------------------------------------
'
SUB KeypadMouse (KeyPress$)
'
'
' ++++++++++      Keypad Mouse    +++++++++++
'
'
        SetCursor
        ICS = DI.CSIZE
        IF SI.NCOLS < 80 THEN
          IC = 15
        ELSE
          IC = 55
        END IF
        XF$ = FormD$(DI.XMIN, DI.XMAX)
        YF$ = FormD$(DI.YMIN, DI.YMAX)
	FF$ = XF$ + " " + YF$
	XColor 7

        IX = DI.IX : IY = DI.IY
	IA = 1
        OldKey$ = ""

	DO
	  GET (IX - ICS, IY - ICS)-(IX + ICS, IY + ICS), IAREA
	  PUT (IX - ICS, IY - ICS), IGC, OR

' Display logical coordinates XX, YY

	  IX2 = IX
	  IY2 = IY
	  Coordinates XX, YY, IX2, IY2, -1
	  LOCATE 1, IC
	  PRINT USING FF$; XX; YY
	  START! = TIMER
          KeyWait KeyPress$
	  FINISH! = TIMER
          IF (KeyPress$ = OldKey$) AND ((START! - FINISH!) < .04) THEN
	    IA = IA + 1
	  ELSE
	    IA = 1
	  END IF
	  IF IA > 5 THEN IA = 5
          OldKey$ = KeyPress$

' Reset old points

	  PUT (IX - ICS, IY - ICS), IAREA, PSET

          IF LEN(KeyPress$) <> 2 THEN
            DI.IX = IX: DI.IY = IY
            EXIT DO
          END IF
          SK = ASC(MID$(KeyPress$, 2, 1))
	  SELECT CASE SK
	    CASE 72
	      IY = IY - IA
	    CASE 75
	      IX = IX - IA
	    CASE 77
	      IX = IX + IA
	    CASE 80
	      IY = IY + IA
	    CASE 71
              IX = (SI.IX1 + SI.IX2) / 2
              IY = (SI.IY1 + SI.IY2) / 2
	    CASE ELSE
              DI.IX = IX: DI.IY = IY
	      EXIT DO
	  END SELECT
	  IF IX < SI.IX1 THEN IX = SI.IX1
	  IF IY < SI.IY1 THEN IY = SI.IY1
	  IF IX > SI.IX2 THEN IX = SI.IX2
	  IF IY > SI.IY2 THEN IY = SI.IY2
	LOOP

END SUB
'
' ---------------------------------------------------------------
'
SUB PointPlot (X(), Y(), JX1, JX2, JY1, ISIZE, ICOL)
'
'  Plot points for X indices [JX1, JX2], and Y indices [JY1, JY2].
'
        J = 0
        DO
          JX = JX1 + J
          JY = JY1 + J

          Coordinates X(JX), Y(JY), IX, IY, 0

          IF IBOUND(IX, IY) THEN
            FOR K = -ISIZE TO ISIZE
              FOR M = -ISIZE TO ISIZE
                PSET (IX + K, IY + M), ICOL
              NEXT M
            NEXT K
          END IF
          J = J + 1
        LOOP WHILE JX < JX2

END SUB
'
' ---------------------------------------------------------------
'
SUB LinePlot (X(), Y(), JX1, JX2, JY1, ISTYLE, IC)
'
'  Plot continuous or broken line
'
        IX1 = SI.IX1 : IX2 = SI.IX2 : IY1 = SI.IY1 : IY2 = SI.IY2

        X1 = X(JX1)
        Y1 = Y(JY1)

	Coordinates X1, Y1, IX, IY, 0

        IF IBOUND(IX, IY) THEN PSET (IX, IY), IC
        J = 0
        DO
          IXL = IX
	  IYL = IY
          JX = JX1 + J
          JY = JY1 + J

          Coordinates X(JX), Y(JY), IX, IY, 0

          IXN = IX
          IYN = IY

          LineClip IXL, IYL, IXN, IYN, IX1, IX2, IY1, IY2, JFL

          IF JFL THEN
            IF ISTYLE THEN
              LINE (IXL, IYL) - (IXN, IYN), IC, , &HF0F0
            ELSE
              LINE (IXL, IYL)-(IXN, IYN), IC
            END IF
          END IF

          IXL = IX
          IYL = IY
          J = J + 1

        LOOP WHILE JX < JX2

END SUB
'
' ---------------------------------------------------------------
'
SUB StickPlot (X(), Y(), JX1, JX2, JY1, IC)
'
'  Plot vertical sticks
'
        IX1 = SI.IX1 : IX2 = SI.IX2 : IY1 = SI.IY1 : IY2 = SI.IY2

        J = 0
        DO
          JX = JX1 + J
          JY = JY1 + J

          Coordinates X(JX), 0!, IX0, IY0, 0
          Coordinates X(JX), Y(JY), IX, IY, 0

          IF IX >= SI.IX1 AND IX <= SI.IX2 THEN
            IF IY0 > IY THEN SWAP IY, IY0

            I1 = IY0 < SI.IY1
            I2 = IY < SI.IY1
            I3 = IY0 > SI.IY2
            I4 = IY > SI.IY2

            IF I2 OR I3 THEN
              JFL = 0
            ELSE
              IF I1 THEN IY0 = SI.IY1
              IF I4 THEN IY = SI.IY2
              JFL = -1
            END IF

            IF JFL THEN LINE (IX, IY0)-(IX, IY), IC
          END IF

          J = J + 1

        LOOP WHILE JX < JX2

END SUB
'
' ---------------------------------------------------------------
'            XYPLOT MENU ROUTINES
' ---------------------------------------------------------------
'
'
SUB MenuSelection (KeyPress$)
'
'  Determine item selected from menu line and return in KeyPress$
'
        ICOL = 1 + INT(DI.IX / SI.NCPIX)
          SELECT CASE ICOL
            CASE 7 TO 14
              KeyPress$ = "<FILE_MENU>"
            CASE 15 TO 25
              KeyPress$ = "<PLOT_MENU>"
            CASE 26 TO 34
              KeyPress$ = "<MATH_MENU>"
            CASE 36 TO 38
              SELECT CASE DI.IB
                CASE 1
                  KeyPress$ = "E"
                CASE 2
                  KeyPress$ = CHR$(27)
                CASE 3
                  KeyPress$ = "<BASE>"
                CASE ELSE
                  '
              END SELECT
            CASE 43
              IF DI.PLIST > 1 THEN
                DI.PLIST = DI.PLIST - 1
              END IF
            CASE 44 TO 50
              J = INT((ICOL - 45) / 2) + DI.PLIST
              IF J <= DI.NPLOTS THEN
                IF DI.IB = 1 THEN
                  DI.SP1 = J
                ELSE
                  DI.SP2 = J
                END IF
              END IF
            CASE 51
              IF (DI.PLIST + 2) < DI.NPLOTS THEN
                DI.PLIST = DI.PLIST + 1
              END IF
            CASE ELSE
              KeyPress$ = CHR$(2)
          END SELECT
'
END SUB
'
' ---------------------------------------------------------------
'
SUB HighlightOption (GM AS GraphicsMenu, Opt%)
'
'  Highlight selected menu option by reversing image.
'
        DIM IBOX(1000) AS INTEGER

        IF DI.CMODE THEN HideMouse
        IR1 = Opt% + GM.IR1 + 1
        IC1 = GM.IC1 + 1
        IR2 = IR1 + 1
        IC2 = IC1 + 11
        PixelPosition IR1, IC1, SI.NCPIX, SI.NRPIX, IX1, IY1
        PixelPosition IR2, IC2, SI.NCPIX, SI.NRPIX, IX2, IY2
        GET (IX1, IY1)-(IX2, IY2), IBOX
        PUT (IX1, IY1), IBOX, PRESET
        IF DI.CMODE THEN
          PutMouse (IX1 + IX2)/2, (IY1 + IY2)/2
          ShowMouse
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB MenuBox (GM AS GraphicsMenu, OPT$())
'
'
' Display a menu box with specified options and wait for user selection
'   via mouse or keyboard.

        DIM IBOX1(20000) AS INTEGER
        DIM IBOX2(1000) AS INTEGER

        IR1 = GM.IR1 : IC1 = GM.IC1
        NOPT = GM.NOPT
        IR2 = IR1 + NOPT + 3
        IC2 = IC1 + 14
        IF GM.Selection < 1 THEN GM.Selection = 1
        IF GM.Selection > NOPT THEN GM.Selection = NOPT
        LastOption% = GM.Selection
        CurrentOption% = GM.Selection

        PixelPosition IR1, IC1, SI.NCPIX, SI.NRPIX, IX1, IY1
        PixelPosition IR2, IC2, SI.NCPIX, SI.NRPIX, IX2, IY2
'        IY2 = 4 * (INT((IY2 - IY1)/4) + 1) + IY1

        GET (IX1, IY1)-(IX2, IY2), IBOX1        ' save background

        BOX IX1, IY1, IX2, IY2, 7               ' draw menu border
        IX3 = IX1 + 5
        IX4 = IX2 - 5
        IY3 = IY1 + 5
        IY4 = IY2 - 5
        BOX IX3, IY3, IX4, IY4, 7

        FOR J = 1 TO NOPT                          ' print menu options
          LOCATE IR1 + J + 1, IC1 + 2
          PRINT OPT$(J)
        NEXT J

'  Reverse menu image

        FOR IY = IY1 TO IY2 - 4 STEP 4
          GET (IX1, IY)-(IX2, IY + 3), IBOX2
          PUT (IX1, IY), IBOX2, PRESET
        NEXT IY

        IF DI.CMODE THEN
          ShowMouse
          ArrowCursor
        END IF

        KeyPress$ = ""
        M2 = 99
        IRLAST = IR1

        HighlightOption GM, LastOption%

        DO
          IF CurrentOption% <> LastOption% THEN
            HighlightOption GM, LastOption%
            HighlightOption GM, CurrentOption%
            LastOption% = CurrentOption%
          END IF

          IF DI.CMODE AND KeyPress$ = "" THEN
            GetMousePosition IX, IY, IB
            IR = 1 + INT(IY / SI.NRPIX)
            IC = 1 + INT(IX / SI.NCPIX)

            IF IC >= IC1 AND IC <= IC2  AND IR >= IR1 AND IR <= IR2 THEN
              IF IR <> IRLAST THEN
                CurrentOption% = IR - IR1 - 1
                CurrentOption% = MAX(CurrentOption%, 1)
                CurrentOption% = MIN(CurrentOption%, NOPT)
                IRLAST = IR
              END IF
            ELSE
              GM.Selection = 0
              EXIT DO
            END IF

            IF IB = 1 THEN
              ButtonRelease
              GM.Selection = CurrentOption%
              EXIT DO
            END IF
          END IF

          KeyPress$ = INKEY$
          IF KeyPress$ <> "" THEN
            IF LEN(KeyPress$) > 1 THEN
              JSK = ASC(MID$(KeyPress$, 2, 1))
              SELECT CASE JSK
                CASE 72
                  CurrentOption% = CurrentOption% - 1
                  IF CurrentOption% < 1 THEN CurrentOption% = NOPT
                CASE 80
                  CurrentOption% = CurrentOption% + 1
                  IF CurrentOption% > NOPT THEN CurrentOption% = 1
                CASE ELSE
                  '
              END SELECT
            ELSE
              SELECT CASE KeyPress$
                CASE CHR$(13)
                  GM.Selection = CurrentOption%
                CASE CHR$(27)
                  GM.Selection = 0
                CASE ELSE
                  GM.Selection = ASC(KeyPress$) + 255
              END SELECT
              EXIT DO
            END IF
          END IF
        LOOP

        IF DI.CMODE THEN HideMouse
        PUT (IX1, IY1), IBOX1, PSET           ' restore background
'
END SUB
'
' ---------------------------------------------------------------
'
SUB ShowMenu (KeyPress$)
'
' Display selected menu specified in KeyPress$, and return menu
'   selection in KeyPress$;  KeyPress$=CHR$(2) for null choice.
'

    M$ = KeyPress$
    KeyPress$ = CHR$(2)

    SELECT CASE M$
      CASE "<FILE_MENU>"
        FileMenu KeyPress$
        IF KeyPress$ = "<SET_MENU>" THEN
          SetMenu KeyPress$
        ELSEIF KeyPress$ = "<SAVE_MENU>" THEN
          SaveMenu KeyPress$
        ELSE
          '
        END IF
      CASE "<PLOT_MENU>"
        PlotMenu KeyPress$
        IF KeyPress$ = "<INCLUDE>" THEN
          IncludeMenu KeyPress$
        ELSEIF KeyPress$ = "<SYMBOL_MENU>" THEN
          SymbolMenu KeyPress$
        ELSE
          '
        END IF
      CASE "<MATH_MENU>"
        DO
          MathMenu KeyPress$
          IF KeyPress$ = "<ARITHMETIC_MENU>" THEN
            ArithmeticMenu KeyPress$
          ELSEIF KeyPress$ = "<FIT_MENU>" THEN
            FitMenu KeyPress$
          ELSEIF KeyPress$ = "<MORE>" THEN
            MathMenu2 KeyPress$
            IF KeyPress$ = "<COMPLEX_MENU>" THEN
              ComplexMenu KeyPress$
            ELSEIF KeyPress$ = "<FFT_MENU>" THEN
              FFTMenu KeyPress$
            ELSE
              '
            END IF
	  ELSE
	    '
          END IF
        LOOP WHILE KeyPress$ = "<PREV>"
      CASE "<SET_MENU>"
        SetMenu KeyPress$
      CASE "<SAVE_MENU>"
        SaveMenu KeyPress$
      CASE "<SYMBOL_MENU>"
        SymbolMenu KeyPress$
      CASE "<ARITHMETIC_MENU>"
        ArithmeticMenu KeyPress$
      CASE "<FIT_MENU>"
        FitMenu KeyPress$
      CASE "<COMPLEX_MENU>"
        ComplexMenu KeyPress$
      CASE "<FFT_MENU>"
        FFTMenu KeyPress$
      CASE ELSE
        '
    END SELECT

    IF DI.CMODE THEN
      '  update mouse position
      GetMousePosition IX, IY, BS%
      DI.IX = IX: DI.IY = IY
    END IF

'
END SUB
'
' ---------------------------------------------------------------
'
SUB FileMenu (KeyPress$)
'
' Display file menu
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " New      "
        OPT$(2) = " Load     "
        OPT$(3) = " Set      "
        OPT$(4) = " Save     "
        OPT$(5) = " Exit     "

        GM.NOPT = 5
        GM.IR1 = 2: GM.IC1 = 7

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "N"
          CASE 2
            KeyPress$ = "F"
          CASE 3
            KeyPress$ = "<SET_MENU>"
          CASE 4
            KeyPress$ = "<SAVE_MENU>"
          CASE 5
            KeyPress$ = "<EXIT_MENU>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB SetMenu (KeyPress$)

        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

	OPT$(1) = " Header    "
	OPT$(2) = " Delete    "
        OPT$(3) = " Duplicate "
	OPT$(4) = " Join      "
        OPT$(5) = " Prune     "
	GM.NOPT = 5
        GM.IR1 = 2: GM.IC1 = 7

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
	  CASE 1
            KeyPress$ = "H"
	  CASE 2
            KeyPress$ = "<DELETE_SET>"
	  CASE 3
            KeyPress$ = "<DUP>"
	  CASE 4
            KeyPress$ = "<JOIN>"
	  CASE 5
            KeyPress$ = "<PRUNE>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB SaveMenu (KeyPress$)

        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Data Set  "
        OPT$(2) = " WorkSpc   "
        OPT$(3) = " Lotus WK1 "
        OPT$(4) = " Options   "

        GM.NOPT = 4
        GM.IR1 = 2: GM.IC1 = 7

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<STORE>"
          CASE 2
            KeyPress$ = "<WORK>"
          CASE 3
            KeyPress$ = "<WK1>"
          CASE 4
            KeyPress$ = "<SAVE_OPTS>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB PlotMenu (KeyPress$)
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Include   "
        OPT$(2) = " Drop      "
        OPT$(3) = " Grid      "
	OPT$(4) = " Symbol    "
        OPT$(5) = " Color     "
        OPT$(6) = " --------- "
        OPT$(7) = " --------- "

        NS = PV(DI.SP1).SET
        IF DI.SCALE THEN
          OPT$(6) = " Linear   "
        ELSE
          OPT$(6) = " Log      "
        END IF
        IF DS(NS).CMPLX THEN
          IF PV(DI.SP1).VIS = 1 THEN
            OPT$(7) = " See Im(Y)"
          ELSE
            OPT$(7) = " See Re(Y)"
          END IF
          GM.NOPT = 7
        ELSE
          GM.NOPT = 6
        END IF
        GM.IR1 = 2: GM.IC1 = 15

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<INCLUDE>"
          CASE 2
            KeyPress$ = "D"
          CASE 3
            KeyPress$ = "G"
	  CASE 4
            KeyPress$ = "<SYMBOL_MENU>"
          CASE 5
            KeyPress$ = "<PALETTE>"
          CASE 6
            KeyPress$ = "L"
          CASE 7
            IF PV(DI.SP1).VIS = 1 THEN
              PV(DI.SP1).VIS = 2
            ELSE
              PV(DI.SP1).VIS = 1
            END IF
            KeyPress$ = "<REDRAW>"
          CASE ELSE
            '
        END SELECT
'
END SUB
'
' ---------------------------------------------------------------
'
SUB IncludeMenu (KeyPress$)
'
' Display include menu
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        FOR J = 1 TO DB.NSETS
          OPT$(J) = " " + MID$(DS(J).FNAME, 1, 8) + " "
        NEXT J

        GM.NOPT = DB.NSETS
        GM.IR1 = 2: GM.IC1 = 15

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        IF GM.Selection <> 0 THEN
          AddNewPlot GM.Selection, DefaultSymbol$, NP
          KeyPress$ = "<REDRAW>"
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB SymbolMenu (KeyPress$)
'
' Display plotting symbol menu
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Line      "
        OPT$(2) = " Point     "
        OPT$(3) = " Ln + Pt   "
        OPT$(4) = " Broken    "
        OPT$(5) = " Big Point "
        OPT$(6) = " Stick     "

        NP = DI.SP1
        GM.NOPT = 6
        GM.IR1 = 2: GM.IC1 = 15

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            PV(NP).SYM = "L"
            KeyPress$ = "<REDRAW>"
          CASE 2
            PV(NP).SYM = "P"
            KeyPress$ = "<REDRAW>"
          CASE 3
            PV(NP).SYM = "+"
            KeyPress$ = "<REDRAW>"
          CASE 4
            PV(NP).SYM = "R"
            KeyPress$ = "<REDRAW>"
          CASE 5
            PV(NP).SYM = "B"
            KeyPress$ = "<REDRAW>"
          CASE 6
            PV(NP).SYM = "S"
            KeyPress$ = "<REDRAW>"
          CASE ELSE
            '
        END SELECT
'
END SUB
'
' ---------------------------------------------------------------
'
SUB MathMenu (KeyPress$)
'
' Display primary math menu
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Template "
        OPT$(2) = " Rescale  "
        OPT$(3) = " Arithme.."
        OPT$(4) = " Fit      "
        OPT$(5) = " Deriv    "
        OPT$(6) = " Area     "
        OPT$(7) = " [More]   "

        GM.NOPT = 7
        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection

          CASE 1
            KeyPress$ = "T"
          CASE 2
            KeyPress$ = "R"
          CASE 3
            KeyPress$ = "<ARITHMETIC_MENU>"
          CASE 4
            KeyPress$ = "<FIT_MENU>"
          CASE 5
            KeyPress$ = "V"
          CASE 6
            KeyPress$ = "A"
          CASE 7
            KeyPress$ = "<MORE>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB MathMenu2 (KeyPress$)
'
'  Display second math menu.
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Sort     "
        OPT$(2) = " Smooth   "
        OPT$(3) = " FFT      "
        OPT$(4) = " Complex  "
        OPT$(5) = " [Back]   "

        GM.NOPT = 5
        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<SORT>"
          CASE 2
            KeyPress$ = "S"
          CASE 3
            KeyPress$ = "<FFT_MENU>"
          CASE 4
            KeyPress$ = "<COMPLEX_MENU>"
          CASE 5
            KeyPress$ = "<PREV>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB ArithmeticMenu (KeyPress$)
'
'  Display plot arithmetic menu.
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Add      "
        OPT$(2) = " Subtract "
        OPT$(3) = " Multiply "
        OPT$(4) = " Divide   "

        GM.NOPT = 4
        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "+"
          CASE 2
            KeyPress$ = "-"
          CASE 3
            KeyPress$ = "*"
          CASE 4
            KeyPress$ = "/"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB FitMenu (KeyPress$)
'
'  Display fit menu.
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Polynom  "
        OPT$(2) = " Lin Com  "
        OPT$(3) = " Errors   "

        GM.NOPT = 1
        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "P"
          CASE 2
            KeyPress$ = "<LC_FIT>"
          CASE 3
            KeyPress$ = "<SET_ERRORS>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB ComplexMenu (KeyPress$)
'
'  Display complex math menu.
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Mag      "
        IF DS(PV(DI.SP1).SET).CMPLX THEN
          OPT$(2) = " Phase    "
          OPT$(3) = " Conj     "
          OPT$(4) = " Real (Y) "
          OPT$(5) = " Imag (Y) "
          GM.NOPT = 5
        ELSE
          OPT$(2) = " Cmpl (Y) "
          GM.NOPT = 2
        END IF

        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<MAG>"
          CASE 2
            IF DS(PV(DI.SP1).SET).CMPLX THEN
              KeyPress$ = "<PHASE>"
            ELSE
              KeyPress$ = "<CMPL(Y)>"
            END IF
          CASE 3
            KeyPress$ = "<CONJ>"
          CASE 4
            KeyPress$ = "<REAL(Y)>"
          CASE 5
            KeyPress$ = "<IMAG(Y)>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB ExitMenu (KeyPress$)

        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Exit      "
        OPT$(2) = " DOS Shell "
        GM.NOPT = 2
        GM.IR1 = 2: GM.IC1 = 7

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<EXIT>"
          CASE 2
            KeyPress$ = "<SHELL>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB FFTMenu (KeyPress$)

        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        OPT$(1) = " Forward   "
        OPT$(2) = " Inverse   "
        GM.NOPT = 2
        GM.IR1 = 2: GM.IC1 = 26

        MenuBox GM, OPT$()
        KeyPress$ = CHR$(2)

        SELECT CASE GM.Selection
          CASE 1
            KeyPress$ = "<FFT0>"
          CASE 2
            KeyPress$ = "<FFT1>"
          CASE ELSE
            '
        END SELECT

END SUB
'
' ---------------------------------------------------------------
'
SUB ButtonMenu (N, KeyPress$)
'
'  Display a mouse button on the graphics screen and wait for
'    input.
'
        STATIC GM AS GraphicsMenu
        DIM OPT$(MaxOpts)

        SELECT CASE N
          CASE 0
            OPT$(1) = " CONTINUE "
            NOPT = 1
          CASE 1
            OPT$(1) = "  YES     "
            OPT$(2) = "  NO      "
            OPT$(3) = "  CANCEL  "
            NOPT = 3
          CASE 2
            OPT$(1) = " CONTINUE "
            OPT$(2) = " CANCEL   "
            NOPT = 2
          CASE ELSE
            OPT$(1) = " OK       "
            NOPT = 1
        END SELECT

        GM.NOPT = NOPT
        GM.IR1 = 2: GM.IC1 = 7

        KeyPress$ = ""
        DO WHILE KeyPress$ = ""
          MenuBox GM, OPT$()
          IF GM.Selection >= 255 THEN
            KeyPress$ = UCASE$(CHR$(GM.Selection - 255))
          ELSEIF GM.Selection = 0 THEN
            KeyPress$ = ""
            EXIT DO
          ELSE
            KeyPress$ = OPT$(GM.Selection)
          END IF
	LOOP

END SUB
