' ***************************************************************
' **                                                           **
' **                                                           **
' **                         XYPLOT                            **
' **                                                           **
' **                       Version 4.1                         **
' **                                                           **
' **                      24 October 1993                      **
' **                                                           **
' ** (C) 1990-1993 Creative Consulting for Research & Education**
' **                                                           **
' ***************************************************************
'
'
' ***************************************************************
' **                    HEADER FILES                           **
' ***************************************************************
'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\MATHLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\GRAPHLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\DOSLIB.INC'
'       $INCLUDE: 'c:\XYPLOT\DEVQB\INCLUDE\XYPLOT.INC'
'
	ON ERROR GOTO ErrorHandler
'

	DEFINT I-N
	DEFSNG A-H, O-Z

	DIM X(MaxPoints) AS SINGLE
	DIM Y(MaxPoints) AS SINGLE

        DIM ResetBase AS INTEGER
        DIM ResetWin AS INTEGER
        DIM ReDraw AS INTEGER
        DIM SkipMouse AS INTEGER
        DIM ReadF AS INTEGER

'  Initialize variables

	ISCN = NO
	InitParameters
	SCREEN SI.N
	ISCN = YES
	SetTextScreen

' Determine starting directory

        GetDrive ID
	GetDirectory SDIR$
        SDIR$ = CHR$(ID + 65) + ":" + SDIR$

        IF StartFile$ = "" THEN
          CopyrightNotice
          KeyPress$ = "N"
        ELSE
          KeyPress$ = "F"
        END IF

OPTIONS:

        NP1 = DI.SP1          ' active plot
        NP2 = DI.SP2          ' operand plot
        NS1 = PV(NP1).SET     ' selected data set 1
        NS2 = PV(NP2).SET     ' second set for two-set operations

        ResetBase = NO
        ResetWin = NO
	ReDraw = YES
	SkipMouse = NO
        ReadF = NO


'  +++++++++++++++++++++++ Select option ++++++++++++++++++++++++


        SpecialKey KeyPress$
        KeyPress$ = UCASE$(KeyPress$)

        SELECT CASE KeyPress$

          CASE "<KEY_HELP>"

            KeyHelp KeyPress$
            IF ASC(KeyPress$) <> ESC AND ASC(KeyPress$) <> RET THEN
	      ReDraw = NO
	      SkipMouse = YES
	    END IF

	  CASE "<RESET>"
	   
            ResetBase = YES          ' force extrema and window reset
            ResetWin = YES

	  CASE "<REDRAW>"
	   
            ReDraw = YES                ' force redraw

          CASE "<INCLUDE>", "I"

            IncludeMenu KeyPress$

          CASE "<DELETE_SET>", CHR$(24)

            DeleteSet X(), Y(), NS1
            IF DB.NSETS = 0 THEN
              KeyPress$ = "N"
              ReDraw = NO
              SkipMouse = YES
            ELSE
              ResetBase = YES
            END IF

          CASE "<DUP>", CHR$(4)

            XDuplicate X(), Y(), NS1

          CASE "<JOIN>", CHR$(10)

            JoinSets X(), Y(), NS1, NS2
            ResetBase = YES

          CASE "<PRUNE>", CHR$(25)

            PruneSet X(), Y(), NS1
            ResetBase = YES

          CASE "<DELETE>", "<INSERT>"

            ErrorDisplay 247
            ReDraw = NO

          CASE CHR$(49) TO CHR$(57)

            N = VAL(KeyPress$)
	    IF N <= DI.NPLOTS THEN
              DI.PLIST = MAX(1, N - 2)
              DI.SP1 = N
	    END IF
	    ReDraw = NO

          CASE CHR$(200) TO CHR$(228)

            N = ASC(KeyPress$) - 199
	    IF N <= DI.NPLOTS THEN
              DI.PLIST = MAX(1, N - 2)
              DI.SP2 = N
	    END IF
	    ReDraw = NO

          CASE "<PALETTE>", "C"

            N = PV(NP1).COL
            SelectColor N
            IF N <> 0 THEN
              PV(NP1).COL = N
            ELSE
              ReDraw = NO
            END IF

          CASE "T"

	    Template X(), Y()
            ResetBase = YES
            ResetWin = YES

	  CASE "A"

            XArea X(), Y(), NS1
	    ReDraw = NO

	  CASE "V"

            XDeriv X(), Y(), NS1
            ResetBase = YES
            ResetWin = YES

	  CASE "P"

            PolynomialFit X(), Y(), NS1

          CASE "<SORT>"

            SortDataSet X(), Y(), NS1

          CASE "<MAG>"

            XMAG X(), Y(), NS1

          CASE "<PHASE>"

            XPHASE X(), Y(), NS1

          CASE "<CONJ>"

            XCONJ X(), Y(), NS1

          CASE "<REAL(Y)>"

            CmpToReal X(), Y(), NS1, -1

          CASE "<IMAG(Y)>"

            CmpToReal X(), Y(), NS1, 0

          CASE "<CMPL(Y)>"

            RealToCmp X(), Y(), NS1

          CASE CHR$(26)

            SetDataToZero X(), Y(), NS1

          CASE CHR$(ESC)

            CORNERS(DI.LEVEL).N = 0
	    IF DI.LEVEL > 1 THEN
	      DI.LEVEL = DI.LEVEL - 1
	      CORNERS(DI.LEVEL).N = 0
	    ELSE
              ResetBase = YES
	    END IF

	  CASE "<BASE>"

            FOR J = 1 TO 5
	      CORNERS(J).N = 0
	    NEXT J
            ResetBase = YES

          CASE "<EXIT_MENU>"

	    ID% = ASC(MID$(SDIR$, 1, 1)) - 65
	    SetDrive ID%
	    SetDirectory SDIR$
            ExitXYPLOT
	    ReDraw = NO

	  CASE "E"

	    EXPAND

	  CASE "F"

	    IF DB.NSETS = MaxDataSets THEN
              ErrorDisplay 234
              ReDraw = NO
	    ELSE
              ReadF = YES
	    END IF

	  CASE "G"

	    IF DI.Grid THEN
              DI.Grid = NO
            ELSE
              DI.Grid = YES
              Grid
	      ReDraw = NO
	    END IF
					 
          CASE "M"

            CALL CHKDRV
	    MouseReset IC
            IF NOT IC THEN
              ErrorDisplay 227
              DI.CMODE = NO
            ELSE
              IF SI.NCOLS > 40 THEN
                DI.CMODE = (DI.CMODE = NO)
              END IF
	    END IF
	    ReDraw = NO

	  CASE "D"

            DropPlot NP1
	    IF DI.NPLOTS = 0 THEN
              KeyPress$ = "<INCLUDE>"
	      ReDraw = NO
	      SkipMouse = YES
	    ELSE
              ResetBase = YES
	    END IF

	  CASE "L"

	    IF (NOT (DI.SCALE) AND (DI.YMIN <= 0)) THEN
              ErrorDisplay 220
              ReDraw = NO
	    ELSE
	      DI.SCALE = (DI.SCALE = NO)
	    END IF

          CASE "<FFT0>", "<FFT1>"

            XFFT X(), Y(), NS1, KeyPress$
            ResetBase = YES
            ResetWin = YES

          CASE "R"

            XScale X(), Y(), NS1
            ResetBase = YES

	  CASE "S"

            XSmooth Y(), NS1
            ResetBase = YES

	  CASE "+", "-", "*", "/"

            PlotArithmetic X(), Y(), NS1, NS2, KeyPress$
            ResetBase = YES

	  CASE "<DIR>"

            ReadF = YES

	  CASE "H"

	    ViewHeader

          CASE "<WORK>"

            SaveWork X(), Y()
            ReDraw = NO

          CASE "<WK1>"

            SaveWK1 X(), Y()
            ReDraw = NO

          CASE "<STORE>"

            StoreData X(), Y(), NS1
	    ReDraw = NO

          CASE "<SAVE_OPTS>", CHR$(15)

             SetSaveOptions

          CASE "<VIEW>"

	    SetTextScreen
	    CLS
            FileView

          CASE "<FILE_MENU>", "<PLOT_MENU>", "<MATH_MENU>", _
               "<SYMBOL_MENU>", "<SET_MENU>", "<FFT_MENU>", _
               "<COMPLEX_MENU>", "<ARITHMETIC_MENU>", _
               "<SAVE_MENU>", "<FIT_MENU>"
            ShowMenu KeyPress$
            ReDraw = NO
            SkipMouse = YES

          CASE "."

            IF PV(NP1).SYM = "P" THEN
               PV(NP1).SYM = "L"
	    ELSE
               PV(NP1).SYM = "P"
	    END IF

          CASE CHR$(32)

            DataCursor X(), Y(), NP1
            ReDraw = NO

          CASE CHR$(RET)

            SetCorners
            KeyPress$ = "E"
            SkipMouse = YES
            ReDraw = NO

	  CASE "N"

            NewSpace JFL
            IF JFL THEN
              ReadF = YES
            ELSE
              ReDraw = NO
            END IF

          CASE CHR$(1)                  ' error handler return

            IF DB.NSETS = 0 THEN
              ReadF = YES
            ELSE
              ResetBase = YES
              ResetWin = YES
            END IF

	  CASE ELSE
	    ReDraw = NO

	END SELECT

' +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'  Read another file?

        IF ReadF THEN
          DO
            FileRead X(), Y(), FType%
          LOOP WHILE (DB.NSETS = 0)
          ResetBase = YES
          IF FType% = 2 THEN
            ResetWin = YES
          END IF
	END IF

'  Reset base window limits?

        IF NOT PlotVisible (DI.SP1) THEN
          ResetBase = YES
          ResetWin = YES
        END IF

        IF ResetBase THEN
          FullWindow
        END IF

'  Reset current plot window limits to base?

        IF ResetWin THEN
          DI.LEVEL = 1
          ReDraw = YES
        END IF

'  ReDraw plot?

        IF TextScreen% THEN ReDraw = YES

	IF ReDraw THEN
	  ScreenPlot X(), Y()
	END IF

' Skip mouse so that another option may be executed?

	IF NOT SkipMouse THEN
          KMouse KeyPress$
          IF KeyPress$ = "" THEN
            IF IBOUND2(DI.IX, DI.IY) THEN
              IF DI.IB = 1 THEN
                KeyPress$ = CHR$(RET)
              ELSEIF DI.IB = 2 THEN
                KeyPress$ = CHR$(32)
              ELSE
                '
              END IF
	    ELSE
	      ButtonRelease             ' wait for button release
              MenuSelection KeyPress$
	    END IF
	  END IF
	END IF

        GOTO OPTIONS
'
' ---------------------------------------------------------------
'
ErrorHandler:


	NUMBER = ERR
	ErrorDisplay NUMBER
	SELECT CASE NUMBER
	  CASE 5
	    IF NOT ISCN THEN
	      Message2
	    END IF
	    END
	  CASE ELSE
	    '
	END SELECT
        KeyPress$ = CHR$(1)
	RESUME OPTIONS
'
'
'  Screen data: nrows, ncols, ncolors, xres, yres
'
'  screens 0 - 13
'
	DATA 25, 80, 16, 80, 25
	DATA 25, 40, 4, 320, 200
	DATA 25, 80, 0, 640, 200
	DATA 25, 80, 0, 720, 348
	DATA 25, 80, 16, 80, 25
	DATA 25, 80, 16, 80, 25
	DATA 25, 80, 4, 640, 350
	DATA 25, 40, 16, 320, 200
	DATA 25, 80, 16, 640, 200
	DATA 25, 80, 16, 640, 350
	DATA 25, 80, 4, 640, 350
	DATA 30, 80, 2, 640, 480
	DATA 30, 80, 16, 640, 480
	DATA 25, 40, 256, 320, 200
'
'  Default color maps
'
'  screens 0 - 13
'
	DATA 1,2,3,4,5,6,7,8,9
	DATA 2,1,3,2,1,3,2,1,3
	DATA 1,1,1,1,1,1,1,1,1
	DATA 1,1,1,1,1,1,1,1,1
	DATA 1,1,1,1,1,1,1,1,1
	DATA 1,1,1,1,1,1,1,1,1
	DATA 1,1,1,1,1,1,1,1,1
	DATA 10,12,11,14,13,6,9,15,8
	DATA 10,12,11,14,13,6,9,15,8
	DATA 10,12,11,14,13,6,9,15,8
	DATA 1,3,1,3,1,3,1,3,1
	DATA 1,1,1,1,1,1,1,1,1
	DATA 10,12,11,14,13,6,9,15,8
	DATA 10,12,11,14,13,6,9,15,8
'
'  Default window colors
'
        DATA 1, 15, 12, 3, 15, 15, 1, 7, 15
        DATA 0, 7, 7, 0, 7, 7, 0, 7, 7
'
' ---------------------------------------------------------------
'
SUB NewSpace (JFL)
'
'  Re-initialize for new workspace. Set flag JFL to true if
'    re-initialized.
'
        IF DB.NSETS <> 0 THEN
          IF NOT WKSaved THEN
            ClearTopLine
            PRINT "CURRENT WORKSPACE NOT SAVED!! CONTINUE? ";
            ButtonMenu 2, KeyPress$
            IF INSTR(KeyPress$, "CONT") <> 0 OR _
              INSTR(KeyPress$, "Y") <> 0 THEN
              JFL = YES
            ELSE
              JFL = NO
              EXIT SUB
            END IF
          END IF
        END IF

        DB.NSETS = 0
        DB.NVALS = 0
        DI.NPLOTS = 0
        DI.SP1 = 1
        DI.SP2 = 1

        JFL = YES

END SUB
'
' ---------------------------------------------------------------
'
SUB CopyrightNotice
'
'  Give opening message.
'
        IF SI.MFLAG THEN
          TextBox 1, 1, 10, 80, 7, 0
        ELSE
          TextBox 1, 1, 10, 80, 15, 4
        END IF
        LOCATE 3, 32
	PRINT "XYPLOT  Ver "; Version$;
        LOCATE 5, 6
        PRINT "Copyright (C) 1990-1993 Creative Consulting for ";
        PRINT "Research & Education"
        LOCATE 6, 31
        PRINT "All rights reserved"

        A$ = "Portions of this program are copyrighted under: " + _
             "Copyright (C) 1986 Numerical Recipes Software"

        COLOR 7, 0
        IF DI.CMODE THEN
          CONTbutn.TopRow = 12 : CONTbutn.LeftCol = 35
          ShowButton CONTbutn
          GetKey KeyPress$, BS%
        ELSE
          LOCATE 12, 25
          PROMPT
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB EXPAND
'
'  Expand Plot
'
	DIM A(10) AS SINGLE

	A(1) = DI.XMIN
	A(2) = DI.YMIN
	A(3) = DI.XMAX
	A(4) = DI.YMAX
        DX = A(3) - A(1)
        DY = A(4) - A(2)
	J = DI.LEVEL + 1
	M = CORNERS(J).N

	SELECT CASE M
	  CASE 0
	    ClearTopLine
	    PRINT "Enter new window limits x1, y1, x2, y2: ";
	    GetInput V$
	    IF (ASC(V$) = RET) OR (ASC(V$) = ESC) THEN EXIT SUB
	    NumberParse A(), N, V$
            IF (FMIN(A(2), A(4)) <= 0) AND DI.SCALE THEN
              ErrorDisplay 220
              EXIT SUB
            END IF
	    IF A(3) < A(1) THEN SWAP A(3), A(1)
	    IF A(4) < A(2) THEN SWAP A(4), A(2)
            IF (A(3) = A(1)) OR (A(4) = A(2)) THEN EXIT SUB  ' error
            CORNERS(J).XMIN = A(1)
	    CORNERS(J).YMIN = A(2)
	    CORNERS(J).XMAX = A(3)
	    CORNERS(J).YMAX = A(4)
	  CASE 1
            ErrorDisplay 226
            EXIT SUB
	  CASE 2
            '
          CASE ELSE
            CORNERS(J).N = 0: EXIT SUB
	END SELECT

        ' Check for too small an expansion region to prevent crash!

        RX = ABS((CORNERS(J).XMAX - CORNERS(J).XMIN)/DX)
        RY = ABS((CORNERS(J).YMAX - CORNERS(J).YMIN)/DY)

        IF (RX < 0.03) OR (RY < 0.03) THEN
          ErrorDisplay 246
          CORNERS(J).N = 0
          EXIT SUB
        END IF

        IF J > 4 THEN
          CORNERS(4) = CORNERS(5)
        ELSE
          DI.LEVEL = J
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB Extrema (X(), Y(), NS)
'
'
'  Find extrema for data set NS
'
        DIM iXMIN AS SINGLE
        DIM iXMAX AS SINGLE
        DIM iYMIN AS SINGLE
	DIM iYMAX AS SINGLE
        DIM iXK AS SINGLE
	DIM iYK AS SINGLE
		
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        JSi = DS(NS).JSi
        JEi = DS(NS).JEi
       
        XMIN = X(JSr)
        YMIN = Y(JSr)
        XMAX = XMIN
        YMAX = YMIN
        iXMIN = X(JSi)
        iXMAX = iXMIN
        iYMIN = Y(JSi)
        iYMAX = iYMIN
'  
' Determine extrema for X
'
        FOR K = JSr TO JEr
	   XK = X(K)
	   IF XK < XMIN THEN XMIN = XK
	   IF XK > XMAX THEN XMAX = XK
	NEXT K

	DS(NS).XMIN = XMIN
	DS(NS).XMAX = XMAX

        IF DS(NS).CMPLX THEN
          FOR K = JSi TO JEi
            iXK = X(K)
            IF iXK < iXMIN THEN iXMIN = iXK
            IF iXK > iXMAX THEN iXMAX = iXK
          NEXT K

          DS(NS).iXMIN = iXMIN
          DS(NS).iXMAX = iXMAX
        END IF
'
' Determine extrema for Y
'
        FOR K = JSr TO JEr
          YK = Y(K)
          IF YK < YMIN THEN YMIN = YK
          IF YK > YMAX THEN YMAX = YK
        NEXT K

        DS(NS).YMIN = YMIN
        DS(NS).YMAX = YMAX

        IF DS(NS).CMPLX THEN
          FOR K = JSi  TO JEi
            iYK = Y(K)
	    IF iYK < iYMIN THEN iYMIN = iYK
	    IF iYK > iYMAX THEN iYMAX = iYK
	  NEXT K
	  DS(NS).iYMIN = iYMIN
	  DS(NS).iYMAX = iYMAX
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB FileRead (X(), Y(), FType%)
'
'  FType% = 0 for no file read; 1 for workspace; 2 for data set file.
'
        SetTextScreen
        FSpec$ = "*.*"
        FType% = 0
FR1:
        IF StartFile$ = "" THEN
          Message1
          P$ = "Select the file >> "
          IX = 20
          IY = 22

          SelectFile FSpec$, DI.CMODE, P$, FL$, IX, IY, BS%

          IF IY < 3 AND BS% <> 0 THEN
            IF IX < 30 THEN
              FL$ = "<DIR>"
            ELSEIF IX < 60 THEN
              FL$ = "<VIEW>"
            ELSE
              FL$ = CHR$(ESC)
            END IF
          END IF
        ELSE
          FL$ = StartFile$
          StartFile$ = ""
        END IF

        IF FL$ = "<VIEW>" THEN
          FileView
          FSpec$ = "*.*"
          GOTO FR1
        ELSEIF FL$ = "<DIR>" THEN
          DirectorySet DIR$
          FSpec$ = "*.*"
          GOTO FR1
        ELSEIF INSTR(CHR$(0)+"<", MID$(FL$, 1, 1)) <> 0 THEN
          SOUND 500, 3
          GOTO FR1
        ELSEIF FL$ = "" THEN
          GOTO FR1
        ELSE
          '
        END IF

        IF FL$ = CHR$(ESC) THEN
          IF DB.NSETS = 0 THEN
            ExitXYPLOT
          END IF
          EXIT SUB
        END IF

        IF FL$ = CHR$(RET) THEN
          Template X(), Y()
          EXIT SUB
        END IF

        FL$ = TRIM$(FL$)
        FL$ = UCASE$(FL$)

' set default extension if not specified

        IF INSTR(FL$, ".") = 0 THEN
          IF FileExists(FL$ + ".XSP") THEN
            FL$ = FL$ + ".XSP"
          ELSE
            IF FileExists(FL$ + ".DAT") THEN
              FL$ = FL$ + ".DAT"
            ELSE
              ErrorDisplay 53
              EXIT SUB
            END IF
          END IF
        END IF

        IF SI.MFLAG THEN
          TextBox 1, 1, 3, 80, 0, 7
        ELSE
          TextBox 1, 1, 3, 80, 0, 2
        END IF
	LOCATE 2, 18
	PRINT "Reading "; FL$; " - One moment please ...";

        IF INSTR(FL$, ".XSP") <> 0 THEN
          IF DB.NSETS <> 0 THEN
            ErrorDisplay 235
            EXIT SUB
          END IF
          ReadWork X(), Y(), FL$
          FType% = 1
          EXIT SUB
        END IF

        FType% = 2

        IF DB.NSETS = 0 THEN
          JSr = 1
	ELSE
          JSr = DS(DB.NSETS).JEi + 1
	END IF

        XYREAD X(), Y(), NPTS, DataType%, JSr, JEi, IERR, FL$, HDR$

        IF IERR <> 0 THEN
          ErrorDisplay IERR
          EXIT SUB
        END IF

        LOCATE 2, 18
	PRINT SPACE$(60);
	LOCATE 2, 18
	PRINT FL$; " contains "; NPTS; " points";
        IF DI.CMODE THEN
          CANCbutn.TopRow = 23 : CANCbutn.LeftCol = 25
          CONTbutn.TopRow = 23 : CONTbutn.LeftCol = 43
          CANCbutn.NROWS = 2 : CONTbutn.NROWS = 2
          ShowButton CANCbutn
          ShowButton CONTbutn
        ELSE
          COLOR 7, 0
          LOCATE 24, 25
          PRINT "<<Press a key to continue>>";
        END IF

        DisplayHeader HDR$, KeyPress$, 10, 22

        IF KeyPress$ = CHR$(ESC) OR KeyPress$ = "CANCEL" THEN
          TextBox 19, 1, 25, 80, 0, 0
          GOTO FR1
        END IF

        AddNewSet X(), Y(), JSr, JEi, DataType%, FL$, HDR$, NS
        AddNewPlot NS, Dsym$, NP

END SUB
'
' ---------------------------------------------------------------
'
SUB FileView
'
'  Select file and view contents
'
        SetTextScreen
        DO
          FSpec$ = "*.*"
          CANCbutn.NROWS = 2: CANCbutn.TopRow = 23: CANCbutn.LeftCol = 36
          IF DI.CMODE THEN
            ShowButton CANCbutn
          ELSE
            LOCATE 24, 1
            PRINT TAB(31); "<<Press ESC to exit>>";
          END IF
          TextBox 1, 1, 3, 80, CI.FWA, 0
          LOCATE 2, 30
          PRINT "VIEW FILE"
          P$ = "Select the file >> "
          IX = 20
          IY = 22

          SelectFile FSpec$, DI.CMODE, P$, FL$, IX, IY, BS%

          IF FL$ = "CANCEL" OR FL$ = CHR$(ESC) OR FL$ = CHR$(RET) THEN
            EXIT SUB
          END IF

          IF INSTR(FL$, ".") = 0 THEN FL$ = FL$ + ".DAT"
          DisplayFile FL$

	LOOP

END SUB
'
' ---------------------------------------------------------------
'
SUB FullWindow
'
' set base expansion level to the full window, i.e. min and max
'   values for all visible plots.
'

        ' Find first visible plot

	J = 0

	DO
	  J = J + 1
	LOOP WHILE (PV(J).VIS = NO AND J < DI.NPLOTS)

	I = PV(J).SET

	SELECT CASE PV(J).VIS
	  CASE 1
	    XMIN = DS(I).XMIN: XMAX = DS(I).XMAX
	    YMIN = DS(I).YMIN: YMAX = DS(I).YMAX
	  CASE 2
	    XMIN = DS(I).XMIN: XMAX = DS(I).XMAX
	    YMIN = DS(I).iYMIN: YMAX = DS(I).iYMAX
	  CASE ELSE
	    '
	END SELECT

	FOR K = J TO DI.NPLOTS
	   I = PV(K).SET
	   SELECT CASE PV(K).VIS
	     CASE 0
	       ' plot not visible
	     CASE 1
	       XMIN = FMIN(XMIN, DS(I).XMIN)
	       XMAX = FMAX(XMAX, DS(I).XMAX)
	       YMIN = FMIN(YMIN, DS(I).YMIN)
	       YMAX = FMAX(YMAX, DS(I).YMAX)
	     CASE 2
	       XMIN = FMIN(XMIN, DS(I).XMIN)
	       XMAX = FMAX(XMAX, DS(I).XMAX)
	       YMIN = FMIN(YMIN, DS(I).iYMIN)
	       YMAX = FMAX(YMAX, DS(I).iYMAX)
	     CASE ELSE
	       '
	   END SELECT

	NEXT K

        IF XMIN = XMAX THEN                     ' prevent divide by zero
          XMIN = XMIN - 1 : XMAX = XMAX + 1
        END IF
        IF YMIN = YMAX THEN
          YMIN = YMIN - 1 : YMAX = YMAX + 1
        END IF

        CORNERS(1).XMIN = XMIN
	CORNERS(1).XMAX = XMAX
	CORNERS(1).YMIN = YMIN
	CORNERS(1).YMAX = YMAX

END SUB
'
' ---------------------------------------------------------------
'
SUB Grid
'
'
'       ++++++++        Draw Grid       +++++++++
'
				      
        BOX SI.IX1, SI.IY1, SI.IX2, SI.IY2, 15

' Draw Tic Marks

	IXD = SI.IX2 - SI.IX1
	IYD = SI.IY2 - SI.IY1
	IXL = IXD / 50
	IYL = IYD / 50
	YL1 = LOG(SI.IY1)
	YLD = LOG(SI.IY2) - YL1

        FOR K = 1 TO 9
          IXT = SI.IX1 + K * IXD / 10
	  IYT = K * IYD / 10

	  IF DI.SCALE THEN
	    IYT = INT((LOG(IYT + SI.IY1) - YL1) * IYD / YLD)
	  END IF

	  IYT = SI.YINV - IYT
          LINE (IXT, SI.IY1)-(IXT, SI.IY1 + IYL), 15
          LINE (IXT, SI.IY2)-(IXT, SI.IY2 - IYL), 15
          LINE (SI.IX1, IYT)-(SI.IX1 + IXL, IYT), 15
          LINE (SI.IX2, IYT)-(SI.IX2 - IXL, IYT), 15

	  IF DI.Grid THEN

	     FOR M = SI.IY1 TO SI.IY2 STEP 4
		PSET (IXT, M), 7
	     NEXT M

	     FOR M = SI.IX1 TO SI.IX2 STEP 4
		PSET (M, IYT), 7
	     NEXT M
	  END IF
	NEXT K

	IF DI.Grid THEN
	   IF (DI.XMIN < 0!) AND (DI.XMAX > 0!) THEN
	      Coordinates 0!, DI.YMAX, IXT, IYT, 0
	      LINE (IXT, SI.IY1)-(IXT, SI.IY2), 15
	   END IF

	   IF (DI.YMIN < 0!) AND (DI.YMAX > 0!) THEN
	      Coordinates DI.XMAX, 0!, IXT, IYT, 0
	      LINE (SI.IX1, IYT)-(SI.IX2, IYT), 15
	   END IF
	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB InitializeGraphics
'
'
	SCREEN SI.N
	J = DI.LEVEL
	DI.XMIN = CORNERS(J).XMIN
	DI.XMAX = CORNERS(J).XMAX
	DI.YMIN = CORNERS(J).YMIN
	DI.YMAX = CORNERS(J).YMAX
	IXD = SI.IX2 - SI.IX1
	IYD = SI.IY2 - SI.IY1
	DI.XSF = IXD / (DI.XMAX - DI.XMIN)
	DI.YSF = IYD / (DI.YMAX - DI.YMIN)

        IF (CORNERS(1).YMIN > 0) AND (DI.YMIN > 0) THEN
	  DI.YLSF = IYD / (LOG(DI.YMAX) - LOG(DI.YMIN))
	  DI.LYMIN = LOG(DI.YMIN)
	ELSE
	  DI.SCALE = 0       ' auto disable of log scale if ymin <= 0
	END IF
	CLS 0

END SUB
'
' ---------------------------------------------------------------
'
SUB InitParameters
'
'  Determine if mouse is present
'
	CALL CHKDRV
	MouseReset DI.CMODE

'  Default values for screen mode, cursor size, plotting symbol, etc.

        SI.N = 9                ' ega mode 640x350
        SI.MFLAG = NO           ' color monitor
        DI.PLIST = 1            '
        DI.CSIZE = 3            '
        DI.LEVEL = 1            '
        DI.Grid = NO            ' no grid
        DI.SCALE = NO           ' linear scale
        DI.SP1 = 1              ' active plot
        DI.SP2 = 1              ' operand plot
        DB.NSETS = 0            ' number of sets in database
        DB.NVALS = 0            ' number of x, y pairs
        MI.ErrType = 1          ' specified error type
        MI.Sigma = 1!           '
        WKsaved = YES           '
        Dsym$ = DefaultSymbol$  '
        Pcolors$ = ""           '
        Wcolors$ = ""           '
        VI.HS = YES             ' default save with header
        VI.FM = "E"             '              exponential format
        VI.DL = " "             '              space delimiter

'  Analyze command string for filename

	CL$ = COMMAND$
	CL$ = TRIM$(CL$)
        StartFile$ = CL$

'  Read initialization file (xyplot.ini)

        ReadIniFile Pcolors$, Wcolors$

'  Read screen data and store for selected mode

	FOR J = 0 TO 13
	  READ IA, IB, IC, ID, IE
	  IF J = SI.N THEN
	    SI.NROWS = IA
	    SI.NCOLS = IB
	    SI.NCOLORS = IC
	    SI.XRES = ID
	    SI.YRES = IE
	  END IF
	NEXT J

' mouse not used if screen is less than 80 columns wide

	IF SI.NCOLS < 80 THEN DI.CMODE = 0

	SI.NCPIX = SI.XRES / SI.NCOLS
	SI.NRPIX = SI.YRES / SI.NROWS

'  Set display area so that its horizontal and vertical pixel counts
'    are multiples of 10 (for known graphics screens)

	SELECT CASE SI.XRES
	  CASE 320
	    SI.IX1 = 50
	    SI.IX2 = 270
	  CASE 640
	    SI.IX1 = 50
	    SI.IX2 = 590
	  CASE 720
	    SI.IX1 = 55
	    SI.IX2 = 665
	  CASE ELSE
	    SI.IX1 = 6 * SI.NCPIX
	    SI.IX2 = SI.XRES - SI.IX1
	END SELECT

	SELECT CASE SI.YRES
	  CASE 200
	    SI.IY1 = 15
	    SI.IY2 = 185
	  CASE 348
	    SI.IY1 = 25
	    SI.IY2 = 325
	  CASE 350
	    SI.IY1 = 25
	    SI.IY2 = 325
	  CASE 480
	    SI.IY1 = 25
	    SI.IY2 = 455
	  CASE ELSE
	    SI.IY1 = 3 * SI.NRPIX / 2
	    SI.IY2 = SI.YRES - SI.IY1
	END SELECT

	SI.YINV = SI.YRES - SI.IY1
	IF DI.CMODE THEN
	  MouseLimits 0, 0, SI.XRES, SI.YRES
	END IF

' Set plot colors and default window colors

        SetColors Pcolors$, Wcolors$

' Set default visibility and plotting symbols

	FOR J = 1 TO MaxPlots
	  PV(J).VIS = 1
          PV(J).SYM = Dsym$
	NEXT J

	DI.IX = (SI.IX1 + SI.IX2) / 2
	DI.IY = (SI.IY1 + SI.IY2) / 2

' Setup action buttons

        CANCbutn.Active = 1
        HELPbutn.Active = 1
        CONTbutn.Active = 1
        NEXTbutn.Active = 1
        PREVbutn.Active = 1
        OKbutn.Active = 1

        CANCbutn.NCOLS = 12  : CANCbutn.NROWS = 4
        HELPbutn.NCOLS = 12  : HELPbutn.NROWS = 4
        CONTbutn.NCOLS = 12  : CONTbutn.NROWS = 4
        NEXTbutn.NCOLS = 12  : NEXTbutn.NROWS = 4
        PREVbutn.NCOLS = 12  : PREVbutn.NROWS = 4
        OKbutn.NCOLS = 12 : OKbutn.NROWS = 4

        IF SI.MFLAG THEN
          CANCbutn.Foreground = 15 : CANCbutn.Background = 0
          HELPbutn.Foreground = 15 : HELPbutn.Background = 0
          CONTbutn.Foreground = 15 : CONTbutn.Background = 0
          NEXTbutn.Foreground = 15 : NEXTbutn.Background = 0
          PREVbutn.Foreground = 15 : PREVbutn.Background = 0
          OKbutn.Foreground = 15 : OKbutn.Background = 0
        ELSE
          CANCbutn.Foreground = 15 : CANCbutn.Background = 4
          HELPbutn.Foreground = 15 : HELPbutn.Background = 2
          CONTbutn.Foreground = 15 : CONTbutn.Background = 3
          NEXTbutn.Foreground = 15 : NEXTbutn.Background = 1
          PREVbutn.Foreground = 15 : PREVbutn.Background = 1
          OKbutn.Foreground = 15 : OKbutn.Background = 2
        END IF

        CANCbutn.ButtonText = "CANCEL"
        HELPbutn.ButtonText = "HELP"
        CONTbutn.ButtonText = "CONTINUE"
        NEXTbutn.ButtonText = "NEXT"
        PREVbutn.ButtonText = "PREVIOUS"
        OKbutn.ButtonText = " OK "

END SUB
'
' ---------------------------------------------------------------
'
SUB KMouse (KeyPress$)
'
'
'  Print plot list on status line
'
	IF SI.NCOLS > 40 THEN
          ClearTopLine
	  XColor 3
	  LOCATE 1, 1: PRINT "      File     Plot      Math      < >   ";
          XColor 4
          IF DI.LEVEL > 1 THEN
            LOCATE 1, 37: PRINT "*";
          END IF
	END IF

        PlotList
        XColor 7

	IF DI.CMODE THEN                        ' use real mouse
	   IC = 55
           XF$ = FormD$(DI.XMIN, DI.XMAX)
           YF$ = FormD$(DI.YMIN, DI.YMAX)
	   FF$ = XF$ + " " + YF$

           PutMouse DI.IX, DI.IY
	   ShowMouse

           KeyPress$ = ""
           BS% = 0: IXOLD = 0: IYOLD = 0

           WHILE ((BS% = 0) AND (KeyPress$ = ""))
              GetMousePosition IX, IY, BS%
              IF IBOUND2(IX, IY) THEN
                IF ICURSOR(2, 2) <> 256 THEN
                  CrosshairCursor
                END IF
                IF ((IX <> IXOLD) OR (IY <> IYOLD)) THEN
                  Coordinates XX, YY, IX, IY, -1     ' update cursor posn
                  LOCATE 1, IC: PRINT USING FF$; XX; YY
                END IF
              ELSE
                IF ICURSOR(2, 2) <> &H4000 THEN ArrowCursor
              END IF

              IXOLD = IX: IYOLD = IY
              KeyPress$ = INKEY$
	   WEND

'  button has been pressed.

           DI.IX = IX: DI.IY = IY: DI.IB = BS%
           ArrowCursor
           HideMouse

	ELSE                        ' keypad mouse
           KeypadMouse KeyPress$
	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB Labels
'
'  Label axes
'
	IX1 = SI.IX1
	IY1 = SI.IY1
	IXD = SI.IX2 - IX1
	IYD = SI.IY2 - IY1
	YL1 = LOG(IY1)
	YLD = LOG(SI.IY2) - YL1
        XF$ = FormL$(DI.XMIN, DI.XMAX, "X")
        YF$ = FormL$(DI.YMIN, DI.YMAX, "Y")

	XColor 15
	ISKIP = 2

	IF SI.NCOLS < 80 THEN
	   IF LEN(XF$) > 5 THEN ISKIP = 5
	ELSE
	   IF LEN(XF$) >= 10 THEN ISKIP = 5
	END IF

	FOR J = 0 TO 10 STEP 2
	   IY = J * IYD / 10

	   IF DI.SCALE AND (J <> 0) THEN
              IY = INT((LOG(IY + IY1) - YL1) * IYD / YLD)
	   END IF

	   IY = SI.YINV - IY
           IROW = 1 + INT(IY / SI.NRPIX)
           IF IROW > (SI.NROWS - 2) THEN IROW = IROW - 1
           IF IROW < 3 THEN IROW = IROW + 1

	   Coordinates XX, YY, IX1, IY, -1
	   LOCATE IROW, 1
	   PRINT USING YF$; YY;
	NEXT J

	FOR J = 0 TO 10 STEP ISKIP
	   IX = IX1 + J * IXD / 10
           ICOL = INT(IX / SI.NCPIX) - LEN(XF$) / 2
           IF ICOL < 3 THEN ICOL = 3
	   IF (ICOL + LEN(XF$)) > SI.NCOLS THEN
	      ICOL = SI.NCOLS - LEN(XF$)
	   END IF

	   Coordinates XX, YY, IX, IY1, -1
	   LOCATE SI.NROWS, ICOL
	   PRINT USING XF$; XX;
	NEXT J

END SUB
'
' ---------------------------------------------------------------
'
SUB PlotList
'
'  Print plot list on status line, showing currently selected plot
'
        IF DI.NPLOTS > 1 THEN

	  IF SI.NCOLS > 40 THEN
	    JOFFSET = 43
	  ELSE
	    JOFFSET = 1
	  END IF

	  LOCATE 1, JOFFSET
	  PRINT SPACE$(9);

	  FOR J = 0 TO 2
	    LOCATE 1, JOFFSET + 2 + 2 * J
	    J1 = DI.PLIST + J

	    IF DI.NPLOTS >= J1 THEN
	      XColor PV(J1).COL
	      PRINT LTRIM$(STR$(J1));
	    END IF

	  NEXT J

          ICOL1 = 2 * (DI.SP1 - DI.PLIST)
          ICOL2 = 2 * (DI.SP2 - DI.PLIST)

' Indicate operand plot

          IF (ICOL2 >= 0) AND (ICOL2 < 5) THEN
            ICOL2 = ICOL2 + 2 + JOFFSET
            XColor 7
            LOCATE 1, ICOL2 - 1
	    PRINT "(";
            LOCATE 1, ICOL2 + 1
	    PRINT ")";
	  END IF

' Indicate active plot

          IF (ICOL1 >= 0) AND (ICOL1 < 5) THEN
            ICOL1 = ICOL1 + 2 + JOFFSET
            PixelPosition 1, ICOL1, SI.NCPIX, SI.NRPIX, IX, IY
            BOX IX, IY, IX + SI.NCPIX, IY + SI.NRPIX - 1, 15
	  END IF

	  XColor PV(1).COL

	  IF DI.PLIST > 1 THEN
	    LOCATE 1, JOFFSET
	    PRINT CHR$(17);
	  END IF

	  IF (DI.PLIST + 2) < DI.NPLOTS THEN
	    LOCATE 1, JOFFSET + 8
	    PRINT CHR$(16);
	  END IF

	END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB SelectColor (N)
'
'  Display palette of colors and allow user to select.
'
        ClearTopLine
        FOR J = 1 TO 15
          PixelPosition 1, J, SI.NCPIX, SI.NRPIX, IX, IY
          IX = IX + SI.NCPIX/2
          IY = IY + SI.NRPIX/2
          CIRCLE (IX, IY), SI.NCPIX / 2, 7
          PAINT (IX, IY), J, 7
        NEXT J

        DO
          PixelPosition 1, N, SI.NCPIX, SI.NRPIX, IX, IY
          Box IX, IY, IX + SI.NCPIX, IY + SI.NRPIX, 15
          IF DI.CMODE THEN
            ShowMouse
            PutMouse IX + SI.NCPIX/2, IY + SI.NRPIX/2
          END IF
          BS% = 0
          DO
            IF DI.CMODE THEN GetMousePosition IXM, IYM, BS%
            KeyPress$ = INKEY$
          LOOP WHILE (BS% = 0 AND KeyPress$ = "")
          IF DI.CMODE THEN HideMouse
          Box IX, IY, IX + SI.NCPIX, IY + SI.NRPIX, 0
          IF KeyPress$ <> "" THEN
            SpecialKey KeyPress$
            SELECT CASE KeyPress$
              CASE "<LEFT>"
                N = MAX (1, N - 1)
              CASE "<RIGHT>"
                N = MIN (N + 1, 15)
              CASE CHR$(RET)
                EXIT DO
              CASE CHR$(ESC)
                N = 0
                EXIT DO
              CASE ELSE
                '
            END SELECT
          ELSE
            ButtonRelease
            IF (IYM <= SI.NRPIX) THEN
              ConvertToRC IXM, IYM
              N = MIN (IXM, 15)
              EXIT DO
            END IF
          END IF
        LOOP

END SUB
'
' ---------------------------------------------------------------
'
SUB PXY (X(), Y(), NP)
'
'
'  Display plot NP
'
' If plot visibility is set to 0, then exit without plotting.
'
        IF PV(NP).VIS = 0 THEN EXIT SUB

	NS = PV(NP).SET
        JSr = DS(NS).JSr
        JEr = DS(NS).JEr
        JSi = DS(NS).JSi
        JEi = DS(NS).JEi
        DataType% = DS(NS).CMPLX

' If plot not visible in display window, then exit subroutine

        IF NOT PlotVisible (NP) THEN EXIT SUB

' Determine indices in X() array for beginning and end of visible region

        IndexLimits X(), DI.XMIN, DI.XMAX, JSr, JEr, JX1, JX2, IERR

        IF JX1 > JSr THEN JX1 = JX1 - 1
        IF JX2 < JEr THEN JX2 = JX2 + 1
        IF PV(NP).VIS > 1 THEN
          JY1 = JX1 - JSr + JSi
        ELSE
          JY1 = JX1
        END IF

        IC = PV(NP).COL
        IF SI.MFLAG THEN IC = 7
        Sym$ = PV(NP).SYM

        IF Sym$ = "B" THEN
          PointPlot X(), Y(), JX1, JX2, JY1, 3, IC
        ELSEIF Sym$ = "P" THEN
          PointPlot X(), Y(), JX1, JX2, JY1, 1, IC
        ELSEIF Sym$ = "L" THEN
          LinePlot X(), Y(), JX1, JX2, JY1, 0, IC
        ELSEIF Sym$ = "R" THEN
          LinePlot X(), Y(), JX1, JX2, JY1, -1, IC
        ELSEIF Sym$ = "+" THEN
          PointPlot X(), Y(), JX1, JX2, JY1, 1, IC
          LinePlot X(), Y(), JX1, JX2, JY1, 0, IC
        ELSEIF Sym$ = "S" THEN
          StickPlot X(), Y(), JX1, JX2, JY1, IC
        ELSE
          '
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB AddNewPlot (NS, SYM$, NP)
'
'  Create a new plot in the display with set NS. Plotting
'    symbol is set to SYM$ and new plot number is returned in NP
'
        IF DI.NPLOTS = MaxPlots THEN
          ErrorDisplay 231
          EXIT SUB
        END IF

        DI.NPLOTS = DI.NPLOTS + 1
        NP = DI.NPLOTS
        DI.SP1 = NP
        DI.PLIST = MAX(1, NP - 2)

        IF SYM$ <> "" THEN PV(NP).SYM = SYM$
        PV(NP).SET = NS
        PV(NP).VIS = 1
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB DropPlot (NP)
'
'  Drop plot NP from plot list. Note that data set corresponding
'    to plot NP remains in database until deleted with REMOVE.
'

        IF NP = DI.NPLOTS THEN
          DI.SP1 = MAX(1, NP - 1)
	ELSE
	  JC = PV(NP).COL         ' save color value

	  JP = DI.NPLOTS - 1

	  FOR K = NP TO JP    ' move up plots to fill vacated space
	    PV(K) = PV(K + 1)
	  NEXT K
	 
	  PV(DI.NPLOTS).COL = JC    ' set old color to color of next plot
          PV(DI.NPLOTS).VIS = 0
	END IF

	DI.NPLOTS = DI.NPLOTS - 1
        WKSaved = NO

END SUB
' ---------------------------------------------------------------
'
SUB AddNewSet (X(), Y(), J1, J2, CMPLX%, FL$, HDR$, NS)
'
'  Update database to keep track of new data set. Set all required
'    data set parameters and determine extrema. Return the new
'    set number in NS.
'  Input Parameters:
'      J1 and J2 are the start and end indices in X(), Y() arrays.
'      CMPLX% is an integer flag (TRUE when data set is complex).
'      FL$ is the filename associated with data set.
'      HDR$ is the new data set's header.
'
        IF DB.NSETS = MaxDataSets THEN
          ErrorDisplay 234                      ' too many data sets
          EXIT SUB
        END IF
        NVALS = J2 - J1 + 1
        IF (DB.NVALS + NVALS) > MaxPoints THEN
          ErrorDisplay 238                       ' too many values
          EXIT SUB
        END IF

        NS = DB.NSETS + 1
        DB.NSETS = NS
        DB.NVALS = DB.NVALS + NVALS

        IF CMPLX% THEN
          NPTS = NVALS / 2
        ELSE
          NPTS = NVALS
        END IF

        DS(NS).CMPLX = CMPLX%
        DS(NS).NPTS = NPTS
        DS(NS).JSr = J1
        DS(NS).JEi = J2
        DS(NS).JEr = J1 + NPTS - 1
        IF CMPLX% THEN
          DS(NS).JSi = DS(NS).JEr + 1
        ELSE
          DS(NS).JSi = DS(NS).JSr
        END IF
        DS(NS).FNAME = FL$
        DS(NS).HDR = HDR$

        Extrema X(), Y(), NS
        WKSaved = NO

END SUB
'
' ---------------------------------------------------------------
'
SUB ScreenPlot (X(), Y())
'
'   +++++++++  Redo last screen plot   +++++++++

	InitializeGraphics
	Grid
	Labels

        IF DI.NPLOTS <> 0 THEN
          FOR J = 1 TO DI.NPLOTS
            PXY X(), Y(), J
          NEXT J
        END IF

END SUB
'
' ---------------------------------------------------------------
'
SUB SetColors (Pcolors$, Wcolors$)
'
'  Set colors for screen mode SI.N
'
'    Pcolors$ is a string containing user set plot colors.
'    Wcolors$ is a string containing user set window colors.
'
	DIM IA(9) AS INTEGER
	DIM A(9) AS SINGLE

'  Read default color maps

	N = SI.N

	FOR J = 0 TO 13
	   FOR K = 1 TO MaxPlots
	      READ IA(K)
	   NEXT K
	   IF J = N THEN
	      FOR K = 1 TO MaxPlots
		 A(K) = IA(K)
	      NEXT K
	   END IF
	NEXT J

'  Replace default list with user specified colors for valid screen modes

	K = ((N = 2) OR (N = 11) OR (N = 10))

        IF NOT K AND Pcolors$ <> "" THEN
           NumberParse A(), M, Pcolors$
	END IF

'  Set colors

	FOR K = 1 TO MaxPlots
	   PV(K).COL = INT(A(K))
	NEXT K
'
'
'     Default colors for directory window, file view window,
'       and header view window if not monochrome monitor.
'
        FOR J = 1 TO 9
          READ IA(J)
          A(J) = IA(J)
        NEXT J
        IF SI.MFLAG THEN
          FOR J = 1 TO 9
            READ IA(J)
          NEXT J
        ELSE
          FOR J = 1 TO 9
            READ K
          NEXT J
        END IF

        IF Wcolors$ <> "" AND NOT SI.MFLAG THEN
          NumberParse A(), M, Wcolors$
          FOR J = 1 TO 9
            IA(J) = INT(A(J))
          NEXT J
        END IF

        CI.DWB = IA(1)            ' directory window colors
        CI.DWF = IA(2)
        CI.DWA = IA(3)
        CI.HWB = IA(4)            ' header view window colors
        CI.HWF = IA(5)
        CI.HWA = IA(6)
        CI.FWB = IA(7)            ' file view window colors
        CI.FWF = IA(8)
        CI.FWA = IA(9)


END SUB
'
' ---------------------------------------------------------------
'
SUB SetCorners
'


        J = DI.LEVEL + 1
        IX1 = DI.IX : IY1 = DI.IY

'  Draw a cross to mark expansion corner if mouse not present

	IF NOT DI.CMODE THEN
	   JS = 2 * DI.CSIZE
           DrawCross IX1, IY1, JS, 15
	END IF

        ExpansionBox IX1, IY1, IX2, IY2, SI.XRES, SI.YRES, DI.CMODE

        IF (IX1 = IX2) OR (IY1 = IY2) THEN
          CORNERS(J).N = 0
          EXIT SUB
        END IF

        Coordinates XMIN, YMIN, IX1, IY1, -1
        Coordinates XMAX, YMAX, IX2, IY2, -1
        IF XMAX < XMIN THEN SWAP XMIN, XMAX
        IF YMAX < YMIN THEN SWAP YMIN, YMAX
        CORNERS(J).XMIN = XMIN
        CORNERS(J).YMIN = YMIN
        CORNERS(J).XMAX = XMAX
        CORNERS(J).YMAX = YMAX
        CORNERS(J).N = 2
        DI.IX = (IX2 + IX1) / 2
        DI.IY = (IY2 + IY1) / 2

END SUB
'
' ---------------------------------------------------------------
'
SUB ShowDir (FSpec$)
'
'  Display Directory in standard position.
'
        DisplayDirectory FSpec$, 4, 16, CI.DWF, CI.DWB, CI.DWA

END SUB
'
' ---------------------------------------------------------------
'
SUB ViewHeader
'
	SetTextScreen
	CLS

        IF SI.MFLAG THEN
          TextBox 1, 1, 5, 80, 7, 0
        ELSE
          TextBox 1, 1, 5, 80, 3, 0
        END IF
        LOCATE 2, 35
        PRINT "VIEW HEADER"
        PREVbutn.TopRow = 23 : PREVbutn.LeftCol = 15
        PREVbutn.NROWS = 2
        NEXTbutn.TopRow = 23 : NEXTbutn.LeftCol = 30
        NEXTbutn.NROWS = 2
        CANCbutn.TopRow = 23 : CANCbutn.LeftCol = 45
        CANCbutn.NROWS = 2
        IF DI.CMODE THEN
          ShowButton PREVbutn
          ShowButton NEXTbutn
          ShowButton CANCbutn
        ELSE
          COLOR 15
          LOCATE 24, 1
          PRINT TAB(31); "Press ESC to exit.";
          LOCATE 4, 24
          PRINT "Use "; CHR$(24); " and "; CHR$(25); " keys to change plots."
        END IF

        NP = DI.SP1

	DO
	  NS = PV(NP).SET
          COLOR 15, 0
          LOCATE 6, 1 : PRINT SPACE$(80); : LOCATE 6, 1
          PRINT "Plot: "; : XCOLOR PV(NP).COL : PRINT NP
          COLOR 15 : LOCATE 6, 12
          PRINT "Data Set: "; : COLOR 7: PRINT NS
          COLOR 15 : LOCATE 6, 27
          PRINT "Type: "; : COLOR 7
	  IF DS(NS).CMPLX THEN
	    PRINT "Complex"
	  ELSE
	    PRINT "Real"
	  END IF
          COLOR 15 : LOCATE 6, 42
          PRINT "File: "; : COLOR 7
	  PRINT DS(NS).FNAME
	  LOCATE 6, 65
	  PRINT DS(NS).NPTS; " points"
       
	  HDR$ = RTRIM$(DS(NS).HDR)
          DisplayHeader HDR$, KeyPress$, 7, 22
          SpecialKey KeyPress$
          SELECT CASE KeyPress$
            CASE "<UP>", "PREVIOUS"
              NP = MAX(1, NP - 1)
            CASE "<DOWN>", "NEXT"
              NP = MIN(DI.NPLOTS, NP + 1)
            CASE CHR$(ESC), "CANCEL"
              EXIT SUB
            CASE ELSE
              '
          END SELECT
	LOOP

END SUB
