\ anim1.4th
\
\ Simple animation demo for xyplot
\ Copyright (c) 1999 Krishna Myneni
\
\ Create a new dataset, its plot, and animate it
\ by translation and modulation.
\


create dsanim 8 4 * allot
create planim 8 4 * allot
create anim_xydata 200 2 * 4 * allot

\ Fill out a dataset info structure on the new set

" Animation" 1+ dsanim DNAME + ! \ name of new dataset
" Example of creating and animating a dataset" 1+ dsanim DHEADER + !
0 dsanim DTYPE + !		\ real dataset
200 dsanim DNPTS + !		\ 200 points in the set
2 dsanim DSIZE + !		\ dimension is 2 (x, y)
anim_xydata dsanim DDATA + !	\ pointer to data

\ Fill out a plot info structure on the new plot

0 planim PDSET + !		\ dataset number (assume it is first set)
0 planim PTYPE + !		\ plot type
1 planim PSYM + !		\ plot symbol
2 planim PCOLOR + !		\ plot color


: set_anim_data ( -- | initialize data buffer with 200 pts of y=x/10 )
	\ x goes from -10 to 10 in steps of 0.1 
	200 0 do
	  -10e .1e i s>f f* f+
	  fdup
	  anim_xydata i 2* SFSIZE * + 
	  dup >r sf! 
	  0.1e f* r> SFSIZE + sf!
	loop ;
	   
fvariable phase
fvariable deltax
fvariable atten
fvariable width

: propagate1 ( -- | modify the active dataset ) 
	?active dsanim get_ds drop
	dsanim @npts 0 do
	  i dsanim @xy
	  fdrop fdup 
	  deltax f@ f+ 
	  fdup fdup f* fnegate width f@ f/ fexp fswap
	  10e f* phase f@ f+ fcos f*
	  atten f@ f*
	  i dsanim !xy
	loop
	?active set_ds_extrema
	deltax f@ .03e f+ deltax f!
	atten f@ 0.99e f* atten f!
	width f@ .04e f+ width f!
	phase f@ 0.2e f+ phase f!
;

: anim1 ( -- | animate the active plot by modulating and translating it )
	0e phase f!
	0e deltax f!
	1e atten f!
	1e width f!
	200 0 do
	  false draw_plot
	  propagate1
	  true draw_plot
	  5000 usleep
	loop
;

set_anim_data		\ fill the data buffer
dsanim make_ds		\ make a dataset in xyplot
planim make_plot	\ make a plot in xyplot
0 0 set_grid_lines	\ turn off x and y axes grid lines
reset_window		\ reset the plot display in xyplot
100000 usleep
anim1			\ start the animation




