\ fsl-tester.fs
\
\  Test revised versions of the FSL routines under various
\  ANS Forth systems: Gforth, PFE, VFXforth.
\
\  K. Myneni, 2007-08-25
\
\  Revisions:
\
\    2007-09-22  km; added gauleg  
\    2007-09-23  km; added runge4
\    2007-10-10  km; added regfalsi
\    2007-10-12  km; added expint, horner
\    2007-10-13  km; added polys
\    2007-10-18  km; added gamma
\    2007-10-22  km; added logistic
\    2007-10-23  km; added crc, permcomb
\    2007-10-25  km; added adaptint, elip
\    2007-11-11  km; added gauss
\    2007-11-28  km; added sph_bes, cubic
\    2007-11-29  km; added factorl, shanks
\    2007-11-30  km; added pcylfun
\    2007-12-02  km; added gaussj
\    2008-09-16  km; use the dstrings.fs dynamic strings package
\                    instead of the kForth strings package;
\        (see http://www-personal.umich.edu/~williams/archive/forth/strings/ )
\    2008-09-18  km; detect Forth system so we can use this file
\                    on multiple systems
\    2009-06-03  km; added r250
\    2010-12-31  km; added polrat, aitken, and lagroots

\ Detect the Forth system and perform any system-specific loading

[DEFINED] zSysName [IF]
    s" VFX" zSysName 3 SEARCH [IF]   \ VFXforth
	2drop s" Hfp387.fth" included \ load fp extensions in VFXforth
    [THEN]
[THEN]

s" gforth" environment? 0= [IF]     \ not Gforth
    s" FLOATING-EXT" environment?   \ autoload fp extensions in PFE
    0= [IF] ." Floating-point extensions not available!" cr ABORT [THEN]
    drop
    s" struct.fs" included          \   load Gforth-compatible structures
[THEN]

include dstrings.fs
include ttester.fs
include fsl-test-utils.fs
include fsl-util.fs
include dynmem.fs
include complex.fs

DECIMAL
	
true to TEST-CODE?
true verbose !

CR CR
include sph_bes.fs

CR CR
include logistic.fs

CR CR
include polrat.fs

CR CR
include expint.fs

CR CR
include horner.fs

CR CR
include aitken.fs

CR CR
include elip.fs

CR CR
include polys.fs

CR CR
include factorl.fs

CR CR
include gamma.fs

CR CR
include pcylfun.fs

CR CR
include shanks.fs

CR CR
include hilbert.fs

CR CR
include lufact.fs

CR CR
include dets.fs

CR CR
include backsub.fs

CR CR
include invm.fs

CR CR
include gaussj.fs

CR CR
include adaptint.fs

CR CR
include gauleg.fs

CR CR
include cubic.fs

CR CR
include lagroots.fs

CR CR
include regfalsi.fs

CR CR
include runge4.fs

CR CR
include crc.fs

CR CR
include permcomb.fs

CR CR
include gauss.fs

CR CR
include r250.fs

bye

