\ textbox.fs
\
\ A module providing the Box class, for text boxes.
\
\ Copyright (c) 2003--2011 Krishna Myneni, Creative Consulting for
\   Research and Education
\
\ Provided under the GNU General Public License
\
\ Requires:
\   modules.fs
\   mini-oof.fs
\   strings.fs
\   ansi.fs

Module: TextBox

Begin-Module

1 cells constant cell

object class
       cell var col
       cell var row
       cell var width
       cell var height
       cell var bkg		\ background color
       cell var fg		\ foreground color
       cell var border		\ border color
Public:
       method	SetColors
       method   LineXY		\ return col and row for start of line
       method	Draw
       method	Init
end-class box

Private:

:noname ( o -- )  dup bkg @ background fg @ foreground ;
box defines SetColors

:noname ( n o -- col row )  >r r@ row @ + r> col @ swap ; 
box defines LineXY

:noname ( o -- ) 
	 >r
	 r@ SetColors 
	 0 r@ LineXY at-xy
	 r@ border @ background r@ width @ spaces r@ bkg @ background
	 r>
	 dup height @ 1- 1 ?do
	   dup i swap linexy at-xy
	   dup border @ background  space  dup bkg @ background
	   dup width @ 2 - spaces 
	   dup border @ background  space  dup bkg @ background
	 loop
	 dup dup height @ 1- swap LineXY at-xy
	 dup border @ background dup width @ spaces 
	 dup bkg @ background 
	 drop ;
box defines Draw

:noname ( col row width height fg bkg border o -- )
	 >r 
	 r@ border !
	 r@ bkg !
	 r@ fg !
	 r@ height !
	 r@ width !
	 r@ row !
	 r> col ! ;

box defines Init

End-Module

\ Demo: See textbox-demo.fs




	 
         
