\ ==============================================================================
\
\        snl_test - the test words for the snl module in the ffl
\
\               Copyright (C) 2007  Dick van Oudheusden
\  
\ This library is free software; you can redistribute it and/or
\ modify it under the terms of the GNU General Public
\ License as published by the Free Software Foundation; either
\ version 2 of the License, or (at your option) any later version.
\
\ This library is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\ General Public License for more details.
\
\ You should have received a copy of the GNU General Public
\ License along with this library; if not, write to the Free
\ Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\ ==============================================================================
\ 
\  $Date: 2012-01-14 15:42:00 $ $Revision: 1.4b $
\  
\ ==============================================================================
\

Only Forth

include modules.fs
include config.fs
include tst.fs
include stc.fs
include snn.fs
include snl.fs
include sni.fs

Also ffl-snn Also ffl-snl  Also ffl-tst

.( Testing: snl, snn and sni) cr 

t{ snl-create l1  }t

t{    l1 length@   ?0   }t
t{    l1 empty?    ?true   }t

Also ffl-snn

t{ new value n1 }t
t{ new value n2 }t
t{ new value n3 }t
t{ new value n4 }t
t{ new value n5 }t

Previous

\ append & prepend tests

t{ n1 l1 append   }t
t{ n2 l1 append   }t
t{ n3 l1 append   }t

t{ n4 l1 prepend   }t
t{ n5 l1 prepend   }t

t{ l1 length@   5 ?s   }t
t{ l1 empty?   ?false  }t

\ execute test

: test-count ( u snn - u+1 )
  drop 1+
;

t{ 0 ' test-count l1 snl-execute 5 ?s }t

: test-count? ( u snn - u+1 false | u+1 true )
  swap 1+ swap n1 =
;

t{ 0 ' test-count? l1 execute? ?true 3 ?s }t

Also ffl-sni

\ Iterator test

t{ l1 sni-create i1 }t

t{ i1 first n5 ?s }t
t{ i1 get   n5 ?s }t
t{ i1 first? ?true  }t
t{ i1 last?  ?false }t

t{ i1 sni-next n4 ?s  }t
t{ i1 sni-next n1 ?s  }t
t{ i1 first? ?false }t
t{ i1 last?  ?false }t

t{ i1 sni-next n2 ?s  }t
t{ i1 sni-next n3 ?s  }t
t{ i1 first? ?false }t
t{ i1 last?  ?true  }t

t{ i1 sni-next ?nil     }t

Previous

\ pop tests

t{ l1 pop n5 ?s }t

t{ l1 length@   4 ?s   }t

t{ l1 pop n4 ?s }t
t{ l1 pop n1 ?s }t
t{ l1 pop n2 ?s }t
t{ l1 pop n3 ?s }t

t{ l1 empty?   ?true }t

t{ l1 pop ?nil }t

t{ l1 first@ ?nil }t
t{ l1 last@  ?nil }t

t{ l1 pop ?nil }t


t{ new value l2 }t

\ insert tests

t{ n1 0 l2 insert }t
t{ n2 1 l2 insert }t
t{ n3 1 l2 insert }t
t{ n4 0 l2 insert }t
t{ n5 4 l2 insert }t

t{ l2 length@  5 ?s }t

\ get tests

t{ 0 l2 get n4 ?s }t
t{ 1 l2 get n1 ?s }t
t{ 2 l2 get n3 ?s }t
t{ 3 l2 get n2 ?s }t
t{ 4 l2 get n5 ?s }t

\ index tests

t{ 0  l2 index? ?true  }t
t{ 4  l2 index? ?true  }t
t{ 5  l2 index? ?false }t
t{ 99 l2 index? ?false }t

t{ -1  l2 index? ?true  }t
t{ -5  l2 index? ?true  }t
t{ -6  l2 index? ?false }t
t{ -99 l2 index? ?false }t

t{ l2 reverse }t

t{ 0 l2 get n5 ?s }t
t{ 1 l2 get n2 ?s }t
t{ 2 l2 get n3 ?s }t
t{ 3 l2 get n1 ?s }t
t{ 4 l2 get n4 ?s }t

Also ffl-sni

\ Iterator test

t{ l2 new value i2 }t

t{ i2 first    n5 ?s }t
t{ i2 sni-next n2 ?s  }t
t{ i2 sni-next n3 ?s  }t
t{ i2 sni-next n1 ?s  }t
t{ i2 sni-next n4 ?s  }t

t{ i2 last?  ?true  }t
t{ i2 first? ?false }t

t{ i2 sni-next ?nil     }t

t{ i2 sni-free          }t

Previous

\ delete tests

t{ 0 l2 delete n5 ?s }t
t{ 2 l2 delete n1 ?s }t

t{ 0 l2 get n2 ?s }t
t{ 1 l2 get n3 ?s }t
t{ 2 l2 get n4 ?s }t

t{ 1 l2 delete n3 ?s }t
t{ 0 l2 delete n2 ?s }t
t{ 0 l2 delete n4 ?s }t

t{ l2 length@  ?0 }t
t{ l2 first@ ?nil }t
t{ l2 last@  ?nil }t

\ insert-before & insert-after tests

t{ n1 l2 append }t
t{ n4 n1 l2 insert-after  }t
t{ n5 n1 l2 insert-after  }t
t{ n3 n4 l2 insert-after  }t
t{ n2 n5 l2 insert-after  }t

t{ l2 length@  5 ?s }t

t{ 0 l2 get n1 ?s }t
t{ 1 l2 get n5 ?s }t
t{ 2 l2 get n2 ?s }t
t{ 3 l2 get n4 ?s }t
t{ 4 l2 get n3 ?s }t

t{ n2 l2 remove-after n4 ?s }t
t{ n3 l2 remove-after ?nil    }t
t{ n2 l2 remove-after n3 ?s }t

t{ 0 l2 get n1 ?s }t
t{ 1 l2 get n5 ?s }t
t{ 2 l2 get n2 ?s }t

t{   l2 last@   n2 ?s }t
t{   l2 first@  n1 ?s }t

t{   l2 length@ 3 ?s }t

t{ l2 snl-free }t

t{ n3 snn-free }t
t{ n4 snn-free }t

Only Forth Also Modules 
\ ==============================================================================

