\ ==============================================================================
\
\             snn - the generic single linked node in the ffl
\
\               Copyright (C) 2007  Dick van Oudheusden
\  
\ This library is free software; you can redistribute it and/or
\ modify it under the terms of the GNU General Public
\ License as published by the Free Software Foundation; either
\ version 2 of the License, or (at your option) any later version.
\
\ This library is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\ General Public License for more details.
\
\ You should have received a copy of the GNU General Public
\ License along with this library; if not, write to the Free
\ Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\ ==============================================================================
\ 
\  $Date: 2008-01-09 19:30:48 $ $Revision: 1.3 $
\
\ ==============================================================================


Module: ffl-snn

Also ffl-stc

Begin-Module

( snn = Generic Single Linked List Node )
( The snn module implements a node in a generic single linked list [snl].    )


1 constant version


( Node structure )

begin-structure snn%       ( - n = Get the required space for a snn node )
  field: >next
end-structure


Public:

: get-version ( -- u ) version ;

( Node creation, initialisation and destruction )

: init     ( snn -- = Initialise the node )
  >next nil! ;


: new      (  -- snn = Create a new node on the heap )
  snn% allocate  throw  dup init ;


: snn-free     ( snn -- = Free the node from the heap )
  free throw ;


( Member words )

: next@    ( snn1 -- snn2 = Get the next node snn2 from the node snn1 )
  >next @ ;


: next!    ( snn1 snn2 -- = Set for the node snn1 the next node to snn2 )
  >next ! ;

: next@!  >next @! ;

( Inspection )

: dump     ( snn -- = Dump the single list node )
  ." snn:" dup . cr
  ."  next :"     >next  ?  cr ;

End-Module

\ ==============================================================================
