\ lyx-include.fs
\
\  This program allows a LyX file containing documentation
\  and source to be directly included in a Forth environment.
\  It is based on an example given by Bernd Paysan on
\  comp.lang.forth, February 16, 2011. See message id.
\  <ijipt8$28n$1@news.m-online.net>
\
\ Usage:
\
\   $lyxfile $forthfile lyx-included
\
\ Example:
\
\    s" lpforth" s" gcd" lyx-included
\
\  will use the notangle program to extract and include the 
\  Forth source,  gcd.fs, from the LyX file, lpforth.lyx.
\
\ Revisions:
\   2011-02-17  km  make use of strings.fs for string 
\                   handling; remove existing .nw file;
\                   require two arguments to lyx-include:
\                   the lyx filename and the Forth source
\                   filename.
\
\ Notes:
\
\  1) Set up instructions for LyX (for Linux). LaTeX and LyX are
\     already assumed to be installed:
\
\     a) Install the "noweb" package, if it is provided in your 
\        distribution. Otherwise, obtain the package from its
\        homepage and install it.
\
\     b) Run "texhash" as superuser, so that LaTeX knows about the 
\        noweb.sty stylesheet.
\
\     c) Start LyX and execute Reconfigure ( Tools > Reconfigure ).
\
\     d) Exit and restart LyX. You are now ready to do literate
\        Forth programming from LyX.
\
\     Separate tutorials may be found on the web for using LyX to
\     do literate programming. The chunk containing the Forth source
\     to be loaded must start with, <<filename.fs>>=
\
\     An example LyX file may be found at,
\
\         ftp://ccreweb.org/software/lyx/forth/lpforth.lyx
\
\  2) This file assumes gforth. In particular, s" strings are
\     are assumed to be persistent, and the words OPEN-PIPE
\     and INCLUDE-FILE are assumed to be present. We hope to
\     generalize the code for lyx-include to all Forth-94 compliant 
\     systems.

include strings.fs

2variable src_name
2variable lyx_name

: lyx-included ( alyx u asrc u -- ) 
  \ s" filename" set-macro
  \ s" lyx -e literate %filename%.lyx; notangle -R%filename%.fs %filename%.nw"
  \ substitute
  src_name 2!  lyx_name 2!
  s" rm " lyx_name 2@ strcat s" .nw;" strcat
  s"  lyx -e literate " strcat lyx_name 2@ strcat s" .lyx;" strcat
  s"  notangle -R" strcat src_name 2@ strcat s" .fs " strcat 
  lyx_name 2@ strcat s" .nw" strcat
  r/o open-pipe throw include-file 
; 


