\ elfcode.4th
\
\ Read, parse, and display a code section for an ELF object file
\
include read-elf.4th
include dump.4th

create rel.text.buf 16384 allot
0 value text.section
0 value text.size

: display-code ( a u -- )
    open-elf-file
    read-elf-header drop
    read-all-section-hdrs
    read-section-names
    read-string-table
    read-symbol-table

\ Find the first code section with non-zero length
    -1 to text.section
    e1 SHDRCNT w@ 0 ?DO
      I [sh] SH_TYPE @ SHT_PROGBITS = IF
        I [sh] SH_SIZE @ IF
          I to text.section
          I [sh] SH_SIZE @ to text.size
          LEAVE
        THEN
      THEN
    LOOP

    text.section 0< IF close-elf-file cr ." No code section found!" EXIT THEN
    cr ." First code section is section " text.section . 
    cr ." Executable code is " text.size . ."  bytes long." 

\ Read the executable code section

    text.section reposition@section
    rel.text.buf text.size elf-id @ read-file 
    close-elf-file
    ABORT" Unable to read the code section"
    cr  .  ."  bytes read from the code section."  
    rel.text.buf text.size dump
;

