\ gpib-device.4th
\
\ Provides class GpibDevice, a generic class for communicating
\   with instruments on a GPIB interface.
\
\  Requires:
\    modules.4th
\    mini-oof.4th
\    gpib.4th
\
\  Revisions:
\    2011-11-24  km  created    

Module: gpib-device

Begin-Module

Public:

∋ gpib in_buf  constant  in_buf

Private:

object class
	cell var PRI_ADDR   \ primary address of device
Public:
	method  GetPad  ( o -- u )
	method  SetPad  ( u o -- )
	method  Send    ( ^str o -- )
	method  Read    ( u o -- )
	method  Clear   ( o -- )
end-class GpibDevice

Private:

: noname ( o -- u ) PRI_ADDR @ ;
' noname GpibDevice defines GetPad

: noname ( u o -- ) PRI_ADDR ! ;
' noname GpibDevice defines SetPad

: noname ( ^str o -- )  2drop ( PRI_ADDR @ ∋ gpib send_command ) ;
' noname GpibDevice defines Send

: noname ( u o -- )    2drop ( PRI_ADDR @ ∋ gpib read_bytes) ;
' noname GpibDevice defines Read 

: noname ( o -- )  PRI_ADDR @ ∋ gpib clear_device ;
' noname GpibDevice defines Clear

End-Module


