\ hp-54750.4th
\
\ Provides class Hp54750 for GPIB interface to HP54750 digitizing
\ scope
\
\ Requires:
\	modules
\	mini-oof
\	gpib
\	gpib-device
\	hp-scope
\
\ Revisions:
\   2011-11-24 km  created class module (unfinished)
\   2012-02-16 km  revised for modules v0.5.0

Module: hp-54750

Also gpib-device
Also hp-scope

Begin-Module

HpScope class
	cell  var Npts                                                
	float var Yoffset
	float var Yscale
Public:

end-class Hp54750

Private:

: noname ( u o -- | set the number of points )         
    >r s>string count                                              
    s" ACQ:POIN " 2swap strcat strpck                      
    r> Send ;
' noname Hp54750 defines SetRecordLength
 
: noname ( n o -- | averaging on/off if n true/false )
    >r if c" ACQ:AVER ON" else c" ACQ:AVER OFF" then                 
    r> Send ;
' noname Hp54750 defines SetAveraging

: noname ( u o -- | download channel u waveform data )          
    >r s>string count 
    s" :WAV:SOUR CHAN"
    2swap strcat strpck r@ Send
    c" :WAV:FORM WORD"  r@ Send
    r@ GetRecordLength  r@ Npts !                                           
    c" :WAV:DATA?" r@ Send                            
    r@ Npts @ 2* 10 +  r> Read ;
' noname Hp54750 defines DownloadChannel

End-Module


