\ mosterm.4th
\
\ Terminal configured to talk to MOS (micro operating system) 
\ Allows upload of hex files to target.
\ 
\ Written by Krishna Myneni and David P. Wallace
\ Provided under the terms of the GNU General Public License
\
\ Requires:
\
\       ans-words.4th
\       struct.4th
\       struct-ext.4th
\	strings.4th
\	ansi.4th
\	serial.4th
\	files.4th
\
\ Revisions:
\	04-19-2001  created
\       08-03-2007  updated to use revised serial.4th  km
include ans-words
include struct
include struct-ext
include strings
include ansi
include serial
include files

variable fid
variable com			
create buf 256 allot

: serinp ( -- | look for input on the serial port and display it )
	com @ serial_lenrx
	dup 
	if
	  com @ buf rot serial_read
	  dup 0> if
	    0 do
	      buf i + c@
	      case
	        13 of 13 emit 10 emit endof  \ (cr ->cr lf) on input
	        dup emit
	      endcase
	    loop
	  else
	    drop
	  then
	else
	  drop
	then ;


\ com port parameters are set to 9600 baud, N81
." Usage: " cr 9 emit ." com1 mt" cr 9 emit ." com2 mt" cr cr

: mt ( port -- | terminal emulator configured for MOS )

	black background
	page
	green background
	black foreground
	." MOS Terminal: COM"
	dup 1+ 1 .r 
	." | "
	red foreground ." Ctl-u "
	black foreground ." Send file | "
	red foreground ." Esc "
	black foreground ." Exit |" 10 spaces cr
	white background
	." MOS Commands: "
	blue foreground ." load  store  run  read  write " 
	15 spaces cr
	white foreground
	black background

	serial_open com !
	com @ c" 8N1" serial_setparams
	com @ B9600 serial_setbaud

	begin
	  serinp
	  key?
	  if
	    key
	    case
	      27 of		\ ESC
	        com @ serial_close
	        drop
	        text_normal	\ restore normal foreground/background colors
	        page		\ clear the screen
	        exit endof
	      10 of		
	        13 buf c! 	\ (lf->cr) on output
	        com @ buf 1 serial_write drop
	        endof
	      21 of		\ CTL-u
	        cr cr ." Enter hex file to upload: "
	        buf 64 accept
		buf swap R/O open-file
	        if drop cr ." Error: Cannot open file!" cr
	        else 
	          fid !
	          begin
	            buf 256 fid @ read-line drop
	          while
	            com @ swap buf swap serial_write drop
	            100 ms	\ delay between lines
		    serinp
 	          repeat
	          com @ swap buf swap serial_write drop
		  fid @ close-file drop
	        then
	        endof
	      dup buf c!
	      com @ buf 1 serial_write drop
	    endcase
	  then
	again ;
		
