\ simple-typeset-x11.4th
\
\ Simplified typesetting of text in X11 windows.
\
\   Copyright (c) 2012 Krishna Myneni, Creative Consulting for
\   Research and Education, http://ccreweb.org
\
\   This code may be used for any purpose, provided the copyright
\   notice above is included.
\
\ Provides:
\
\   draw-centered-text  ( y caddr u -- )
\   place-centered-text ( n caddr u -- )
\
\ Requires:
\
\   font-strings-x11.4th
\   simple-graphics-x11.4th
\   simple-fonts-x11.4th
\
\  
\ Revisions:
\   2012-04-30  km  created.
\

Module: simple-typeset-x11

Also font-strings-x11
Also simple-graphics-x11
Also simple-fonts-x11

Begin-Module

variable cx0
variable cx
variable cy

Public:


: draw-centered-text ( y caddr u -- )
    2dup 2>r rot >r get-string-box drop  \ strwidth  R: caddr u y
    get-window-size drop                 \ strwidth winwidth
    2dup > IF  2drop 0 
    ELSE       swap - 2/ 
    THEN  r> 2r> draw-text
;

\ Display text, centered horizontally in the window, and
\ n lines down from the top of window.

: place-centered-text ( n caddr u -- )
    2>r current-font-height * 2r> draw-centered-text
;

\ Draw text starting at the specified window position, wrapping it
\ as needed to show the text in the current font.
: draw-wrapped-text ( x y caddr u -- )
    2>r cy ! dup cx ! cx0 !
    2r@ get-string-box drop
    cx @ + get-window-size drop < IF
      cx @ cy @ 2r> draw-text
    ELSE
      \ An intelligent wrapped text output algorithm
      \ goes here.
      cx @ cy @ 2r> draw-text
    THEN
;

End-Module

