\ syscalls-test.4th
\
\  Test selected syscalls from kForth
\
\  Copyright (c) 2012 K. Myneni, Creative Consulting for
\  Research and Education
\
\  Provided under the GNU General Public License
\
\  Revision history:
\    2012-01-27  km  created
\

include ans-words
include strings
include files
include syscalls

[undefined] ptr [IF] : ptr create 1 cells ?allot ! does> a@ ; [THEN]

0 value fd

1 constant PROT_READ
2 constant PROT_WRITE
1 constant MAP_SHARED
2 constant MAP_PRIVATE

0    ptr   mmap_address
1024 value mmap_length

: test-mmap ( -- )

\ For now, user must provide any file named mmap.dat,
\ with read permission.

    s" mmap.dat" R/O open-file
    IF ." TEST-MMAP: Unable to open map file. Exiting!" cr
       EXIT
    THEN
    to fd

    \ Use mmap to map this file to a memory region

    0               \ address; 0 means kernel picks address
    mmap_length     \ length of region to map
    PROT_READ       \ prot
    MAP_SHARED      \ flags
    fd              \ fd (specifies the file to map)
    0               \ offset
    mmap

    dup to mmap_address

    -1 = IF 
      ." TEST-MMAP: Map failed!" cr
    THEN
;

\ execute test-mmap first

: test-munmap ( -- n )
    \ Unmap the memory previously mapped with mmap
    mmap_address mmap_length  munmap
    -1 = IF
      ." TEST-MUNMAP: Unmap failed!" cr
    THEN
    fd close-file drop
;



