\ test-fft-x86.4th
\
\ Test assembly language version of fft in Forth
\
include asm-x86
include fft-x86
include dump

create a 2048 dfloats allot
create b 2048 dfloats allot
fvariable pulse_height
variable pulse_width
variable start_pulse
variable stop_pulse

variable ntrials
1000 ntrials !

1024 constant IMAX

: setup-pulse

    100 pulse_width !
    1e pulse_height f!
    
    IMAX pulse_width @ - 1- start_pulse !
    IMAX pulse_width @ + 1- stop_pulse !
    
    \ Fill array with rectangular pulse data

    IMAX 2* 0 DO
      I start_pulse @ > IF
        I stop_pulse @ < IF  pulse_height f@ ELSE 0e THEN 
	ELSE 0e THEN 
	fdup a I dfloats + F! b I dfloats + F!
	0e a I 1+ dfloats + F! 0e b I 1+ dfloats + F!
    2 +LOOP


;

: print-array ( a -- )
    IMAX 0 DO
      dup f@ f. 2 spaces dfloat+ dup f@ f. cr dfloat+
    LOOP  drop
;

: power-spectrum ( a -- | print out the power spectrum for given array )
    IMAX 0 DO
      dup F@ FDUP F* 2>r dfloat+ dup F@ FDUP F* 2R> F+ F. CR
      dfloat+
    LOOP
    drop
;


: verify-fft ( -- )
    setup-pulse
    IMAX a fft
    \ a print-array
    a power-spectrum
;


: test
    setup-pulse
    ms@
    ntrials @ 0 DO
      IMAX b fft
    LOOP
    ms@ swap - .
;

\ ' fft >body 512 dump
