/*
High precision calculation of the real gamma function
using the MPFR library

Krishna Myneni

Revisions:
  2010-11-19  km  revised to use hex input for argument.

Notes:

1. Under Linux, compile and link with 

	gcc -o mpfr_gamma-hex mpfr_gamma-hex.c -lmpfr

*/

#include <stdio.h>
#include <stdlib.h>
#include <mpfr.h>


int main()
{
  mpfr_t num, dst;
  mpfr_set_default_prec (2048);

  double inp;
  unsigned int x1, x2;
  unsigned int *p = (unsigned int*) &inp;


  printf("\nThe argument will be entered as a hex number representation of");
  printf("\na double precision (8 byte) floating point number.\n");

  printf("\nBelow, enter the argument x, as two hex values for the");
  printf("\ntop four bytes and then the bottom four bytes.");
  printf("\nFor example, the hex value for double precision 1.0e0 is");
  printf("\n3ff00000 00000000  with a space separating the top four");
  printf("\nfrom the bottom four bytes. This argument may be entered as");
  printf("\n  0x3ff00000 0x0\n");

/* Need a check for too many digits in input */

  while (1) {
      printf("\nArgument (Top4 Bottom4): ");
      scanf("%x %x", &x1, &x2);
      *p = x2; *(p+1) = x1;

      mpfr_init (dst);
      mpfr_init_set_ld (num, inp, GMP_RNDN);
      mpfr_gamma (dst, num, GMP_RNDN);
      printf ("gamma(");
      mpfr_out_str (stdout, 10, 40, num, GMP_RNDN);
      printf (") = ");
      mpfr_out_str (stdout, 10, 40, dst, GMP_RNDN);
      printf ("\n");
   }
}

