/*
Find the "nice" decimal floating point value, near a specified
value, which is exactly representable by an IEEE double precision 
number.

Build:  gcc -o nice-double nice-double.c -lm

*/

#include <stdio.h>
#include <math.h>

/* 
Test whether or not a double number has a "nice" decimal 
representation
*/
int is_nice(double x)
{
   char s[80];
   snprintf(s, 80, "%.60g", x);
   return( strlen(s) < 14 ); 
}


int main(void)
{
  double x, xb;
  unsigned int *p = &xb, i; 
  long nsteps;

  printf("\nEnter a real number, x: ");
  scanf("%lf", &x);

  xb = x;

  for (i = 0; i < 50; i++) {
    if (is_nice(xb)) break;
    if (i < 32) {
      *p = (*p & (~(1 << i)));
    }
    else {
       ++p;
       *p &= (~(1 << (i-32)));
       --p;
    }
  }


  printf("Nearby exactly representable decimal value: %.60g\n", xb);
  printf("Hexadecimal value: %x %x\n", *(p+1), *p);
  
  return 0;

}

