\ xyexpfit.4th
\
\ Fit data to the function:
\
\	y = a*exp(-x/b) + c
\
\ Parameter array ordering is:
\
\	0   a
\	1   b
\	2   c
\
\ Requires:
\	fsl-util.4th
\	curvefit.4th
\

: functn ( fx a -- fy )
	>r 
        r@ 1 } f@ f/ fnegate fexp
	r@ 0 } f@ f* 
	r> 2 } f@ f+ ;

include fsl/extras/curvefit.4th

MAX_POINTS FLOAT array x{
MAX_POINTS FLOAT array y{
MAX_POINTS 2 FLOAT MATRIX fit_data{{

3 FLOAT array params{
3 FLOAT array increments{

: expfit ( -- )
	?active dup 0 >= 
	if
	  ds1 get_ds
	  0 >= if
	    ds1 ->npts @ MAX_POINTS > if
	      ." Too many points in data set. Resize MAX_POINTS." cr
	      exit
	    then
	    \ ds1 ->npts 1 x mat_size!
	    \ ds1 ->npts 1 y mat_size!

	    ds1 ->npts @ 0 ?do
	      I ds1 @xy  y{ I } f!  x{ I } f!
	    loop
	    5 0 do
	      x{ y{ params{ increments{ curfit
	    loop
	    ." Reduced Chi^2 = " f. cr
	    ." a = " params{ 0 } f@ f. cr
	    ." b = " params{ 1 } f@ f. cr
	    ." c = " params{ 2 } f@ f. cr
	    
	    \ Make a dataset with the fit data

	    \ ds1 ->npts 2 fit_data mat_size!
	    ds1 ->npts @ 0 ?do
	      x{ I }    f@  fit_data{{ I 0 }} f!
	      yfit{ I } f@  fit_data{{ I 1 }} f!
	    loop
	    
	    c"  " 1+ ds2 DHEADER + !
	    c" Exp Fit" 1+ ds2 DNAME + !
	    256 ds2 DTYPE + !
	    ds1 ->npts ds2 DNPTS + !
	    2 ds2 DSIZE + !
	    fit_data 2 cells + ds2 DDATA + !

	    ds2 make_ds drop

	  then
	else
	  drop
	then ;


: xyexpfit ( -- )
	?active 0 >= 
	if
	  c" Enter initial a, b, c for y=a*exp(-x/b) + c:" get_input
	  if
	    count parse_args 3 <> abort" Entered wrong number of parameters!"
	    params{ 2 } f!  params{ 1 } f!  params{ 0 } f!
	    c" Enter initial increments da, db, dc:" get_input
	    if
	      count parse_args 3 <> abort" Entered wrong number of params!"
	      increments{ 2 } f!  increments{ 1 } f!  increments{ 0 } f!
	    else
	      exit
	    then
	    ." Initial parameters and increments:" cr
	    3 0 do params{ I } f@ f. 2 spaces increments{ I } f@ f. cr loop
	    expfit
	  else
	    drop
	  then
	then ;

MN_MATH " Exponential Fit"  " xyexpfit draw_window" add_menu_item

