\ zerf.fs
\
\ Error function and Complementary Error Function of 
\ a complex number.
\
\ Provides:
\
\   ZERF
\   ZERFC
\
\ Krishna Myneni
\
\ Requires:
\   fsl-util.fs
\   complex.fs
\   zwofz.fs
\
\ Revisions:
\   2010-12-08 km  created.

BASE @
DECIMAL

Private:
zvariable eterm

Public:

: zerfc ( F: z1 -- z2 )
    zdup z^2 znegate zexp eterm z! 
    i* zwofz drop eterm z@ z* ;
 
: zerf ( F: z1 -- z2 )
    1e 0e zswap zerfc z- ;

Reset-Search-Order
BASE !
