\ quad-hd.fs
\ Quadratic Equation Solver by humptydumpty 
\ posted on comp.lang.forth, 15 Aug 2009, by h.d.
\ Test code added by K. Myneni

[UNDEFINED] test-code? [IF] include fsl-util.fs  [THEN]
[UNDEFINED] z.         [IF] include complex.fs   [THEN]
true to test-code?

[UNDEFINED] ftuck  [IF] : ftuck   fswap fover ;  [THEN]
[UNDEFINED] fnip   [IF] : fnip    fswap fdrop ;  [THEN]

: `   postpone  postpone ; immediate
: -frot  ` frot  ` frot  ; immediate
: f2dup  ` fover ` fover ; immediate

: prepare       ( F: a b c -- q=c/a  p=-b/2a )
        frot ftuck f/ -frot     ( F: q b a )
        2e f* f/ fnegate
;

: discriminant  ( F: q p -- q p d=p^2-q )
        fover fnegate           ( F: q p -q )
        fover fdup f* f+ ;      ( F: q p -q+p^2 )

: complex       ( F: q p d  -- re1 im1 re2 im2 )
        fnegate fsqrt           ( F: q p sqrt|d| )
        frot fdrop              ( F:   p sqrt|d| )
        f2dup fnegate
;

: real          ( F: q p d -- re1 0 re 0 )
        fsqrt   fswap                   ( F: q  sqrt|d|  p )
        fdup  0e f<
        if fswap fnegate then f+        ( F: q  re1 )
        ftuck f/                        ( F: q  re1  re2 )
        0e ftuck
;

: roots         ( F: a b c -- re1 im1 re2 im2 )
        prepare discriminant fdup 0e f<
        if complex else real then
;  


\ ---------------------
test-code? [IF] 
[undefined] T{      [IF]  include ttester.fs  [THEN]    
BASE @ DECIMAL

1e-15  rel-near F!
1e-256 abs-near F!
set-near

\ Examples from:
\
\    http://www.purplemath.com/modules/quadform.htm

-2e 3e F/       fconstant -2/3
-3e 2e F/       fconstant -3/2
 5e fsqrt       fconstant sqrt{5}
 2e fsqrt 3e F/ fconstant sqrt{2}/3
 3e fsqrt 2e F/ fconstant sqrt{3}/2
10e fsqrt 2e F/ fconstant sqrt{10}/2

: zz}t  rrrr}t ;

TESTING ROOTS
t{ 1e  3e -4e roots ->  -4e               0e   1e               0e      zz}t
t{ 2e -4e -3e roots ->   1e sqrt{10}/2 F+ 0e   1e sqrt{10}/2 F- 0e      zz}t
t{ 1e -2e -4e roots ->   1e sqrt{5} F+    0e   1e sqrt{5} F-    0e      zz}t
t{ 9e 12e  4e roots ->  -2/3              0e  -2/3              0e      zz}t
t{ 3e  4e  2e roots ->  -2/3       sqrt{2}/3  -2/3 sqrt{2}/3 fnegate    zz}t
t{ 1e  3e  3e roots ->  -3/2       sqrt{3}/2  -3/2 sqrt{3}/2 fnegate    zz}t
t{ 1e  0e  1e roots ->   0e               1e    0e              -1e     zz}t
t{ 1e 1e 1e-17 roots -> -1e 1e-17 f+      0e   -1e-17            0e     zz}t

BASE !
[THEN]


