\ quad-bench.fs
\ by humptydumpty and M. A. Hendrix,
\ revised by K. Myneni, 2009-08-11

include fsl-util.fs
\ true to test-code?
include quadratic.fs

[UNDEFINED] ftuck  [IF] : ftuck   fswap fover ;  [THEN]
[UNDEFINED] fnip   [IF] : fnip    fswap fdrop ;  [THEN]

: `   postpone  postpone ; immediate
: -frot  ` frot  ` frot  ; immediate
: f2dup  ` fover ` fover ; immediate

: prepare       ( F: a b c -- q=c/a  p=-b/2a )
        frot ftuck f/ -frot     ( F: q b a )
        2e f* f/ fnegate
;

: discriminant  ( F: q p -- q p d=p^2-q )
        fover fnegate           ( F: q p -q )
        fover fdup f* f+ ;      ( F: q p -q+p^2 )

: complex       ( F: q p d  -- re1 im1 re2 im2 )
        fnegate fsqrt           ( F: q p sqrt|d| )
        frot fdrop              ( F:   p sqrt|d| )
        f2dup fnegate
;

: real          ( F: q p d -- re1 0 re 0 )
        fsqrt   fswap                   ( F: q  sqrt|d|  p )
        fdup  0e f<
        if fswap fnegate then f+        ( F: q  re1 )
        ftuck f/                        ( F: q  re1  re2 )
        0e ftuck
;

: roots         ( F: a b c -- re1 im1 re2 im2 )
        prepare discriminant fdup 0e f<
        if complex else real then
;  


\ ---------------------
test-code? [IF]
TESTING ROOTS
t{ 1e  3e -4e roots ->  1e               0e   -4e               0e   zz}t
t{ 2e -4e -3e roots ->  1e sqrt{10}/2 F- 0e    1e sqrt{10}/2 F+ 0e   zz}t
t{ 1e -2e -4e roots ->  1e sqrt{5} F-    0e    1e sqrt{5} F+    0e   zz}t
t{ 9e 12e  4e roots ->  -2/3             0e   -2/3              0e   zz}t
t{ 3e  4e  2e roots ->  -2/3      sqrt{2}/3   -2/3 sqrt{2}/3 fnegate zz}t
t{ 1e  3e  3e roots ->  -3/2      sqrt{3}/2   -3/2 sqrt{3}/2 fnegate zz}t
t{ 1e  0e  1e roots ->  0e               1e    0e              -1e   zz}t
t{ 1e 1e 1e-17 roots -> -1e-17           0e    -1e 1e-17 f+     0e   zz}t
[THEN]

: Z2DROP ( F: z1 z2 -- )  F2DROP F2DROP ;

[UNDEFINED] ms@ [IF] : ms@ ( -- u )  utime 1 1000 m*/ d>s ;  [THEN]

variable start-time
: TIMER-RESET ms@ start-time ! ;
: .ELAPSED ms@ start-time @ - . ."  ms" ;

: BENCHMARK ( -- )
        CR ." roots           -> " TIMER-RESET 
	10000000 0 DO  1e 1e  1e-17 roots           Z2DROP  LOOP 
	.ELAPSED 
        CR ." solve_quadratic -> " TIMER-RESET
	10000000 0 DO  1e 1e  1e-17 solve_quadratic Z2DROP  LOOP 
	.ELAPSED 
;

: BENCHMARK2 ( -- )

        CR ." Triplet 2e -4e -3e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  2e -4e -3e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  2e -4e -3e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 1e 3e -4e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  1e 3e -4e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  1e 3e -4e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 1e -2e -4e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  1e -2e -4e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  1e -2e -4e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 9e 12e 4e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  9e 12e 4e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  9e 12e 4e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 3e 4e 2e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  3e 4e 2e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  3e 4e 2e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 1e 3e 3e"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  1e 3e 3e solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  1e 3e 3e roots           Z2DROP  LOOP 
	.ELAPSED
        CR
        CR ." Triplet 1e 1e 1e-17"
        CR ." solve_quadratic -> " TIMER-RESET 
	20000000 0 DO  1e 1e 1e-17 solve_quadratic Z2DROP  LOOP 
	.ELAPSED
        CR ." roots           -> " TIMER-RESET 
	20000000 0 DO  1e 1e 1e-17 roots           Z2DROP  LOOP 
	.ELAPSED
; 
CR .( Benchmarking ... ) BENCHMARK2

