\ fsl-test-utils.fs 
\
\  Utilities for generating element by element, Hayes-style tests on
\  arrays and matrices:
\
\ Requires: dstrings.fs
\
\ Use:
\          n  CompareArrays    a{  b{
\       n  m  CompareMatrices  a{{  b{{
\
\  K. Myneni, D. N. Williams
\  Revisions: 2007-08-25, 2007-09-22, 2008-09-15, 2008-09-18,
\             2008-09-23

DECIMAL


[UNDEFINED] DEFAULT-/$BUF [IF]
    s" dstrings.fs" included  [THEN]
[UNDEFINED] $+ [IF]
    cr .( ***dstrings.fs: need version 0.7.5 or later) ABORT [THEN]
    \ cr .( Using ANS Forth dstrings.fs.)


[UNDEFINED] unum>s [IF]
: unum>s  ( u -- u.s )  0 <# #S #> ; [THEN]

: unum>$  ( u -- )  unum>s >$s-copy ;
: bl+    ( -- )     $+"  " ;  


\ Generate element by element tests for two fp arrays.
: CompareArrays ( n <a1> <a2> -- )

(
The "copy" in >$S-COPY after PARSE-NAME is important, because in
gforth something in the rest of the code [has to be the pictured
numeric conversion] clobbers the output of PARSE-NAME.  --dnw
)
    parse-name >$s-copy parse-name >$s-copy
    $ARGS{  a{ b{  }
    ( n) 0 DO
	I unum>$ ($: I)
	$+" t{ "    a{ bl+    ($: I) $dup $+    $+"  } F@  -> "
	b{ bl+   ($: I) $+    $+"  } F@ r}t" ENDCAT

	($: "t{ <a{> <I> } F@  -> <b{> <I> } F@ r}t")
	$s> evaluate
    LOOP
;

0 value Nrows
0 value Ncols
\ Generate element by element tests for two fp matrices.
: CompareMatrices ( n m <m1> <m2> -- )
    to Ncols to Nrows
    parse-name >$s-copy parse-name >$s-copy
    $ARGS{  a{{ b{{  }
    Nrows 0 DO
    	Ncols 0 DO
	    J unum>$    I unum>$ ($: J I)
	    $+" t{ "    a{{ bl+    ($: J I) $over $+ bl+    ($: I) $dup $+
		$+"  }} F@  -> "    b{{ bl+   $swap ($: I J) $+ bl+ $+ 
		$+"  }} F@ r}t" ENDCAT
	    ($: "t{ <a{{> <J> <I> }} F@  -> <b{{> <J> <I> }} F@ r}t")
	    $s> evaluate
	LOOP
    LOOP
;
