\     File:  regress.4th
\    Title:  Regression tests
\   Author:  David N. Williams
\  License:  Public Domain, except for GPL in D+ and D- tests
\  Started:  March 22, 2006
\  Revised:  March 22, 2006
\  Revised:  March 26, 2006
\  Revised:  March 27, 2006
\  Revised:  March 29, 2006
\  Revised:  March 30, 2006
\  Revised:  April 2, 2006
\  Revised:  April 4, 2006
\  Revised:  April 5, 2006
\  Revised:  April 8, 2006

include tester.4th
\ include div-test.4th

\ from core.4th:
0 INVERT                 CONSTANT  maxuint
0 INVERT 1 RSHIFT        CONSTANT  maxint
0 INVERT 1 RSHIFT INVERT CONSTANT  minint

minint   1 RSHIFT        CONSTANT  minint/2
minint/2 NEGATE          CONSTANT -minint/2 

create pad 512 allot

testing 0<> 0> <> U>

hex
{  5 0<> -> true }
{  0 0<> -> false }
{ -1 0<> -> true }
{ maxint 0>  -> true }
{ -1 0>  -> false }
{  0 0>  -> false }
{  0  1 <>  -> true }
{  0  0 <>  -> false }
{ -1 -2 u> -> true }
{ -1 -1 u> -> false }
{  1  1 u> -> false }
{  1  0 u> -> true }
{ -1  0 u> -> true }

testing W@  W!

variable george

{ 1ffff george w! -> }
{ george w@ -> ffff }

testing <= >= -ROT 2ROT

{ -1  0 <= -> true }
{  0  0 <= -> true }
{  1  0 <= -> false }
{ -2 -1 <= -> true }
{ -1 -1 <= -> true }
{  0 -1 <= -> false }

{ -1  0 >= -> false }
{  0  0 >= -> true }
{  1  0 >= -> true }
{ -2 -1 >= -> false }
{ -1 -1 >= -> true }
{  0 -1 >= -> true }

{ 1 2 3 -rot -> 3 1 2 }

{ 1 2 3 4 5 6 2rot -> 3 4 5 6 1 2 }

testing 2+ 2-

{  3 2+ ->  5 }
{ -1 2+ ->  1 }
{ -2 2+ ->  0 }
{  3 2- ->  1 }
{  2 2- ->  0 }
{  1 2- -> -1 }

\ testing DNEGATE
\ testing D<
comment Need tests for DNEGATE D< besides Gforth

\ testing DU<

decimal
{     2 0    3 0 du< -> true  }
{     3 0    3 0 du< -> false }
{     4 0    3 0 du< -> false }
{     2 0 5000 1 du< -> true } 
{     2 1 5000 1 du< -> true }
{     2 2 5000 1 du< -> false }
{ 20000 1 5000 1 du< -> false }
{  5000 1 5000 1 du< -> false }
{  4999 1 5000 1 du< -> true }

hex
{ -1 maxint 0 -1 du< -> true }
{ -1 minint 0 -1 du<  -> true }
{ -1 minint 0 90000000 du< -> true }

testing CMOVE  CMOVE>  FILL  ERASE

decimal

: ?chars  ( addr u char -- )
  -rot ( char addr u) over >r + r>
  ( char addr+u addr)
  DO i c@ over <> abort" ***character doesn't match" LOOP
  drop ;

0 pad c!   0 pad 511 + c!
{ pad 1+ 510 21 fill -> }
{ pad c@ pad 511 + c@ -> 0 0 }
pad 1+ 510 21 ?chars

3 pad c!   3 pad 511 + c!
{ pad 0 5 fill pad c@ -> 3 }

{ pad 1+ 510 erase -> }
{ pad c@ pad 511 + c@ -> 3 3 }
pad 1+ 510 0 ?chars

{ pad 0 erase pad c@ -> 3 }

: upper-pad-fill  ( char -- )  pad 256 rot fill ;
: lower-pad-fill  ( char -- )  pad 256 + 256 rot fill ;

3 upper-pad-fill   0 lower-pad-fill
{ pad 1+ pad 257 + 254 cmove -> }
{ pad 256 + c@ pad 511 + c@ -> 0 0 }
pad 257 + 254 3 ?chars

0 lower-pad-fill
{ pad 1+ pad 257 + 254 cmove> -> }
{ pad 256 + c@ pad 511 + c@ -> 0 0 }
pad 257 + 254 3 ?chars

5 0 DO i 1+ pad i + c! LOOP  \ PAD chars: 1 2 3 4 5
pad pad 1+ 4 cmove
{ pad 5 +  pad DO i c@ LOOP -> 1 1 1 1 1 } 

5 0 DO i 1+ pad i + c! LOOP  \ PAD chars: 1 2 3 4 5
pad pad 5 cmove>
{ pad 5 +  pad DO i c@ LOOP -> 1 2 3 4 5 }

testing SP@  RP@  2R@  2>R  2R>

\ The kForth dsp and rsp point to S0 and R0.
{ sp@ dup @ = -> true }
: RP@1  ( n -- n )  >r rp@ cell+ @ r> drop ;
{ 3 RP@1 -> 3 }

: 2R@1  ( n1 n2 -- n1 n2 )
  ( n2) >r ( n1) >r ( r: n2 n1) 2r@ ( n2 n1) swap
  r> drop r> drop ;
{ 5 6 2R@1 -> 5 6 }

: 2>R1  ( n1 n2 -- n1 n2 )
  2>r ( r: n1 n2) r> ( n2) r> ( n2 n1) swap ;
{ 5 6 2>R1 -> 5 6 }

: 2R>1  ( n1 n2 -- n1 n2 )
  ( n2) >r ( r: n2) ( n1) >r ( r: n2 n1) 2r> ( n2 n1) swap ;
{ 5 6 2R>1 -> 5 6 }

testing NIP TUCK PICK ROLL

{ 1 2     nip -> 2 }
{ 1 2     tuck -> 2 1 2 }
{ 0 1 2 0 pick -> 0 1 2 2 }
{ 0 1 2 1 pick -> 0 1 2 1 }
{ 0 1 2 2 pick -> 0 1 2 0 }
{ 1 0     roll -> 1 }
{ 1 2 3 2 roll -> 2 3 1 }

0 INVERT CONSTANT MAX-UINT

testing UDM* DABS M*/ DS*

\ hex
{  0  0  0 udm* ->  0  0  0 }
{  2  0  3 udm* ->  6  0  0 }
{  0 -1  2 udm* ->  0 -2  1 }
{ -1  0  2 udm* -> -2  1  0 }
{ -1  0 -1 udm* ->  1 -2  0 }
{  0 -1 -1 udm* ->  0  1 -2 }
{ -1 -1 -1 udm* ->  1 -1 -2 }
{ minint minint  1 udm* -> minint minint  0 }
{ minint minint  4 udm* ->  0  2  2 }

{  0  0 dabs ->  0 0 }
{  1  0 dabs ->  1 0 }
{ -1  0 dabs -> -1 0 }
{ -1 -1 dabs ->  1 0 }
{ -3 -1 dabs ->  3 0 }
{  0 -1 dabs ->  0 1 }
{  1 -1 dabs -> -1 0 }
{  minint 0 dabs ->  minint 0 }
{ -1 maxint dabs -> -1 maxint }

{  0  0  0 ds* ->  0  0  0 }
{  1  0  0 ds* ->  0  0  0 }
{ -1  0  0 ds* ->  0  0  0 }
{  0 -1  0 ds* ->  0  0  0 }
{ -1 -1  0 ds* ->  0  0  0 }

{  1  0  1 ds* ->  1  0  0 }
{ -1  0  1 ds* -> -1  0  0 }
{ -1 -1  1 ds* -> -1 -1 -1 }

{  1  0 -1 ds* -> -1 -1 -1 }
{ -1  0 -1 ds* ->  1 -1 -1 }

{  0  0 0 1 m*/ ->  0   0 }
{  0  0 1 1 m*/ ->  0  0 }
{  1  0 0 1 m*/ ->  0  0 }
{  2  0 1 2 m*/ ->  1  0 }
{ -2 -1 1 2 m*/ -> -1 -1 }

{  0  0  1 m/ ->  0 }
{  1  0  1 m/ ->  1 }
{  1  0  2 m/ ->  0 }
{  2  0  2 m/ ->  1 }
{  0  0 -1 m/ ->  0 }
{  1  0 -1 m/ -> -1 }
{  1  0 -2 m/ ->  0 }
{  2  0 -2 m/ -> -1 }
{ -1  0  2 m/ ->  maxint }
{ -1 -1  1 m/ -> -1 }
{ -1 -1 -1 m/ ->  1 }

\ Uncommenting one of the commented lines should result in an
\ error.

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0  0 m*/ -> 0 }
\ {  1  0  1  0 m*/ -> 0 }
\ {  0  2  2  0 m*/ -> 0 }
\ { -1 -1  1  0 m*/ -> 0 }

\ To test precision overflow, leave the next lines uncommented.
\ They should not overflow.
{ 0 minint/2  1  1 m*/ ->  0  minint/2 }
{ 0 minint/2  1 -1 m*/ ->  0 -minint/2 }
{ 0 minint/2 -1  1 m*/ ->  0 -minint/2 }
{ 0 minint/2  4  4 m*/ ->  0  minint/2 }
{ 0 minint/2  4 -4 m*/ ->  0 -minint/2 }
{ 0 minint/2 -4  2 m*/ ->  0  minint }

\ But uncomment one of the following lines.
\ {  0 minint/2  4  1  m*/ -> 0 }
\ {  0 maxint maxint 3 m*/ -> 0 }
\ { -1 maxint 2  1     m*/ -> 0 }
\ {  0 minint  2  1    m*/ -> 0 }
\ {  0 minint -2 -1    m*/ -> 0 }
\ {  0 minint/2  4  2  m*/ -> 0 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0 m/ -> 0 }
\ {  1  0  0 m/ -> 0 }
\ {  0  2  0 m/ -> 0 } { -1 -1  0 m/ -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { 0 minint -1 m/ -> 0 }

\ Uncomment one of the following lines to test double precision
\ overflow.
\ {  0  2  1 m/ -> 0 }
\ {  0 -1  1 m/ -> 0  }
\ { -1  0  1 m/ -> -1 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  / -> 0 }
\ {  1  0  / -> 0 }
\ {  2  0  / -> 0 }
\ { -1  0  / -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { minint -1 / -> 0 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  mod -> 0 }
\ {  1  0  mod -> 0 }
\ {  2  0  mod -> 0 }
\ { -1  0  mod -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { minint -1 mod -> 0 }

\ Error tests for /MOD omitted, because the kForth error code is
\ so similar to that of / and MOD.

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0 */ -> 0 }
\ {  1  0  0 */ -> 0 }
\ {  2  0  0 */ -> 0 }
\ { -1 -1  0 */ -> 0 }
\ {  0  0  0 */mod -> 0 }
\ {  1  0  0 */mod -> 0 }
\ {  2  0  0 */mod -> 0 }
\ { -1 -1  0 */mod -> 0 }

\ To test precision overflow, leave the next lines uncommented.
\ They should not overflow.
{ minint/2  1  1 */ ->  minint/2 }
{ minint/2  1 -1 */ -> -minint/2 }
{ minint/2 -1  1 */ -> -minint/2 }
{ minint/2  1  1 */mod -> 0  minint/2 }
{ minint/2  1 -1 */mod -> 0 -minint/2 }
{ minint/2 -1  1 */mod -> 0 -minint/2 }

\ But uncomment one of the following lines.
\ { minint/2  4  1    */ -> 0 }
\ { maxint maxint  3  */ -> 0 }
\ { minint  2  1      */ -> 0 }
\ { minint -2 -1      */ -> 0 }
\ { minint/2  4  2    */ -> 0 }
\ { minint/2  4  1    */mod -> 0 }
\ { maxint  maxint  3 */mod -> 0 }
\ { minint  2  1      */mod -> 0 }
\ { minint -2 -1      */mod -> 0 }
\ { minint/2  4  2    */mod -> 0 }

\ There's no way to get positive number overflow with */ or */MOD.

testing DMAX DMIN

\ Based on core.4th.
{  0  0  1  0 dmax ->  1  0 }
{  1  0  2  0 dmax ->  2  0 }
{ -1 -1 -1 -1 dmax -> -1 -1 }
{ -1 -1  1  0 dmax ->  1  0 }
{  0  0  0  0 dmax ->  0  0 }
{  1  0  1  0 dmax ->  1  0 }
{  1  0  0  0 dmax ->  1  0 }
{  2  0  1  0 dmax ->  2  0 }
{  0  0 -1 -1 dmax ->  0  0 }
{  1  0 -1 -1 dmax ->  1  0 }
{  0 minint  0  0     dmax ->  0  0 }
{  0  0 -1 maxint     dmax -> -1 maxint }
{  0  0  0 minint     dmax ->  0  0 }
{ -1 maxint  0 minint dmax -> -1 maxint }
{ -1 maxint  0  0     dmax -> -1 maxint }

\ to catch use of D-, which overflows
{  0 minint -1 maxint dmax -> -1 maxint }

\ to catch failure to use low word unsigned compare
{  0  3 -1 2 dmax ->  0  3 }
{  0  3 -1 3 dmax -> -1  3 }
{ -1 2  0  3 dmax ->  0  3 }
{ -1 3  0  3 dmax -> -1  3 }

\ Based on core.4th.
{  0  0  1  0 dmin ->  0  0 }
{  1  0  2  0 dmin ->  1  0 }
{ -1 -1 -1 -1 dmin -> -1 -1 }
{ -1 -1  1  0 dmin -> -1 -1 }
{  0  0  0  0 dmin ->  0  0 }
{  1  0  1  0 dmin ->  1  0 }
{  1  0  0  0 dmin ->  0  0 }
{  2  0  1  0 dmin ->  1  0 }
{  0  0 -1 -1 dmin -> -1 -1 }
{  1  0 -1 -1 dmin -> -1 -1 }
{  0 minint  0  0     dmin ->  0 minint }
{  0  0 -1 maxint     dmin ->  0  0 }
{  0  0  0 minint     dmin ->  0 minint }
{ -1 maxint  0 minint dmin ->  0 minint }
{ -1 maxint  0  0     dmin ->  0  0 }

\ to catch use of D-, which overflows
{  0 minint -1 maxint dmin ->  0 minint }

\ to catch failure to use low word unsigned compare
{  0  3 -1  2 dmin -> -1  2 }
{  0  3 -1  3 dmin ->  0  3 }
{ -1  2  0  3 dmin -> -1  2 }
{ -1  3  0  3 dmin ->  0  3 }

COMMENT Uncomment lines in regress.4th to test errors.
