\ cg-test.4th
\
\  Test the precision and accuracy of the Clebsch-Gordan code (cg.4th)
\
\  K. Myneni, 2006-12-17
\
\  The values of the 3j symbols can be expressed as square-root fractions
\  of integers, from the product of powers of primes method described
\  in Appendix C of ref [2] from cg.4th. The prime number exponents
\  for the 3j symbols tested below are given in Table C-1, and were used
\  to compute the reference fractions, which are an *exact* representation
\  of the values.
\
\  Revisions:
\
\   2007-01-02  added more test cases  km
\   2007-01-04  added more half-integral argument test cases  km

include ans-words
include strings
include ftester
include fsl-util
include cg
	    
false to exact?
1e-16 fdup rel-near f! abs-near f! \ tolerance for comparison


\ The following range of arguments are outside of what the
\   current cg.4th code can properly evaluate.

0 [IF]

f{  3j( 6 3 3   0  0  0 )   f->   1 100  3003 /sqrt }f  
f{  3j( 6 4 4   0  0  0 )   f->  -1  20  1287 /sqrt }f
f{  3j( 6 5 5   0  0  0 )   f->   1  80  7293 /sqrt }f
f{  3j( 6 6 4   0  0  0 )   f->   1  28  2431 /sqrt }f
f{  3j( 6 6 6   0  0  0 )   f->  -1 400 46189 /sqrt }f
f{  3j( 7 5 4   0  0  0 )   f->   1 280 21879 /sqrt }f
f{  3j( 7 6 5   0  0  0 )   f->  -1 420 46189 /sqrt }f
f{  3j( 8 4 4   0  0  0 )   f->   1 490 21879 /sqrt }f
f{  3j( 8 5 3   0  0  0 )   f->   1  56  2431 /sqrt }f
f{  3j( 8 5 5   0  0  0 )   f->  -1 490 46189 /sqrt }f
f{  3j( 8 6 2   0  0  0 )   f->   1  28  1105 /sqrt }f
f{  3j( 8 6 4   0  0  0 )   f->  -1 504 46189 /sqrt }f
f{  3j( 8 6 6   0  0  0 )   f->   1 350 46189 /sqrt }f
f{  3j( 9 5 4   0  0  0 )   f->  -1 882 46189 /sqrt }f
f{  3j( 9 6 3   0  0  0 )   f->  -1  84  4199 /sqrt }f
f{  3j( 9 6 5   0  0  0 )   f->   1 420 46189 /sqrt }f
f{  3j( 10 5 5  0  0  0 )   f->   1 756 46189 /sqrt }f
f{  3j( 10 6 4  0  0  0 )   f->   1  70  4199 /sqrt }f
f{  3j( 10 6 6  0  0  0 )   f->  -1 756 96577 /sqrt }f
[THEN]


Testing Wigner 3j symbols ( whole arguments )

f{  3j( 0 0 0   0  0  0 )   f->   1   1     1 /sqrt }f
f{  3j( 1 1 0   0  0  0 )   f->  -1   1     3 /sqrt }f
f{  3j( 1 1 0   1 -1  0 )   f->   1   1     3 /sqrt }f
f{  3j( 1 1 1   1  0 -1 )   f->  -1   1     6 /sqrt }f
f{  3j( 2 1 1   0  0  0 )   f->   1   2    15 /sqrt }f
f{  3j( 2 1 1   0  1 -1 )   f->   1   1    30 /sqrt }f
f{  3j( 2 1 1   1  0 -1 )   f->  -1   1    10 /sqrt }f
f{  3j( 2 1 1   2 -1 -1 )   f->   1   1     5 /sqrt }f
f{  3j( 2 2 0   0  0  0 )   f->   1   1     5 /sqrt }f
f{  3j( 2 2 0   1 -1  0 )   f->  -1   1     5 /sqrt }f
f{  3j( 2 2 0   2 -2  0 )   f->   1   1     5 /sqrt }f
f{  3j( 2 2 1   1 -1  0 )   f->  -1   1    30 /sqrt }f
f{  3j( 2 2 1   1  0 -1 )   f->   1   1    10 /sqrt }f
f{  3j( 2 2 1   2 -2  0 )   f->   1   2    15 /sqrt }f
f{  3j( 2 2 1   2 -1 -1 )   f->  -1   1    15 /sqrt }f
f{  3j( 2 2 2   0  0  0 )   f->  -1   2    35 /sqrt }f
f{  3j( 2 2 2   1  0 -1 )   f->   1   1    70 /sqrt }f
f{  3j( 2 2 2   2 -1 -1 )   f->  -1   3    35 /sqrt }f
f{  3j( 2 2 2   2  0 -2 )   f->   1   2    35 /sqrt }f
f{  3j( 3 2 1   0  0  0 )   f->  -1   3    35 /sqrt }f
f{  3j( 3 2 1   0  1 -1 )   f->  -1   1    35 /sqrt }f
f{  3j( 3 2 1   1 -2  1 )   f->   1   1   105 /sqrt }f
f{  3j( 3 2 1   1 -1  0 )   f->   1   8   105 /sqrt }f
f{  3j( 3 2 1   1  0 -1 )   f->   1   2    35 /sqrt }f
f{  3j( 3 2 1   2 -2  0 )   f->  -1   1    21 /sqrt }f
f{  3j( 3 2 1   2 -1 -1 )   f->  -1   2    21 /sqrt }f
f{  3j( 3 2 1   3 -2 -1 )   f->   1   1     7 /sqrt }f
f{  3j( 3 2 2   0  1 -1 )   f->   1   2    35 /sqrt }f
f{  3j( 3 2 2   0  2 -2 )   f->   1   1    70 /sqrt }f
f{  3j( 3 2 2   1  0 -1 )   f->  -1   1    35 /sqrt }f
f{  3j( 3 2 2   1  1 -2 )   f->  -1   3    70 /sqrt }f
f{  3j( 3 2 2   2  0 -2 )   f->   1   1    14 /sqrt }f
f{  3j( 3 2 2   3 -1 -2 )   f->  -1   1    14 /sqrt }f
f{  3j( 3 3 0   0  0  0 )   f->  -1   1     7 /sqrt }f
f{  3j( 3 3 0   1 -1  0 )   f->   1   1     7 /sqrt }f
f{  3j( 3 3 0   2 -2  0 )   f->  -1   1     7 /sqrt }f
f{  3j( 3 3 0   3 -3  0 )   f->   1   1     7 /sqrt }f
f{  3j( 3 3 1   1 -1  0 )   f->   1   1    84 /sqrt }f
f{  3j( 3 3 1   1  0 -1 )   f->  -1   1    14 /sqrt }f
f{  3j( 3 3 1   2 -2  0 )   f->  -1   1    21 /sqrt }f
f{  3j( 3 3 1   2 -1 -1 )   f->   1   5    84 /sqrt }f
f{  3j( 3 3 1   3 -3  0 )   f->   1   3    28 /sqrt }f
f{  3j( 3 3 1   3 -2 -1 )   f->  -1   1    28 /sqrt }f
f{  3j( 3 3 2   0  0  0 )   f->   1   4   105 /sqrt }f
f{  3j( 3 3 2   1 -1  0 )   f->  -1   3   140 /sqrt }f
f{  3j( 3 3 2   1  0 -1 )   f->  -1   1   210 /sqrt }f
f{  3j( 3 3 2   1  1 -2 )   f->   1   2    35 /sqrt }f
f{  3j( 3 3 2   2 -2  0 )   f->   1   0     1 /sqrt }f
f{  3j( 3 3 2   2 -1 -1 )   f->   1   1    28 /sqrt }f
f{  3j( 3 3 2   2  0 -2 )   f->  -1   1    21 /sqrt }f
f{  3j( 3 3 2   3 -3  0 )   f->   1   5    84 /sqrt }f
f{  3j( 3 3 2   3 -2 -1 )   f->  -1   5    84 /sqrt }f
f{  3j( 3 3 2   3 -1 -2 )   f->   1   1    42 /sqrt }f
f{  3j( 3 3 3   1  0 -1 )   f->   1   1    42 /sqrt }f
f{  3j( 3 3 3   2  0 -2 )   f->  -1   1    42 /sqrt }f
f{  3j( 3 3 3   3 -1 -2 )   f->   1   1    21 /sqrt }f
f{  3j( 3 3 3   3  0 -3 )   f->  -1   1    42 /sqrt }f
f{  3j( 4 2 2   0  0  0 )   f->   1   2    35 /sqrt }f
f{  3j( 4 2 2   0  1 -1 )   f->   1   8   315 /sqrt }f
f{  3j( 4 2 2   0  2 -2 )   f->   1   1   630 /sqrt }f
f{  3j( 4 2 2   1  0 -1 )   f->  -1   1    21 /sqrt }f
f{  3j( 4 2 2   1  1 -2 )   f->  -1   1   126 /sqrt }f
f{  3j( 4 2 2   2 -1 -1 )   f->   1   4    63 /sqrt }f
f{  3j( 4 2 2   2  0 -2 )   f->   1   1    42 /sqrt }f
f{  3j( 4 2 2   3 -1 -2 )   f->  -1   1    18 /sqrt }f
f{  3j( 4 2 2   4 -2 -2 )   f->   1   1     9 /sqrt }f
f{  3j( 4 3 1   0  0  0 )   f->   1   4    63 /sqrt }f
f{  3j( 4 3 1   0  1 -1 )   f->   1   1    42 /sqrt }f
f{  3j( 4 3 1   1 -2  1 )   f->  -1   1    84 /sqrt }f
f{  3j( 4 3 1   1 -1  0 )   f->  -1   5    84 /sqrt }f
f{  3j( 4 3 1   1  0 -1 )   f->  -1   5   126 /sqrt }f
f{  3j( 4 3 1   2 -3  1 )   f->   1   1   252 /sqrt }f
f{  3j( 4 3 1   2 -2  0 )   f->   1   1    21 /sqrt }f
f{  3j( 4 3 1   2 -1 -1 )   f->   1   5    84 /sqrt }f
f{  3j( 4 3 1   3 -3  0 )   f->  -1   1    36 /sqrt }f
f{  3j( 4 3 1   3 -2 -1 )   f->  -1   1    12 /sqrt }f
f{  3j( 4 3 1   4 -3 -1 )   f->   1   1     9 /sqrt }f
f{  3j( 4 3 2   0  1 -1 )   f->  -1   5   126 /sqrt }f
f{  3j( 4 3 2   0  2 -2 )   f->  -1   1    63 /sqrt }f
f{  3j( 4 3 2   1 -3  2 )   f->  -1   1   210 /sqrt }f
f{  3j( 4 3 2   1 -2  1 )   f->  -1   7   180 /sqrt }f
f{  3j( 4 3 2   1 -1  0 )   f->  -1   1    84 /sqrt }f
f{  3j( 4 3 2   1  0 -1 )   f->   1   1    42 /sqrt }f
f{  3j( 4 3 2   1  1 -2 )   f->   1   2    63 /sqrt }f
f{  3j( 4 3 2   2 -3  1 )   f->   1   3   140 /sqrt }f
f{  3j( 4 3 2   2 -2  0 )   f->   1   4   105 /sqrt }f
f{  3j( 4 3 2   2 -1 -1 )   f->  -1   1   252 /sqrt }f
f{  3j( 4 3 2   2  0 -2 )   f->  -1   1    21 /sqrt }f
f{  3j( 4 3 2   3 -3  0 )   f->  -1   1    20 /sqrt }f
f{  3j( 4 3 2   3 -2 -1 )   f->  -1   1   180 /sqrt }f
f{  3j( 4 3 2   3 -1 -2 )   f->   1   1    18 /sqrt }f
f{  3j( 4 3 2   4 -3 -1 )   f->   1   1    15 /sqrt }f
f{  3j( 4 3 2   4 -2 -2 )   f->  -1   2    45 /sqrt }f
f{  3j( 4 3 3   0  0  0 )   f->  -1   2    77 /sqrt }f
f{  3j( 4 3 3   0  1 -1 )   f->   1   1  1386 /sqrt }f
f{  3j( 4 3 3   0  2 -2 )   f->   1   7   198 /sqrt }f
f{  3j( 4 3 3   0  3 -3 )   f->   1   1   154 /sqrt }f
f{  3j( 4 3 3   1  0 -1 )   f->   1   5   462 /sqrt }f
f{  3j( 4 3 3   1  1 -2 )   f->  -1  16   693 /sqrt }f
f{  3j( 4 3 3   1  2 -3 )   f->  -1   5   231 /sqrt }f
f{  3j( 4 3 3   2 -1 -1 )   f->  -1  20   693 /sqrt }f
f{  3j( 4 3 3   2  0 -2 )   f->   1   1   462 /sqrt }f
f{  3j( 4 3 3   2  1 -3 )   f->   1   3    77 /sqrt }f
f{  3j( 4 3 3   3 -1 -2 )   f->   1   1    99 /sqrt }f
f{  3j( 4 3 3   3  0 -3 )   f->  -1   1    22 /sqrt }f
f{  3j( 4 3 3   4 -2 -2 )   f->  -1   5    99 /sqrt }f
f{  3j( 4 3 3   4 -1 -3 )   f->   1   1    33 /sqrt }f
f{  3j( 4 4 0   0  0  0 )   f->   1   1     9 /sqrt }f
f{  3j( 4 4 0   1 -1  0 )   f->  -1   1     9 /sqrt }f
f{  3j( 4 4 0   2 -2  0 )   f->   1   1     9 /sqrt }f
f{  3j( 4 4 0   3 -3  0 )   f->  -1   1     9 /sqrt }f
f{  3j( 4 4 0   4 -4  0 )   f->   1   1     9 /sqrt }f
f{  3j( 4 4 1   1 -1  0 )   f->  -1   1   180 /sqrt }f
f{  3j( 4 4 1   1  0 -1 )   f->   1   1    18 /sqrt }f
f{  3j( 4 4 1   2 -2  0 )   f->   1   1    45 /sqrt }f
f{  3j( 4 4 1   2 -1 -1 )   f->  -1   1    20 /sqrt }f
f{  3j( 4 4 1   3 -3  0 )   f->  -1   1    20 /sqrt }f
f{  3j( 4 4 1   3 -2 -1 )   f->   1   7   180 /sqrt }f
f{  3j( 4 4 1   4 -4  0 )   f->   1   4    45 /sqrt }f
f{  3j( 4 4 1   4 -3 -1 )   f->  -1   1    45 /sqrt }f
f{  3j( 4 4 2   0  0  0 )   f->  -1  20   693 /sqrt }f
f{  3j( 4 4 2   1 -1  0 )   f->   1 289 13860 /sqrt }f
f{  3j( 4 4 2   1  0 -1 )   f->   1   1   462 /sqrt }f
f{  3j( 4 4 2   1  1 -2 )   f->  -1  10   231 /sqrt }f
f{  3j( 4 4 2   2 -2  0 )   f->  -1  16  3465 /sqrt }f
f{  3j( 4 4 2   2 -1 -1 )   f->  -1  27  1540 /sqrt }f
f{  3j( 4 4 2   2  0 -2 )   f->   1   3    77 /sqrt }f
f{  3j( 4 4 2   3 -3  0 )   f->  -1   7  1980 /sqrt }f
f{  3j( 4 4 2   3 -2 -1 )   f->   1   5   132 /sqrt }f
f{  3j( 4 4 2   3 -1 -2 )   f->  -1   3   110 /sqrt }f
f{  3j( 4 4 2   4 -4  0 )   f->   1  28   495 /sqrt }f
f{  3j( 4 4 2   4 -3 -1 )   f->  -1   7   165 /sqrt }f
f{  3j( 4 4 2   4 -2 -2 )   f->   1   2   165 /sqrt }f
f{  3j( 4 4 3   1 -1  0 )   f->   1   9   770 /sqrt }f
f{  3j( 4 4 3   1  0 -1 )   f->  -1   3   154 /sqrt }f
f{  3j( 4 4 3   2 -2  0 )   f->  -1 169  6930 /sqrt }f
f{  3j( 4 4 3   2 -1 -1 )   f->   1   4  1155 /sqrt }f
f{  3j( 4 4 3   2  0 -2 )   f->   1   5   462 /sqrt }f
f{  3j( 4 4 3   2  1 -3 )   f->  -1  25   693 /sqrt }f
f{  3j( 4 4 3   3 -3  0 )   f->   1   7   990 /sqrt }f
f{  3j( 4 4 3   3 -2 -1 )   f->   1   1   165 /sqrt }f
f{  3j( 4 4 3   3 -1 -2 )   f->  -1   1    33 /sqrt }f
f{  3j( 4 4 3   3  0 -3 )   f->   1   5   198 /sqrt }f
f{  3j( 4 4 3   4 -4  0 )   f->   1  14   495 /sqrt }f
f{  3j( 4 4 3   4 -3 -1 )   f->  -1   7   165 /sqrt }f
f{  3j( 4 4 3   4 -2 -2 )   f->   1   1    33 /sqrt }f
f{  3j( 4 4 3   4 -1 -3 )   f->  -1   1    99 /sqrt }f
f{  3j( 4 4 4   0  0  0 )   f->   1  18  1001 /sqrt }f
f{  3j( 4 4 4   1  0 -1 )   f->  -1   9  2002 /sqrt }f
f{  3j( 4 4 4   2 -1 -1 )   f->   1  20  1001 /sqrt }f
f{  3j( 4 4 4   2  0 -2 )   f->  -1  11  1638 /sqrt }f
f{  3j( 4 4 4   3 -1 -2 )   f->  -1   5  1287 /sqrt }f
f{  3j( 4 4 4   3  0 -3 )   f->   1   7   286 /sqrt }f
f{  3j( 4 4 4   4 -2 -2 )   f->   1   5   143 /sqrt }f
f{  3j( 4 4 4   4 -1 -3 )   f->  -1  35  1287 /sqrt }f
f{  3j( 4 4 4   4  0 -4 )   f->   1  14  1287 /sqrt }f
f{  3j( 5 3 2   0  0  0 )   f->  -1  10   231 /sqrt }f
f{  3j( 5 4 1   0  0  0 )   f->  -1   5    99 /sqrt }f
f{  3j( 5 4 3   0  0  0 )   f->   1  20  1001 /sqrt }f
f{  3j( 5 5 0   0  0  0 )   f->  -1   1    11 /sqrt }f
f{  3j( 5 5 2   0  0  0 )   f->   1  10   429 /sqrt }f 
f{  3j( 5 5 4   0  0  0 )   f->  -1   2   143 /sqrt }f
f{  3j( 6 4 2   0  0  0 )   f->   1   5   143 /sqrt }f
f{  3j( 6 5 1   0  0  0 )   f->   1   6   143 /sqrt }f
f{  3j( 6 5 3   0  0  0 )   f->  -1   7   429 /sqrt }f
f{  3j( 6 6 0   0  0  0 )   f->   1   1    13 /sqrt }f
f{  3j( 6 6 2   0  0  0 )   f->  -1  14   715 /sqrt }f
f{  3j( 7 4 3   0  0  0 )   f->  -1  35  1287 /sqrt }f
f{  3j( 7 5 2   0  0  0 )   f->  -1  21   715 /sqrt }f
f{  3j( 7 6 1   0  0  0 )   f->  -1   7   195 /sqrt }f
f{  3j( 7 6 3   0  0  0 )   f->   1 168 12155 /sqrt }f


Testing Wigner 3j symbols ( half integral arguments )

f{  3j( 1/2  1/2  0     1/2  -1/2   0   )  f->  1  1   2 /sqrt }f

f{  3j( 1    1/2  1/2   0     1/2  -1/2 )  f->  1  1   6 /sqrt }f
f{  3j( 1    1/2  1/2   1    -1/2  -1/2 )  f-> -1  1   3 /sqrt }f

f{  3j( 3/2  1    1/2   1/2  -1     1/2 )  f->  1  1  12 /sqrt }f
f{  3j( 3/2  1    1/2   1/2   0    -1/2 )  f->  1  1   6 /sqrt }f
f{  3j( 3/2  1    1/2   3/2  -1    -1/2 )  f-> -1  1   4 /sqrt }f

f{  3j( 3/2  3/2  0     1/2  -1/2   0   )  f-> -1  1   4 /sqrt }f
f{  3j( 3/2  3/2  0     3/2  -3/2   0   )  f->  1  1   4 /sqrt }f

f{  3j( 3/2  3/2  1     1/2  -1/2   0   )  f-> -1  1  60 /sqrt }f
f{  3j( 3/2  3/2  1     1/2   1/2  -1   )  f->  1  2  15 /sqrt }f
f{  3j( 3/2  3/2  1     3/2  -3/2   0   )  f->  1  3  20 /sqrt }f
f{  3j( 3/2  3/2  1     3/2  -1/2  -1   )  f-> -1  1  10 /sqrt }f

f{  3j( 2    3/2  1/2   0     1/2  -1/2 )  f-> -1  1  10 /sqrt }f
f{  3j( 2    3/2  1/2   1    -3/2   1/2 )  f->  1  1  20 /sqrt }f
f{  3j( 2    3/2  1/2   1    -1/2  -1/2 )  f->  1  3  20 /sqrt }f
f{  3j( 2    3/2  1/2   2    -3/2  -1/2 )  f-> -1  1   5 /sqrt }f

f{  3j( 2    3/2  3/2   0     1/2  -1/2 )  f->  1  1  20 /sqrt }f
f{  3j( 2    3/2  3/2   0     3/2  -3/2 )  f->  1  1  20 /sqrt }f
f{  3j( 2    3/2  3/2   1     1/2  -3/2 )  f-> -1  1  10 /sqrt }f
f{  3j( 2    3/2  3/2   2    -1/2  -3/2 )  f->  1  1  10 /sqrt }f

f{  3j( 5/2  3/2  1     1/2  -3/2   1   )  f->  1  1  60 /sqrt }f
f{  3j( 5/2  3/2  1     1/2  -1/2   0   )  f->  1  1  10 /sqrt }f
f{  3j( 5/2  3/2  1     1/2   1/2  -1   )  f->  1  1  20 /sqrt }f
f{  3j( 5/2  3/2  1     3/2  -3/2   0   )  f-> -1  1  15 /sqrt }f
f{  3j( 5/2  3/2  1     3/2  -1/2  -1   )  f-> -1  1  10 /sqrt }f
f{  3j( 5/2  3/2  1     5/2  -3/2  -1   )  f->  1  1   6 /sqrt }f

f{  3j( 5/2  2    1/2   1/2  -1     1/2 )  f-> -1  1  15 /sqrt }f
f{  3j( 5/2  2    1/2   1/2   0    -1/2 )  f-> -1  1  10 /sqrt }f
f{  3j( 5/2  2    1/2   3/2  -2     1/2 )  f->  1  1  30 /sqrt }f
f{  3j( 5/2  2    1/2   3/2  -1    -1/2 )  f->  1  2  15 /sqrt }f
f{  3j( 5/2  2    1/2   5/2  -2    -1/2 )  f-> -1  1   6 /sqrt }f

f{  3j( 5/2  2    3/2   1/2  -2     3/2 )  f-> -1  1  35 /sqrt }f
f{  3j( 5/2  2    3/2   1/2  -1     1/2 )  f-> -1  5  84 /sqrt }f
f{  3j( 5/2  2    3/2   1/2   0    -1/2 )  f->  1  1  70 /sqrt }f
f{  3j( 5/2  2    3/2   1/2   1    -3/2 )  f->  1  9 140 /sqrt }f
f{  3j( 5/2  2    3/2   3/2  -2     1/2 )  f->  1  8 105 /sqrt }f
f{  3j( 5/2  2    3/2   3/2  -1    -1/2 )  f->  1  1 210 /sqrt }f
f{  3j( 5/2  2    3/2   3/2   0    -3/2 )  f-> -1  3  35 /sqrt }f
f{  3j( 5/2  2    3/2   5/2  -2    -1/2 )  f-> -1  2  21 /sqrt }f
f{  3j( 5/2  2    3/2   5/2  -1    -3/2 )  f->  1  1  14 /sqrt }f

f{  3j( 5/2  5/2  0     1/2  -1/2   0   )  f->  1  1   6 /sqrt }f
f{  3j( 5/2  5/2  0     3/2  -3/2   0   )  f-> -1  1   6 /sqrt }f
f{  3j( 5/2  5/2  0     5/2  -5/2   0   )  f->  1  1   6 /sqrt }f

f{  3j( 5/2  5/2  1     1/2  -1/2   0   )  f->  1  1 210 /sqrt }f
f{  3j( 5/2  5/2  1     1/2   1/2  -1   )  f-> -1  3  35 /sqrt }f
f{  3j( 5/2  5/2  1     3/2  -3/2   0   )  f-> -1  3  70 /sqrt }f
f{  3j( 5/2  5/2  1     3/2  -1/2  -1   )  f->  1  8 105 /sqrt }f
f{  3j( 5/2  5/2  1     5/2  -5/2   0   )  f->  1  5  42 /sqrt }f
f{  3j( 5/2  5/2  1     5/2  -3/2  -1   )  f-> -1  1  21 /sqrt }f

f{  3j( 5/2  5/2  2     1/2  -1/2   0   )  f-> -1  4 105 /sqrt }f
f{  3j( 5/2  5/2  2     3/2  -3/2   0   )  f->  1  1 420 /sqrt }f
f{  3j( 5/2  5/2  2     3/2  -1/2  -1   )  f->  1  1  35 /sqrt }f
f{  3j( 5/2  5/2  2     3/2   1/2  -2   )  f-> -1  9 140 /sqrt }f
f{  3j( 5/2  5/2  2     5/2  -5/2   0   )  f->  1  5  84 /sqrt }f
f{  3j( 5/2  5/2  2     5/2  -3/2  -1   )  f-> -1  1  14 /sqrt }f
f{  3j( 5/2  5/2  2     5/2  -1/2  -2   )  f->  1  1  28 /sqrt }f

f{  3j( 3    3/2  3/2   0     1/2  -1/2 )  f->  1  9 140 /sqrt }f
f{  3j( 3    3/2  3/2   0     3/2  -3/2 )  f->  1  1 140 /sqrt }f
f{  3j( 3    3/2  3/2   1    -1/2  -1/2 )  f-> -1  3  35 /sqrt }f
f{  3j( 3    3/2  3/2   1     1/2  -3/2 )  f-> -1  1  35 /sqrt }f
f{  3j( 3    3/2  3/2   2    -1/2  -3/2 )  f->  1  1  14 /sqrt }f
f{  3j( 3    3/2  3/2   3    -3/2  -3/2 )  f-> -1  1   7 /sqrt }f

f{  3j( 3    5/2  1/2   0     1/2  -1/2 )  f->  1  1  14 /sqrt }f
f{  3j( 3    5/2  1/2   1    -3/2   1/2 )  f-> -1  1  21 /sqrt }f
f{  3j( 3    5/2  1/2   1    -1/2  -1/2 )  f-> -1  2  21 /sqrt }f
f{  3j( 3    5/2  1/2   2    -5/2   1/2 )  f->  1  1  42 /sqrt }f
f{  3j( 3    5/2  1/2   2    -3/2  -1/2 )  f->  1  5  42 /sqrt }f
f{  3j( 3    5/2  1/2   3    -5/2  -1/2 )  f-> -1  1   7 /sqrt }f

f{  3j( 3    5/2  3/2   0     1/2  -1/2 )  f-> -1  1  35 /sqrt }f
f{  3j( 3    5/2  3/2   0     3/2  -3/2 )  f-> -1  3  70 /sqrt }f
f{  3j( 3    5/2  3/2   1    -5/2   3/2 )  f-> -1  1  56 /sqrt }f
f{  3j( 3    5/2  3/2   1    -3/2   1/2 )  f-> -1  7 120 /sqrt }f
f{  3j( 3    5/2  3/2   1    -1/2  -1/2 )  f->  1  1 420 /sqrt }f
f{  3j( 3    5/2  3/2   1     1/2  -3/2 )  f->  1  9 140 /sqrt }f
f{  3j( 3    5/2  3/2   2    -5/2   1/2 )  f->  1  5  84 /sqrt }f
f{  3j( 3    5/2  3/2   2    -3/2  -1/2 )  f->  1  1  84 /sqrt }f
f{  3j( 3    5/2  3/2   2    -1/2  -3/2 )  f-> -1  1  14 /sqrt }f
f{  3j( 3    5/2  3/2   3    -5/2  -1/2 )  f-> -1  5  56 /sqrt }f
f{  3j( 3    5/2  3/2   3    -3/2  -3/2 )  f->  1  3  56 /sqrt }f

f{  3j( 3    5/2  5/2   0     1/2  -1/2 )  f-> -1  4 315 /sqrt }f
f{  3j( 3    5/2  5/2   0     3/2  -3/2 )  f->  1  7 180 /sqrt }f
f{  3j( 3    5/2  5/2   0     5/2  -5/2 )  f->  1  5 252 /sqrt }f
f{  3j( 3    5/2  5/2   1    -1/2  -1/2 )  f->  1  4 105 /sqrt }f
f{  3j( 3    5/2  5/2   1     1/2  -3/2 )  f-> -1  1 210 /sqrt }f
f{  3j( 3    5/2  5/2   1     3/2  -5/2 )  f-> -1  1  21 /sqrt }f
f{  3j( 3    5/2  5/2   2    -1/2  -3/2 )  f-> -1  1  84 /sqrt }f
f{  3j( 3    5/2  5/2   2     1/2  -5/2 )  f->  1  5  84 /sqrt }f
f{  3j( 3    5/2  5/2   3    -3/2  -3/2 )  f->  1  4  63 /sqrt }f
f{  3j( 3    5/2  5/2   3    -1/2  -5/2 )  f-> -1  5 126 /sqrt }f

f{  3j( 7/2  2    3/2   1/2  -2     3/2 )  f->  1  1 280 /sqrt }f
f{  3j( 7/2  2    3/2   1/2  -1     1/2 )  f->  1  3  70 /sqrt }f
f{  3j( 7/2  2    3/2   1/2   0    -1/2 )  f->  1  9 140 /sqrt }f
f{  3j( 7/2  2    3/2   1/2   1    -3/2 )  f->  1  1  70 /sqrt }f
f{  3j( 7/2  2    3/2   3/2  -2     1/2 )  f-> -1  1  56 /sqrt }f
f{  3j( 7/2  2    3/2   3/2  -1    -1/2 )  f-> -1  1  14 /sqrt }f
f{  3j( 7/2  2    3/2   3/2   0    -3/2 )  f-> -1  1  28 /sqrt }f
f{  3j( 7/2  2    3/2   5/2  -2    -1/2 )  f->  1  3  56 /sqrt }f
f{  3j( 7/2  2    3/2   5/2  -1    -3/2 )  f->  1  1  14 /sqrt }f
f{  3j( 7/2  2    3/2   7/2  -2    -3/2 )  f-> -1  1   8 /sqrt }f

f{  3j( 7/2  5/2  1     1/2  -3/2   1   )  f-> -1  1  56 /sqrt }f
f{  3j( 7/2  5/2  1     1/2  -1/2   0   )  f-> -1  1  14 /sqrt }f
f{  3j( 7/2  5/2  1     1/2   1/2  -1   )  f-> -1  1  28 /sqrt }f
f{  3j( 7/2  5/2  1     3/2  -5/2   1   )  f->  1  1 168 /sqrt }f
f{  3j( 7/2  5/2  1     3/2  -3/2   0   )  f->  1  5  84 /sqrt }f
f{  3j( 7/2  5/2  1     3/2  -1/2  -1   )  f->  1  5  84 /sqrt }f
f{  3j( 7/2  5/2  1     5/2  -5/2   0   )  f-> -1  1  28 /sqrt }f
f{  3j( 7/2  5/2  1     5/2  -3/2  -1   )  f-> -1  5  56 /sqrt }f
f{  3j( 7/2  5/2  1     7/2  -5/2  -1   )  f->  1  1   8 /sqrt }f



