\           File:  regress.4th
\          Title:  Regression tests
\         Author:  David N. Williams
\        License:  Public Domain, except for GPL in D+ and D- tests
\  Starting date:  March 22, 2006
\        Revised:  August 1, 2007
\        Revised:  March 16, 2008  km; removed "include ans-words"

include tester.4th
\ include div-test.4th

: cell-  ( n -- n' )  1 cells - ;

\ from core.4th:
0 INVERT                 CONSTANT  maxuint
0 INVERT 1 RSHIFT        CONSTANT  maxint
0 INVERT 1 RSHIFT INVERT CONSTANT  minint

minint   1 RSHIFT        CONSTANT  minint/2
minint/2 NEGATE          CONSTANT -minint/2 

create pad 512 allot

testing 0<> 0> <> U>

hex
{  5 0<> -> true }
{  0 0<> -> false }
{ -1 0<> -> true }
{ maxint 0>  -> true }
{ -1 0>  -> false }
{  0 0>  -> false }
{  0  1 <>  -> true }
{  0  0 <>  -> false }
{ -1 -2 u> -> true }
{ -1 -1 u> -> false }
{  1  1 u> -> false }
{  1  0 u> -> true }
{ -1  0 u> -> true }

testing W@  W!

variable scratch

{ 1ffff scratch w! -> }
{ scratch w@ -> -1 }
{ -1   scratch w! scratch w@ -> -1 }
{ 7fff scratch w! scratch w@ -> 7fff }

testing <= >= -ROT 2ROT

{ -1  0 <= -> true }
{  0  0 <= -> true }
{  1  0 <= -> false }
{ -2 -1 <= -> true }
{ -1 -1 <= -> true }
{  0 -1 <= -> false }

{ -1  0 >= -> false }
{  0  0 >= -> true }
{  1  0 >= -> true }
{ -2 -1 >= -> false }
{ -1 -1 >= -> true }
{  0 -1 >= -> true }

{ 1 2 3 -rot -> 3 1 2 }

{ 1 2 3 4 5 6 2rot -> 3 4 5 6 1 2 }

testing 2+ 2-

{  3 2+ ->  5 }
{ -1 2+ ->  1 }
{ -2 2+ ->  0 }
{  3 2- ->  1 }
{  2 2- ->  0 }
{  1 2- -> -1 }

\ testing DNEGATE
\ testing D<
comment Need tests for DNEGATE D< besides Gforth

\ testing DU<

decimal
{     2 0    3 0 du< -> true  }
{     3 0    3 0 du< -> false }
{     4 0    3 0 du< -> false }
{     2 0 5000 1 du< -> true } 
{     2 1 5000 1 du< -> true }
{     2 2 5000 1 du< -> false }
{ 20000 1 5000 1 du< -> false }
{  5000 1 5000 1 du< -> false }
{  4999 1 5000 1 du< -> true }

hex
{ -1 maxint 0 -1 du< -> true }
{ -1 minint 0 -1 du<  -> true }
{ -1 minint 0 90000000 du< -> true }

testing CMOVE  CMOVE>  FILL  ERASE

decimal

: ?chars  ( addr u char -- )
  -rot ( char addr u) over >r + r>
  ( char addr+u addr)
  DO i c@ over <> abort" ***character doesn't match" LOOP
  drop ;

0 pad c!   0 pad 511 + c!
{ pad 1+ 510 21 fill -> }
{ pad c@ pad 511 + c@ -> 0 0 }
pad 1+ 510 21 ?chars

3 pad c!   3 pad 511 + c!
{ pad 0 5 fill pad c@ -> 3 }

{ pad 1+ 510 erase -> }
{ pad c@ pad 511 + c@ -> 3 3 }
pad 1+ 510 0 ?chars

{ pad 0 erase pad c@ -> 3 }

: upper-pad-fill  ( char -- )  pad 256 rot fill ;
: lower-pad-fill  ( char -- )  pad 256 + 256 rot fill ;

3 upper-pad-fill   0 lower-pad-fill
{ pad 1+ pad 257 + 254 cmove -> }
{ pad 256 + c@ pad 511 + c@ -> 0 0 }
pad 257 + 254 3 ?chars

0 lower-pad-fill
{ pad 1+ pad 257 + 254 cmove> -> }
{ pad 256 + c@ pad 511 + c@ -> 0 0 }
pad 257 + 254 3 ?chars

5 0 DO i 1+ pad i + c! LOOP  \ PAD chars: 1 2 3 4 5
pad pad 1+ 4 cmove
{ pad 5 +  pad DO i c@ LOOP -> 1 1 1 1 1 } 

5 0 DO i 1+ pad i + c! LOOP  \ PAD chars: 1 2 3 4 5
pad pad 5 cmove>
{ pad 5 +  pad DO i c@ LOOP -> 1 2 3 4 5 }

testing SP@  RP@  SP!  RP!  2R@  2>R  2R>

{ 33 sp@ @ = -> true }  \ not airtight
{ 35 sp@ @ = -> true }  \ but this makes it almost certain

: RP@1  ( n -- n )  >r rp@ @ r> drop ;
{ 33 RP@1 -> 33 }
{ 35 RP@1 -> 35 }  \ overkill

: 2R@1  ( n1 n2 -- n1 n2 )
  ( n2) >r ( n1) >r ( r: n2 n1) 2r@ ( n2 n1) swap
  r> drop r> drop ;
{ 5 6 2R@1 -> 5 6 }

: 2>R1  ( n1 n2 -- n1 n2 )
  2>r ( r: n1 n2) r> ( n2) r> ( n2 n1) swap ;
{ 5 6 2>R1 -> 5 6 }

: 2R>1  ( n1 n2 -- n1 n2 )
  ( n2) >r ( r: n2) ( n1) >r ( r: n2 n1) 2r> ( n2 n1) swap ;
{ 5 6 2R>1 -> 5 6 }

{ 33 34 sp@ cell+ sp! -> 33 }
{ 33 >r 34 >r rp@ cell+ rp! r> -> 33 }
{ sp@ cell- dup scratch ! sp! sp@ nip -> scratch @ } 
{ rp@ cell- dup scratch ! rp! rp@ dup cell+ rp! -> scratch @ } 

testing NIP TUCK PICK ROLL

{ 1 2     nip -> 2 }
{ 1 2     tuck -> 2 1 2 }
{ 0 1 2 0 pick -> 0 1 2 2 }
{ 0 1 2 1 pick -> 0 1 2 1 }
{ 0 1 2 2 pick -> 0 1 2 0 }
{ 1 0     roll -> 1 }
{ 1 2 3 2 roll -> 2 3 1 }

0 INVERT CONSTANT MAX-UINT

testing UDM* DABS M*/ DS*

\ hex
{  0  0  0 udm* ->  0  0  0 }
{  2  0  3 udm* ->  6  0  0 }
{  0 -1  2 udm* ->  0 -2  1 }
{ -1  0  2 udm* -> -2  1  0 }
{ -1  0 -1 udm* ->  1 -2  0 }
{  0 -1 -1 udm* ->  0  1 -2 }
{ -1 -1 -1 udm* ->  1 -1 -2 }
{ minint minint  1 udm* -> minint minint  0 }
{ minint minint  4 udm* ->  0  2  2 }

{  0  0 dabs ->  0 0 }
{  1  0 dabs ->  1 0 }
{ -1  0 dabs -> -1 0 }
{ -1 -1 dabs ->  1 0 }
{ -3 -1 dabs ->  3 0 }
{  0 -1 dabs ->  0 1 }
{  1 -1 dabs -> -1 0 }
{  minint 0 dabs ->  minint 0 }
{ -1 maxint dabs -> -1 maxint }

{  0  0  0 ds* ->  0  0  0 }
{  1  0  0 ds* ->  0  0  0 }
{ -1  0  0 ds* ->  0  0  0 }
{  0 -1  0 ds* ->  0  0  0 }
{ -1 -1  0 ds* ->  0  0  0 }

{  1  0  1 ds* ->  1  0  0 }
{ -1  0  1 ds* -> -1  0  0 }
{ -1 -1  1 ds* -> -1 -1 -1 }

{  1  0 -1 ds* -> -1 -1 -1 }
{ -1  0 -1 ds* ->  1 -1 -1 }

{  0  0 0 1 m*/ ->  0   0 }
{  0  0 1 1 m*/ ->  0  0 }
{  1  0 0 1 m*/ ->  0  0 }
{  2  0 1 2 m*/ ->  1  0 }
{ -2 -1 1 2 m*/ -> -1 -1 }

{  0  0  1 m/ ->  0 }
{  1  0  1 m/ ->  1 }
{  1  0  2 m/ ->  0 }
{  2  0  2 m/ ->  1 }
{  0  0 -1 m/ ->  0 }
{  1  0 -1 m/ -> -1 }
{  1  0 -2 m/ ->  0 }
{  2  0 -2 m/ -> -1 }
{ -1  0  2 m/ ->  maxint }
{ -1 -1  1 m/ -> -1 }
{ -1 -1 -1 m/ ->  1 }

\ Uncommenting one of the commented lines should result in an
\ error.

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0  0 m*/ -> 0 }
\ {  1  0  1  0 m*/ -> 0 }
\ {  0  2  2  0 m*/ -> 0 }
\ { -1 -1  1  0 m*/ -> 0 }

\ To test precision overflow, leave the next lines uncommented.
\ They should not overflow.
{ 0 minint/2  1  1 m*/ ->  0  minint/2 }
{ 0 minint/2  1 -1 m*/ ->  0 -minint/2 }
{ 0 minint/2 -1  1 m*/ ->  0 -minint/2 }
{ 0 minint/2  4  4 m*/ ->  0  minint/2 }
{ 0 minint/2  4 -4 m*/ ->  0 -minint/2 }
{ 0 minint/2 -4  2 m*/ ->  0  minint }

\ But uncomment one of the following lines.
\ {  0 minint/2  4  1  m*/ -> 0 }
\ {  0 maxint maxint 3 m*/ -> 0 }
\ { -1 maxint 2  1     m*/ -> 0 }
\ {  0 minint  2  1    m*/ -> 0 }
\ {  0 minint -2 -1    m*/ -> 0 }
\ {  0 minint/2  4  2  m*/ -> 0 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0 m/ -> 0 }
\ {  1  0  0 m/ -> 0 }
\ {  0  2  0 m/ -> 0 } { -1 -1  0 m/ -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { 0 minint -1 m/ -> 0 }

\ Uncomment one of the following lines to test double precision
\ overflow.
\ {  0  2  1 m/ -> 0 }
\ {  0 -1  1 m/ -> 0  }
\ { -1  0  1 m/ -> -1 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  / -> 0 }
\ {  1  0  / -> 0 }
\ {  2  0  / -> 0 }
\ { -1  0  / -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { minint -1 / -> 0 }

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  mod -> 0 }
\ {  1  0  mod -> 0 }
\ {  2  0  mod -> 0 }
\ { -1  0  mod -> 0 }

\ Uncomment the following line to test positive number overflow.
\ { minint -1 mod -> 0 }

\ Error tests for /MOD omitted, because the kForth error code is
\ so similar to that of / and MOD.

\ Uncomment one of the following lines to test divide by zero.
\ {  0  0  0 */ -> 0 }
\ {  1  0  0 */ -> 0 }
\ {  2  0  0 */ -> 0 }
\ { -1 -1  0 */ -> 0 }
\ {  0  0  0 */mod -> 0 }
\ {  1  0  0 */mod -> 0 }
\ {  2  0  0 */mod -> 0 }
\ { -1 -1  0 */mod -> 0 }

\ To test precision overflow, leave the next lines uncommented.
\ They should not overflow.
{ minint/2  1  1 */ ->  minint/2 }
{ minint/2  1 -1 */ -> -minint/2 }
{ minint/2 -1  1 */ -> -minint/2 }
{ minint/2  1  1 */mod -> 0  minint/2 }
{ minint/2  1 -1 */mod -> 0 -minint/2 }
{ minint/2 -1  1 */mod -> 0 -minint/2 }

\ But uncomment one of the following lines.
\ { minint/2  4  1    */ -> 0 }
\ { maxint maxint  3  */ -> 0 }
\ { minint  2  1      */ -> 0 }
\ { minint -2 -1      */ -> 0 }
\ { minint/2  4  2    */ -> 0 }
\ { minint/2  4  1    */mod -> 0 }
\ { maxint  maxint  3 */mod -> 0 }
\ { minint  2  1      */mod -> 0 }
\ { minint -2 -1      */mod -> 0 }
\ { minint/2  4  2    */mod -> 0 }

\ There's no way to get positive number overflow with */ or */MOD.

testing DMAX DMIN

\ Based on core.4th.
{  0  0  1  0 dmax ->  1  0 }
{  1  0  2  0 dmax ->  2  0 }
{ -1 -1 -1 -1 dmax -> -1 -1 }
{ -1 -1  1  0 dmax ->  1  0 }
{  0  0  0  0 dmax ->  0  0 }
{  1  0  1  0 dmax ->  1  0 }
{  1  0  0  0 dmax ->  1  0 }
{  2  0  1  0 dmax ->  2  0 }
{  0  0 -1 -1 dmax ->  0  0 }
{  1  0 -1 -1 dmax ->  1  0 }
{  0 minint  0  0     dmax ->  0  0 }
{  0  0 -1 maxint     dmax -> -1 maxint }
{  0  0  0 minint     dmax ->  0  0 }
{ -1 maxint  0 minint dmax -> -1 maxint }
{ -1 maxint  0  0     dmax -> -1 maxint }

\ to catch use of D-, which overflows
{  0 minint -1 maxint dmax -> -1 maxint }

\ to catch failure to use low word unsigned compare
{  0  3 -1 2 dmax ->  0  3 }
{  0  3 -1 3 dmax -> -1  3 }
{ -1 2  0  3 dmax ->  0  3 }
{ -1 3  0  3 dmax -> -1  3 }

\ Based on core.4th.
{  0  0  1  0 dmin ->  0  0 }
{  1  0  2  0 dmin ->  1  0 }
{ -1 -1 -1 -1 dmin -> -1 -1 }
{ -1 -1  1  0 dmin -> -1 -1 }
{  0  0  0  0 dmin ->  0  0 }
{  1  0  1  0 dmin ->  1  0 }
{  1  0  0  0 dmin ->  0  0 }
{  2  0  1  0 dmin ->  1  0 }
{  0  0 -1 -1 dmin -> -1 -1 }
{  1  0 -1 -1 dmin -> -1 -1 }
{  0 minint  0  0     dmin ->  0 minint }
{  0  0 -1 maxint     dmin ->  0  0 }
{  0  0  0 minint     dmin ->  0 minint }
{ -1 maxint  0 minint dmin ->  0 minint }
{ -1 maxint  0  0     dmin ->  0  0 }

\ to catch use of D-, which overflows
{  0 minint -1 maxint dmin ->  0 minint }

\ to catch failure to use low word unsigned compare
{  0  3 -1  2 dmin -> -1  2 }
{  0  3 -1  3 dmin ->  0  3 }
{ -1  2  0  3 dmin -> -1  2 }
{ -1  3  0  3 dmin ->  0  3 }

COMMENT Uncomment lines in regress.4th to test errors.

\ The word FNEARLY is used to test floating-point results within
\ a tolerance.

1e-7 fconstant tolerance

: -2rot  ( x y z -- z x y )  2rot 2rot ;

{ 1 2 3 4 5 6 -2rot -> 5 6 1 2 3 4 }

: fwithin ( x y z -- flag )
(
Assume y < z.  Leave flag = [y<=x<z].
)
  -2rot 2over       ( z x y x)
  f<= ( [y<=x]) >r  ( z x)
  f> ( [z>x]) r> and
;

{ 1e .5e  2e fwithin -> true }
{ 1e  1e  2e fwithin -> true }
{ 2e  .5e 2e fwithin -> false }
{ .5e 1e  2e fwithin -> false }
{ 3e  1e  2e fwithin -> false }

: fnearly  ( x y -- flag )
  2dup tolerance f-   ( x y y-tol)
  2swap tolerance f+  ( x y-tol y+tol)
  fwithin
;

{ 1e 1e fnearly -> true }
{ 1e tolerance 2e f/ f- 1e fnearly -> true }
{ 1e tolerance 2e f/ f+ 1e fnearly -> true }
{ 1e tolerance 2e f* f- 1e fnearly -> false }
{ 1e tolerance 2e f* f+ 1e fnearly -> false }

testing F= F<> F< F> F<= F>= F0= F0< F0>

{  1e  2e f= -> false }
{  1e  1e f= -> true }
{  1e  2e f<> -> true }
{  1e  1e f<> -> false }
{ -1e  0e f< -> true }
{  0e -1e f< -> false }
{  3e  3e f< -> false }
{ -1e  0e f> -> false }
{  0e -1e f> -> true }
{  3e  3e f> -> false }
{ -1e  0e f<= -> true }
{  0e -1e f<= -> false }
{  3e  3e f<= -> true }
{ -1e  0e f>= -> false }
{  0e -1e f>= -> true }
{  3e  3e f<= -> true }
{  5e f0= -> false }
{  0e f0= -> true }
{  5e f0< -> false }
{  0e f0< -> false }
{ -1e f0< -> true }
{  5e f0> -> true }
{  0e f0> -> false }
{ -1e f0> -> false }

testing S>F D>F F>D FROUND>S FTRUNC>S SF@ SF!

{  3 s>f ->  3e }
{  0 s>f ->  0e }
{ -3 s>f -> -3e }

{  3  0         d>f ->  3e }
{  0  0         d>f ->  0e }
{ -3 -1         d>f -> -3e }
{  0  1         d>f ->  4294967296e }
{  0  1 dnegate d>f -> -4294967296e }

hex
-1 43dfffff           fconstant  maxftod.f
maxftod.f fnegate     fconstant -maxftod.f
0 40900000            fconstant  2^10.f
1 a lshift 0          2constant  2^10.d
fffffc00 7fffffff     2constant  maxftod.d
maxftod.d dnegate     2constant -maxftod.d
-1 maxint             2constant  maxdint
maxdint dnegate       2constant -maxdint
-1 433fffff           fconstant  maxnoshift.f
maxnoshift.f fnegate  fconstant -maxnoshift.f
-1 1fffff             2constant  maxnoshift.d
maxnoshift.d dnegate  2constant -maxnoshift.d
-1 3fefffff           fconstant  1.0-2^[-53]
1.0-2^[-53] fnegate   fconstant -1.0+2^[-53]

decimal
\ underflow
{    0e        f>d ->  0  0 }
{   .5e        f>d ->  0  0 }
{  -.5e        f>d ->  0  0 }
comment Skipping some F>D tests
(
{  1.0-2^[-53] f>d ->  0  0 }
{ -1.0+2^[-53] f>d ->  0  0 }
)
\ right shift
{  1e          f>d ->  1  0 }
{ -1e          f>d -> -1 -1 }
{  1.9e        f>d ->  1  0 }
{ -1.9e        f>d -> -1 -1 }
\ no shift
(
{  maxnoshift.f f>d ->  maxnoshift.d }
{ -maxnoshift.f f>d -> -maxnoshift.d }
\ left shift
{  maxftod.f  2^10.f f- f>d ->  maxftod.d 2^10.d d- }
{ -maxftod.f  2^10.f f+ f>d -> -maxftod.d 2^10.d d+ }	 
{  maxftod.f            f>d ->  maxftod.d }	 
{ -maxftod.f            f>d -> -maxftod.d }	 
\ overflow
{  maxftod.f  2^10.f f+ f>d ->  maxdint }	 
{ -maxftod.f  2^10.f f- f>d -> -maxdint }	 
{  1e  0e f/            f>d ->  maxdint }  \  Inf
{ -1e  0e f/            f>d -> -maxdint }  \ -Inf
{  0e  0e f/            f>d ->  maxdint }  \  NaN
{  0e  0e f/ fnegate    f>d -> -maxdint }  \ -NaN
)
decimal
{  1.8e fround>s ->  2 }
{  1.5e fround>s ->  2 }
{  1.2e fround>s ->  1 }
{    0e fround>s ->  0 }
{ -1.2e fround>s -> -1 }
{ -1.5e fround>s -> -2 }
{ -1.8e fround>s -> -2 }

{  1.8e ftrunc>s ->  1 }
{  1.5e ftrunc>s ->  1 }
{  1.2e ftrunc>s ->  1 }
{    0e ftrunc>s ->  0 }
{ -1.2e ftrunc>s -> -1 }
{ -1.5e ftrunc>s -> -1 }
{ -1.8e ftrunc>s -> -1 }

variable fsingle
{ 1.2e fsingle sf! -> }
{ fsingle sf@ 1.2e fnearly -> true }

fvariable fdouble
{ 1.2e fdouble df! -> }
{ fdouble df@ -> 1.2e }

0.572957795130823208769e2  fconstant 180/pi
0.174532925199432957692e-1 fconstant pi/180
0.157079632679489661923e1  fconstant pi/2
0.104719755119659774615e1  fconstant pi/3
0.523598775598298873077e0  fconstant pi/6
1e 2e fsqrt f/             fconstant 1/sqrt2

{ 1e deg>rad -> pi/180 }
{ 1e rad>deg -> 180/pi }
{ pi/180 rad>deg -> 180/pi deg>rad }
{ 180/pi rad>deg deg>rad -> 180/pi }
{ pi/180 rad>deg deg>rad -> pi/180 }

testing DFLOATS DFLOAT+ F+ F- F* F/ FABS FNEGATE

{  0 dfloats ->  0 }
{  3 dfloats ->  24 }
{ -3 dfloats -> -24 }

{  0  dfloat+ -> 8 }
{ -15 dfloat+ -> -7 }

{  5e 3e f+ -> 8e }
{  5e 3e f- -> 2e }
{  5e 3e f* -> 15e }
{  6e 3e f/ -> 2e }
{  5e fabs -> 5e }
{ -5e fabs -> 5e }
{  5e fnegate -> -5e }
{ -5e fnegate ->  5e }

testing FROUND FFLOOR FTRUNC

{  4e   fround ->  4e }
{  3.8e fround ->  4e }
{  3.5e fround ->  4e }
{  3.3e fround ->  3e }
{  0e   fround ->  0e }
{ -3.3e fround -> -3e }
{ -3.5e fround -> -4e }
{ -3.8e fround -> -4e }
{ -4e   fround -> -4e }

{  4e   floor ->  4e }
{  3.8e floor ->  3e }
{  3.5e floor ->  3e }
{  3.3e floor ->  3e }
{  0e   floor ->  0e }
{ -3.3e floor -> -4e }
{ -3.5e floor -> -4e }
{ -3.8e floor -> -4e }
{ -4e   floor -> -4e }

{  4e   ftrunc ->  4e }
{  3.8e ftrunc ->  3e }
{  3.5e ftrunc ->  3e }
{  3.3e ftrunc ->  3e }
{  0e   ftrunc ->  0e }
{ -3.3e ftrunc -> -3e }
{ -3.5e ftrunc -> -3e }
{ -3.8e ftrunc -> -3e }
{ -4e   ftrunc -> -4e }

testing FSQRT FCOS FSIN FATAN2 FSINCOS

{  4e fsqrt -> 2e }
{  0e fsqrt -> 0e }
{ .5e fsqrt 1/sqrt2 fnearly -> true }

{ 0e   fcos -> 1e }
{ pi/2 fcos 0e fnearly -> true }
{ pi/3 fcos 0.5e fnearly -> true }

{ 0e   fsin -> 0e }
{ pi/2 fsin -> 1e }
{ pi/6 fsin 0.5e fnearly -> true }

{ 1e 1e fatan2 rad>deg -> 45e }
{ 1e 0e fatan2 rad>deg -> 90e }
{ 0e 1e fatan2 rad>deg ->  0e }

{ 0e   fsincos -> 0e 1e }
{ pi/2 fsincos 0e fnearly >r 1e fnearly r> and -> true }

{ 45e deg>rad fsincos 1/sqrt2 fnearly >r 1/sqrt2 fnearly r>
    and -> true }
