\ dltest.4th
\
\ Test use of the dynamic link library interface in kForth v 1.4.6 and greater.
\
\ The example below is the standard man page example for the dlopen function,
\ translated to Forth.
\
\ K. Myneni, 2009-09-23
\
include ans-words
include asm-x86.4th

1 constant RTLD_LAZY

0 value hndLib
variable a_cos

\ Length of a null terminated string
: strlen ( addr -- len )
	0
	begin
	  over c@ 0= dup not if -rot 1+ swap 1+ swap rot then 
	until
	nip ;

: check-dlerror 
    dlerror dup IF  dup strlen cr type cr ABORT THEN ;

CODE fcosine
    ebx push,
    0 [ebx] eax mov,
    eax push,
    TCELL # ebx add,
    0 [ebx] eax mov,
    eax push,
    a_cos #@ call,
    eax pop,
    ecx pop,
    ebx pop,
    ecx 0 [ebx] mov,
    eax TCELL [ebx] mov,
    0 # eax mov,
END-CODE
    
    
: dltest ( -- )
    c" libm.so" RTLD_LAZY dlopen to hndLib
    hndLib 0= IF check-dlerror THEN
    dlerror drop                        \ Clear any existing error
    hndLib c" cos" dlsym a_cos !
    check-dlerror
    cr ." Library function 'cos' is loaded at address " a_cos @ u.
    2.0e
    cr ." Stack contents before calling fcosine" cr
    .s
    fcosine 
    cr ." Stack contents after return from fcosine" cr
    .s
    hndLib dlclose
    cr ." dlclose returned " .
;

    
    
    
    
