\ fcalls-x86.4th
\
\ Forth to C function Calling Interface for kForth
\ 
\ Requires asm-x86.4th
\
\ Krishna Myneni, Creative Consulting for Research & Education
\ krishna.myneni@ccreweb.org
\
\ Requires:
\   ans-words
\
\ Revisions:
\   2009-10-02  km  created
\   2009-10-04  km  implemented generic fcall
\   2009-10-07  km  renamed to fcall-x86.4th and moved
\                   library interface words to lib-interface.4th
\

\ The fcallx words all assume that the arguments are 
\ single or double cell values, with no double precision
\ floating point args.

\ In order to use the generic fcall, we make an assumption
\ about the stack usage of the function we are calling. Below, we
\ assume that the called function does not require > 64K of stack.
65536 constant MAX_FUNC_STACK

CODE fcall ( ncells addr -- val)
   0 [ebx] eax mov,
   TCELL # ebx add,
   0 [ebx] ecx mov,
   TCELL # ebx add,
           ebx push,
       ecx edx mov,
    DO,
       0 [ebx] push,
       TCELL # ebx add,
    LOOP,
         MAX_FUNC_STACK # esp sub,
	 edx push,
	 MAX_FUNC_STACK TCELL + # esp add,
         eax call,
	 MAX_FUNC_STACK TCELL + # esp sub,
	 ecx pop,
	 MAX_FUNC_STACK # esp add,

	 ecx edx mov,	
	 2 # ecx shl,
	 ecx esp add,

         ebx pop,

         edx ecx mov,
	 ecx dec,
	 2 # ecx shl,
	 ecx ebx add,

     eax 0 [ebx] mov,
     0 # eax mov,
END-CODE


CODE fcall0 ( addr -- val )
    0 [ebx] eax mov,
    ebx push,
    eax call,
    ebx pop,          \ restore Forth stack pointer
    eax 0 [ebx] mov,
    0 # eax mov,
END-CODE


CODE fcall1 ( arg addr -- val ) 
    0 [ebx] eax mov,
    TCELL # ebx add,
    ebx push,
    0 [ebx] push,
    eax call,
    ecx pop,
    ebx pop,
    eax 0 [ebx] mov,
    0 # eax mov,
END-CODE


CODE fcall1b ( arg addr -- ) 
    0 [ebx] eax mov,
    TCELL # ebx add,
    ebx push,
    0 [ebx] push,
    eax call,
    eax pop,
    ebx pop,
    TCELL # ebx add,
    0 # eax mov,
END-CODE




CODE fcall2b ( arg1 arg2 addr -- )
    0 [ebx] eax mov,
    TCELL # ebx add,
    ebx push,
    2 0 DO I TCELL * [ebx] push, LOOP
    eax call,
    TCELL 2* # esp add,
    ebx pop,
    TCELL 2* # ebx add,
    0 # eax mov,
END-CODE






