\ X.4th
\
\ Definitions from X.h
\ Adapted to Forth by Krishna Myneni, Creative Consulting for
\   Research and Education, krishna.myneni@ccreweb.org
\
\ Original comments and copyright notice:
\
\ Copyright 1987, 1998  The Open Group
\
\ Permission to use, copy, modify, distribute, and sell this software and its
\ documentation for any purpose is hereby granted without fee, provided that
\ the above copyright notice appear in all copies and that both that
\ copyright notice and this permission notice appear in supporting
\ documentation.
\
\ The above copyright notice and this permission notice shall be included in
\ all copies or substantial portions of the Software.
\
\ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
\ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
\ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
\ OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
\ AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
\ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
\
\ Except as contained in this notice, the name of The Open Group shall not be
\ used in advertising or otherwise to promote the sale, use or other dealings
\ in this Software without prior written authorization from The Open Group.


11 constant X_PROTOCOL                  \ current protocol version
 0 constant X_PROTOCOL_REVISION         \ current minor version

\ *****************************************************************
\  RESERVED RESOURCE AND CONSTANT DEFINITIONS
\ *****************************************************************

[undefined] None [IF]
0 constant  None               \ universal null resource or null atom
[THEN]
1 constant  ParentRelative     \ background pixmap in CreateWindow
                               \     and ChangeWindowAttributes
0 constant  CopyFromParent     \ border pixmap in CreateWindow
                               \        and ChangeWindowAttributes
                               \    special VisualID and special window
                               \        class passed to CreateWindow
0 constant  PointerWindow      \ destination window in SendEvent
1 constant  InputFocus         \ destination window in SendEvent
1 constant  PointerRoot        \ focus window in SetInputFocus
0 constant  AnyPropertyType    \ special Atom, passed to GetProperty
0 constant  AnyKey             \ special Key Code, passed to GrabKey
0 constant  AnyButton          \ special Button Code, passed to GrabButton
0 constant  AllTemporary       \ special Resource ID passed to KillClient
0 constant  CurrentTime        \ special Time
0 constant  NoSymbol           \ special KeySym


\ *****************************************************************
\  EVENT DEFINITIONS
\ *****************************************************************

\ Input Event Masks. Used as event-mask window attribute and as arguments
\   to Grab requests.  Not to be confused with event names.

    0        constant  NoEventMask
 1  0 lshift constant  KeyPressMask                    ( 1L<<0)
 1  1 lshift constant  KeyReleaseMask                  ( 1L<<1)
 1  2 lshift constant  ButtonPressMask                 ( 1L<<2)
 1  3 lshift constant  ButtonReleaseMask               ( 1L<<3)
 1  4 lshift constant  EnterWindowMask                 ( 1L<<4)
 1  5 lshift constant  LeaveWindowMask                 ( 1L<<5)
 1  6 lshift constant  PointerMotionMask               ( 1L<<6)
 1  7 lshift constant  PointerMotionHintMask           ( 1L<<7)
 1  8 lshift constant  Button1MotionMask               ( 1L<<8)
 1  9 lshift constant  Button2MotionMask               ( 1L<<9)
 1 10 lshift constant  Button3MotionMask               ( 1L<<10)
 1 11 lshift constant  Button4MotionMask               ( 1L<<11)
 1 12 lshift constant  Button5MotionMask               ( 1L<<12)
 1 13 lshift constant  ButtonMotionMask                ( 1L<<13)
 1 14 lshift constant  KeymapStateMask                 ( 1L<<14)
 1 15 lshift constant  ExposureMask                    ( 1L<<15)
 1 16 lshift constant  VisibilityChangeMask            ( 1L<<16)
 1 17 lshift constant  StructureNotifyMask             ( 1L<<17)
 1 18 lshift constant  ResizeRedirectMask              ( 1L<<18)
 1 19 lshift constant  SubstructureNotifyMask          ( 1L<<19)
 1 20 lshift constant  SubstructureRedirectMask        ( 1L<<20)
 1 21 lshift constant  FocusChangeMask                 ( 1L<<21)
 1 22 lshift constant  PropertyChangeMask              ( 1L<<22)
 1 23 lshift constant  ColormapChangeMask              ( 1L<<23)
 1 24 lshift constant  OwnerGrabButtonMask             ( 1L<<24)

\ Event names.  Used in "type" field in XEvent structures.  Not to be
\ confused with event masks above.  They start from 2 because 0 and 1
\ are reserved in the protocol for errors and replies.

 2 constant  KeyPress
 3 constant  KeyRelease
 4 constant  ButtonPress
 5 constant  ButtonRelease           
 6 constant  MotionNotify            
 7 constant  EnterNotify             
 8 constant  LeaveNotify             
 9 constant  FocusIn                 
10 constant  FocusOut                
11 constant  KeymapNotify            
12 constant  Expose                  
13 constant  GraphicsExpose          
14 constant  NoExpose                
15 constant  VisibilityNotify        
16 constant  CreateNotify            
17 constant  DestroyNotify           
18 constant  UnmapNotify             
19 constant  MapNotify               
20 constant  MapRequest              
21 constant  ReparentNotify          
22 constant  ConfigureNotify         
23 constant  ConfigureRequest        
24 constant  GravityNotify           
25 constant  ResizeRequest           
26 constant  CirculateNotify         
27 constant  CirculateRequest        
28 constant  PropertyNotify          
29 constant  SelectionClear          
30 constant  SelectionRequest        
31 constant  SelectionNotify         
32 constant  ColormapNotify          
33 constant  ClientMessage           
34 constant  MappingNotify           
35 constant  LASTEvent             \ must be bigger than any event 

\ Key masks. Used as modifiers to GrabButton and GrabKey, results of QueryPointer,
\   state in various key-, mouse-, and button-related events.

 1 0 lshift constant  ShiftMask               ( 1<<0)
 1 1 lshift constant  LockMask                ( 1<<1)
 1 2 lshift constant  ControlMask             ( 1<<2)
 1 3 lshift constant  Mod1Mask                ( 1<<3)
 1 4 lshift constant  Mod2Mask                ( 1<<4)
 1 5 lshift constant  Mod3Mask                ( 1<<5)
 1 6 lshift constant  Mod4Mask                ( 1<<6)
 1 7 lshift constant  Mod5Mask                ( 1<<7)

\ modifier names.  Used to build a SetModifierMapping request or
\   to read a GetModifierMapping request.  These correspond to the
\   masks defined above.
 0 constant  ShiftMapIndex
 1 constant  LockMapIndex
 2 constant  ControlMapIndex
 3 constant  Mod1MapIndex
 4 constant  Mod2MapIndex
 5 constant  Mod3MapIndex
 6 constant  Mod4MapIndex
 7 constant  Mod5MapIndex

\ button masks.  Used in same manner as Key masks above. Not to be confused
\   with button names below.

 1  8 lshift constant  Button1Mask             ( 1<<8)
 1  9 lshift constant  Button2Mask             ( 1<<9)
 1 10 lshift constant  Button3Mask             ( 1<<10)
 1 11 lshift constant  Button4Mask             ( 1<<11)
 1 12 lshift constant  Button5Mask             ( 1<<12)

 1 15 lshift constant  AnyModifier             ( 1<<15) \ used in GrabButton, GrabKey


\ button names. Used as arguments to GrabButton and as detail in ButtonPress
\   and ButtonRelease events.  Not to be confused with button masks above.
\   Note that 0 is already defined above as "AnyButton". 

 1 constant  Button1
 2 constant  Button2
 3 constant  Button3
 4 constant  Button4
 5 constant  Button5

\ Notify modes

 0 constant NotifyNormal          
 1 constant NotifyGrab             
 2 constant NotifyUngrab           
 3 constant NotifyWhileGrabbed     

 1 constant NotifyHint            \ for MotionNotify events

\ Notify detail

 0 constant  NotifyAncestor         
 1 constant  NotifyVirtual          
 2 constant  NotifyInferior         
 3 constant  NotifyNonlinear        
 4 constant  NotifyNonlinearVirtual 
 5 constant  NotifyPointer          
 6 constant  NotifyPointerRoot      
 7 constant  NotifyDetailNone       

\ Visibility notify

 0 constant  VisibilityUnobscured          
 1 constant  VisibilityPartiallyObscured    
 2 constant  VisibilityFullyObscured        

\ Circulation request 

 0 constant PlaceOnTop            
 1 constant PlaceOnBottom      

\ protocol families

 0 constant  FamilyInternet               \ IPv4
 1 constant  FamilyDECnet           
 2 constant  FamilyChaos            
 6 constant  FamilyInternet6              \ IPv6

\ authentication families not tied to a specific protocol
 5 constant  FamilyServerInterpreted

\ Property notification

 0 constant  PropertyNewValue      
 1 constant  PropertyDelete         

\ Color Map notification

 0 constant  ColormapUninstalled   
 1 constant  ColormapInstalled   

\ GrabPointer, GrabButton, GrabKeyboard, GrabKey Modes

 0 constant  GrabModeSync
 1 constant  GrabModeAsync

\ GrabPointer, GrabKeyboard reply status

 0 constant  GrabSuccess            
 1 constant  AlreadyGrabbed         
 2 constant  GrabInvalidTime        
 3 constant  GrabNotViewable        
 4 constant  GrabFrozen             

\ AllowEvents modes

 0 constant  AsyncPointer          
 1 constant  SyncPointer            
 2 constant  ReplayPointer          
 3 constant  AsyncKeyboard          
 4 constant  SyncKeyboard           
 5 constant  ReplayKeyboard         
 6 constant  AsyncBoth              
 7 constant  SyncBoth               

\ Used in SetInputFocus, GetInputFocus

None        constant  RevertToNone      
PointerRoot constant  RevertToPointerRoot
2           constant  RevertToParent

\ *****************************************************************
\  ERROR CODES
\ *****************************************************************

 0 constant  Success               \ everything's okay
 1 constant  BadRequest            \ bad request code
 2 constant  BadValue              \ int parameter out of range
 3 constant  BadWindow             \ parameter not a Window
 4 constant  BadPixmap             \ parameter not a Pixmap
 5 constant  BadAtom               \ parameter not an Atom
 6 constant  BadCursor             \ parameter not a Cursor
 7 constant  BadFont               \ parameter not a Font
 8 constant  BadMatch              \ parameter mismatch
 9 constant  BadDrawable           \ parameter not a Pixmap or Window
10 constant  BadAccess             \ depending on context:
                                   \ - key/button already grabbed
                                   \ - attempt to free an illegal
                                   \ cmap entry
                                   \ - attempt to store into a read-only
                                   \ color map entry.
                                   \ - attempt to modify the access control
                                   \ list from other than the local host.

11 constant  BadAlloc              \ insufficient resources
12 constant  BadColor              \ no such colormap
13 constant  BadGC                 \ parameter not a GC
14 constant  BadIDChoice           \ choice not in range or already used
15 constant  BadName               \ font or color name doesn't exist
16 constant  BadLength             \ Request length incorrect
17 constant  BadImplementation     \ server is defective

128 constant  FirstExtensionError
255 constant  LastExtensionError

\ *****************************************************************
\  WINDOW DEFINITIONS
\ *****************************************************************

\ Window classes used by CreateWindow
\ Note that CopyFromParent is already defined as 0 above

 1 constant  InputOutput            
 2 constant  InputOnly              

\ Window attributes for CreateWindow and ChangeWindowAttributes

 1  0 lshift constant  CWBackPixmap            ( 1L<<0)
 1  1 lshift constant  CWBackPixel             ( 1L<<1)
 1  2 lshift constant  CWBorderPixmap          ( 1L<<2)
 1  3 lshift constant  CWBorderPixel           ( 1L<<3)
 1  4 lshift constant  CWBitGravity            ( 1L<<4)
 1  5 lshift constant  CWWinGravity            ( 1L<<5)
 1  6 lshift constant  CWBackingStore          ( 1L<<6)
 1  7 lshift constant  CWBackingPlanes         ( 1L<<7)
 1  8 lshift constant  CWBackingPixel          ( 1L<<8)
 1  9 lshift constant  CWOverrideRedirect      ( 1L<<9)
 1 10 lshift constant  CWSaveUnder             ( 1L<<10)
 1 11 lshift constant  CWEventMask             ( 1L<<11)
 1 12 lshift constant  CWDontPropagate         ( 1L<<12)
 1 13 lshift constant  CWColormap              ( 1L<<13)
 1 14 lshift constant  CWCursor                ( 1L<<14)

\ ConfigureWindow structure

 1 0 lshift constant  CWX                     ( 1<<0)
 1 1 lshift constant  CWY                     ( 1<<1)
 1 2 lshift constant  CWWidth                 ( 1<<2)
 1 3 lshift constant  CWHeight                ( 1<<3)
 1 4 lshift constant  CWBorderWidth           ( 1<<4)
 1 5 lshift constant  CWSibling               ( 1<<5)
 1 6 lshift constant  CWStackMode             ( 1<<6)

\ Bit Gravity

 0 constant  ForgetGravity          
 1 constant  NorthWestGravity       
 2 constant  NorthGravity           
 3 constant  NorthEastGravity       
 4 constant  WestGravity            
 5 constant  CenterGravity          
 6 constant  EastGravity            
 7 constant  SouthWestGravity       
 8 constant  SouthGravity           
 9 constant  SouthEastGravity      
10 constant  StaticGravity      

\ Window gravity + bit gravity above

 0 constant  UnmapGravity           

\ Used in CreateWindow for backing-store hint

 0 constant  NotUseful              
 1 constant  WhenMapped             
 2 constant  Always                 

\ Used in GetWindowAttributes reply

 0 constant  IsUnmapped             
 1 constant  IsUnviewable           
 2 constant  IsViewable             

\ Used in ChangeSaveSet

 0 constant  SetModeInsert          
 1 constant  SetModeDelete          

\ Used in ChangeCloseDownMode

 0 constant  DestroyAll             
 1 constant  RetainPermanent        
 2 constant  RetainTemporary        

\ Window stacking method (in configureWindow)

 0 constant  Above                  
 1 constant  Below                  
 2 constant  TopIf                  
 3 constant  BottomIf               
 4 constant  Opposite              

\ Circulation direction

 0 constant  RaiseLowest            
 1 constant  LowerHighest          

\ Property modes

 0 constant  PropModeReplace        
 1 constant  PropModePrepend        
 2 constant  PropModeAppend         

\ *****************************************************************
\  GRAPHICS DEFINITIONS
\ *****************************************************************

\ graphics functions, as in GC.alu
hex
 0 constant  GXclear                              \ 0
 1 constant  GXand                                \ src AND dst
 2 constant  GXandReverse                         \ src AND NOT dst
 3 constant  GXcopy                               \ src
 4 constant  GXandInverted                        \ NOT src AND dst
 5 constant  GXnoop                               \ dst
 6 constant  GXxor                                \ src XOR dst
 7 constant  GXor                                 \ src OR dst
 8 constant  GXnor                                \ NOT src AND NOT dst
 9 constant  GXequiv                              \ NOT src XOR dst
 A constant  GXinvert                             \ NOT dst
 B constant  GXorReverse                          \ src OR NOT dst
 C constant  GXcopyInverted                       \ NOT src
 D constant  GXorInverted                         \ NOT src OR dst
 E constant  GXnand                               \ NOT src OR NOT dst
 F constant  GXset                                \ 1 
decimal

\ LineStyle

 0 constant  LineSolid              
 1 constant  LineOnOffDash          
 2 constant  LineDoubleDash         

\ capStyle

 0 constant  CapNotLast             
 1 constant  CapButt                
 2 constant  CapRound               
 3 constant  CapProjecting          

\ joinStyle

 0 constant  JoinMiter              
 1 constant  JoinRound              
 2 constant  JoinBevel              

\ fillStyle

 0 constant  FillSolid              
 1 constant  FillTiled              
 2 constant  FillStippled           
 3 constant  FillOpaqueStippled     

\ fillRule

 0 constant  EvenOddRule            
 1 constant  WindingRule            

\ subwindow mode

 0 constant  ClipByChildren         
 1 constant  IncludeInferiors       

0 [IF]
\ SetClipRectangles ordering

#define Unsorted                0
#define YSorted                 1
#define YXSorted                2
#define YXBanded                3

\ CoordinateMode for drawing routines

#define CoordModeOrigin         0       \ relative to the origin
#define CoordModePrevious       1       \ relative to previous point

\ Polygon shapes

#define Complex                 0       \ paths may intersect
#define Nonconvex               1       \ no paths intersect, but not convex
#define Convex                  2       \ wholly convex

\ Arc modes for PolyFillArc

#define ArcChord                0       \ join endpoints of arc
#define ArcPieSlice             1       \ join endpoints to center of arc

\ GC components: masks used in CreateGC, CopyGC, ChangeGC, OR'ed into
\   GC.stateChanges

#define GCFunction              ( 1L<<0)
#define GCPlaneMask             ( 1L<<1)
#define GCForeground            ( 1L<<2)
#define GCBackground            ( 1L<<3)
#define GCLineWidth             ( 1L<<4)
#define GCLineStyle             ( 1L<<5)
#define GCCapStyle              ( 1L<<6)
#define GCJoinStyle             ( 1L<<7)
#define GCFillStyle             ( 1L<<8)
#define GCFillRule              ( 1L<<9)
#define GCTile                  ( 1L<<10)
#define GCStipple               ( 1L<<11)
#define GCTileStipXOrigin       ( 1L<<12)
#define GCTileStipYOrigin       ( 1L<<13)
#define GCFont                  ( 1L<<14)
#define GCSubwindowMode         ( 1L<<15)
#define GCGraphicsExposures     ( 1L<<16)
#define GCClipXOrigin           ( 1L<<17)
#define GCClipYOrigin           ( 1L<<18)
#define GCClipMask              ( 1L<<19)
#define GCDashOffset            ( 1L<<20)
#define GCDashList              ( 1L<<21)
#define GCArcMode               ( 1L<<22)

#define GCLastBit               22
\ *****************************************************************
\  FONTS
\ *****************************************************************

\ used in QueryFont -- draw direction

#define FontLeftToRight         0
#define FontRightToLeft         1

#define FontChange              255

\ *****************************************************************
\   IMAGING
\ *****************************************************************

\ ImageFormat -- PutImage, GetImage

#define XYBitmap                0       \ depth 1, XYFormat
#define XYPixmap                1       \ depth == drawable depth
#define ZPixmap                 2       \ depth == drawable depth

\ *****************************************************************
\   COLOR MAP STUFF
\ *****************************************************************

\ For CreateColormap

#define AllocNone               0       \ create map with no entries
#define AllocAll                1       \ allocate entire map writeable


\ Flags used in StoreNamedColor, StoreColors

#define DoRed                   ( 1<<0)
#define DoGreen                 ( 1<<1)
#define DoBlue                  ( 1<<2)

\ *****************************************************************
\  CURSOR STUFF
\ *****************************************************************

\ QueryBestSize Class

#define CursorShape             0       \ largest size that can be displayed
#define TileShape               1       \ size tiled fastest
#define StippleShape            2       \ size stippled fastest

\ *****************************************************************
\  KEYBOARD/POINTER STUFF
\ *****************************************************************

#define AutoRepeatModeOff       0
#define AutoRepeatModeOn        1
#define AutoRepeatModeDefault   2

#define LedModeOff              0
#define LedModeOn               1

\ masks for ChangeKeyboardControl

#define KBKeyClickPercent       ( 1L<<0)
#define KBBellPercent           ( 1L<<1)
#define KBBellPitch             ( 1L<<2)
#define KBBellDuration          ( 1L<<3)
#define KBLed                   ( 1L<<4)
#define KBLedMode               ( 1L<<5)
#define KBKey                   ( 1L<<6)
#define KBAutoRepeatMode        ( 1L<<7)

#define MappingSuccess          0
#define MappingBusy             1
#define MappingFailed           2

#define MappingModifier         0
#define MappingKeyboard         1
#define MappingPointer          2

\ *****************************************************************
\  SCREEN SAVER STUFF
\ *****************************************************************

#define DontPreferBlanking      0
#define PreferBlanking          1
#define DefaultBlanking         2

#define DisableScreenSaver      0
#define DisableScreenInterval   0

#define DontAllowExposures      0
#define AllowExposures          1
#define DefaultExposures        2

\ for ForceScreenSaver

#define ScreenSaverReset 0
#define ScreenSaverActive 1

\ *****************************************************************
\  HOSTS AND CONNECTIONS
\ *****************************************************************

\ for ChangeHosts

#define HostInsert              0
#define HostDelete              1

\ for ChangeAccessControl

#define EnableAccess            1
#define DisableAccess           0

\ Display classes  used in opening the connection
\  Note that the statically allocated ones are even numbered and the
\  dynamically changeable ones are odd numbered 

#define StaticGray              0
#define GrayScale               1
#define StaticColor             2
#define PseudoColor             3
#define TrueColor               4
#define DirectColor             5


\ Byte order  used in imageByteOrder and bitmapBitOrder 

#define LSBFirst                0
#define MSBFirst                1

[THEN]

\ end of X.4th

