\ Xlib.4th
\
\ Selected definitions from /usr/include/Xlib.h
\
\ Copyright 1985, 1986, 1987, 1991, 1998  The Open Group
\
\ Permission to use, copy, modify, distribute, and sell this software and its
\ documentation for any purpose is hereby granted without fee, provided that
\ the above copyright notice appear in all copies and that both that
\ copyright notice and this permission notice appear in supporting
\ documentation.
\
\ The above copyright notice and this permission notice shall be included in
\ all copies or substantial portions of the Software.
\
\ Adapted to Forth by
\
\ Krishna Myneni, Creative Consulting for Research & Education
\ krishna.myneni@ccreweb.org
\
\ Requires:
\   struct.4th, struct-ext.4th
\
\ Revisions:
\


struct
  int32: XColor->pixel
  int16: XColor->red
  int16: XColor->green
  int16: XColor->blue
  byte:  XColor->flags
  byte:  XColor->pad
end-struct XColor%


struct
  int16: XSegment->x1
  int16: XSegment->y1
  int16: XSegment->x2
  int16: XSegment->y2
end-struct XSegment%


struct
  int16: XPoint->x
  int16: XPoint->y
end-struct XPoint%


struct
  int16: XRectangle->x
  int16: XRectangle->y
  int16: XRectangle->width
  int16: XRectangle->height
end-struct XRectangle%


struct
  int16: XArc->x
  int16: XArc->y
  int16: XArc->width
  int16: XArc->height
  int16: XArc->angle1
  int16: XArc->angle2
end-struct XArc%


struct
  int: XKeyboardControl->key_click_percent
  int: XKeyboardControl->bell_percent
  int: XKeyboardControl->bell_pitch
  int: XKeyboardControl->bell_duration
  int: XKeyboardControl->led
  int: XKeyboardControl->led_mode
  int: XKeyboardControl->key
  int: XKeyboardControl->auto_repeat_mode
end-struct XKeyboardControl%


struct
  int: XKeyboardState->key_click_percent
  int: XKeyboardState->bell_percent
  int: XKeyboardState->bell_pitch
  int: XKeyboardState->bell_duration
  int32: led_mask
  int: XKeyboardState->global_auto_repeat
  32 buf: XKeyboardState->auto_repeats
end-struct XKeyboardState%

struct
  int: XTimeCoord->time
  int16: XTimeCoord->x
  int16: XTimeCoord->y
end-struct XTimeCoord%

struct
  int: XModifierKeymap->max_keypermod
  int: XModifierKeymap->modifiermap
end-struct XModifierKeymap%


\ Definitions of specific events

struct
  int: XKeyEvent->type
  int32: XKeyEvent->serial
  int: XKeyEvent->send_event
  int: XKeyEvent->display
  int: XKeyEvent->window
  int: XKeyEvent->root
  int: XKeyEvent->subwindow
  int: XKeyEvent->time
  int: XKeyEvent->x
  int: XKeyEvent->y
  int: XKeyEvent->x_root
  int: XKeyEvent->y_root
  int: XKeyEvent->state
  int: XKeyEvent->keycode
  int: XKeyEvent->same_screen
end-struct XKeyEvent%

struct
  int: XButtonEvent->type
  int32: XButtonEvent->serial
  int: XButtonEvent->send_event
  int: XButtonEvent->display
  int: XButtonEvent->window
  int: XButtonEvent->root
  int: XButtonEvent->subwindow
  int: XButtonEvent->time
  int: XButtonEvent->x
  int: XButtonEvent->y
  int: XButtonEvent->x_root
  int: XButtonEvent->y_root
  int: XButtonEvent->state
  int: XButtonEvent->button
  int: XButtonEvent->same_screen
end-struct XButtonEvent%

struct
  int: XMotionEvent->type
  int32: XMotionEvent->serial
  int: XMotionEvent->send_event
  int: XMotionEvent->display
  int: XMotionEvent->window
  int: XMotionEvent->root
  int: XMotionEvent->subwindow
  int: XMotionEvent->time
  int: XMotionEvent->x
  int: XMotionEvent->y
  int: XMotionEvent->x_root
  int: XMotionEvent->y_root
  int: XMotionEvent->state
  int: XMotionEvent->is_hint
  int: XMotionEvent->same_screen
end-struct XMotionEvent%


struct
  int: XErrorEvent->type
  int: XErrorEvent->display
  int: XErrorEvent->resourceid
  int32: XErrorEvent->serial
  byte: XErrorEvent->error_code
  byte: XErrorEvent->request_code
  byte: XErrorEvent->minor_code
  byte: XErrorEvent->pad
end-struct XErrorEvent%


struct
  int: XAnyEvent->type
  int32: XAnyEvent->serial
  int: XAnyEvent->send_event
  int: XAnyEvent->display
  int: XAnyEvent->window
end-struct XAnyEvent%


\ Ensure that our defined structures have the same
\ sizes as in the C definitions in Xlib.h, compiled
\ under 32-bits.

: check-struct-size ( u1 u2 -- )
     <> ABORT" Incorrect structure size!"
;

XColor%           %size 12 check-struct-size
XSegment%         %size  8 check-struct-size
XPoint%           %size  4 check-struct-size
XRectangle%       %size  8 check-struct-size
XArc%             %size 12 check-struct-size
XKeyboardControl% %size 32 check-struct-size
XKeyboardState%   %size 56 check-struct-size
XTimeCoord%       %size  8 check-struct-size
XModifierKeymap%  %size  8 check-struct-size
XKeyEvent%        %size 60 check-struct-size
XButtonEvent%     %size 60 check-struct-size
XMotionEvent%     %size 60 check-struct-size
XErrorEvent%      %size 20 check-struct-size
XAnyEvent%        %size 20 check-struct-size



