\ libblas-test.4th
\
\ Test the Forth interface to the BLAS routines
\
\ Copyright (c) 2009 Creative Consulting for Research and Education
\ krishna.myneni@ccreweb.org
\
\ Examples from,
\
\ 1. Handbook for matrix computations by T. F. Coleman and 
\    C. F. van Loan
\
\ 2. http://www.gnu.org/software/gsl/manual/html_node/GSL-CBLAS-Examples.html
\
\ 3. http://sensawave.com/manuals/SENSAWAVE-manual/SENSAWAVE-manual_5.html
\
\ 4. http://www.intel.com/software/products/mkl/docs/webhelp/appendices/mkl_appC_BLAS.html
 
include ans-words
include asm
include strings
include libblas
include fsl/fsl-util
include ttester

[UNDEFINED] SFLOAT [IF] 1 SFLOATS CONSTANT SFLOAT [THEN]
[UNDEFINED] SFVARIABLE [IF] : SFVARIABLE CREATE 1 SFLOATS ALLOT ; [THEN]

fvariable a
fvariable b
fvariable c
fvariable s

10 SFLOAT array sx{
10 SFLOAT array sy{
10 FLOAT array  x{
10 FLOAT array  y{
variable N
variable M
variable incx
variable incy
variable lda


0 [IF]
TESTING DDOT
set-near
3 N !
1 incx !
1 incy !
1e-15 rel-near f!
t{ N x{ incx y{ incy ddot ->  42e }t
[THEN]


TESTING SCOPY DCOPY
set-exact
: set-sx 10 0 DO  I 1+ s>f sx{ I } sf!  LOOP ;
: set-x  10 0 DO  I 1+ s>f  x{ I }  f!  LOOP ;
set-sx
set-x
10 N !
1 incx !
1 incy !
t{ N sx{  incx sy{  incy  SCOPY  ->  }t
t{ sy{ 0 } sf@  ->  1e  r}t
t{ sy{ 4 } sf@  ->  5e  r}t
t{ sy{ 9 } sf@  -> 10e  r}t
t{ N  x{  incx  y{  incy  DCOPY  ->  }t
t{  y{ 0 }  f@  ->  1e  r}t
t{  y{ 4 }  f@  ->  5e  r}t
t{  y{ 9 }  f@  -> 10e  r}t


TESTING SROTG DROTG
set-near
: set-srotg-vals  s sf!  c sf!  b sf!  a sf! ;
: get-srotg-vals  a sf@  b sf@  c sf@  s sf@ ;
: set-drotg-vals  s df!  c df!  b df!  a df! ;
: get-drotg-vals  a df@  b df@  c df@  s df@ ;

1e-7 rel-near f!
4e 3e 0e 0e set-srotg-vals
t{ a b c s SROTG  get-srotg-vals  ->  5e 0.6e 0.8e 0.6e rrrr}t

1e-15 rel-near f!
4e 3e 0e 0e set-drotg-vals
t{ a b c s DROTG  get-drotg-vals  ->  5e 0.6e 0.8e 0.6e rrrr}t

TESTING SGER
set-near
1e-7 rel-near f!
fvariable alpha
5 3 SFLOAT matrix sa{{
: set-sger-vals
    0.5e alpha sf!
    2 m ! 3 n ! 5 lda ! 2 incx ! 1 incy !
    10 0 DO  1e sx{ I } sf!  1e sy{ I } sf!   LOOP
\ Fortran storage is column order, rather than row order! We must
\   transpose the matrix
    m @ 0 DO  n @ 0 DO  I 1+ s>f  sa{{ I J }} sf!  LOOP LOOP
;
set-sger-vals
t{  m  n  alpha  sx{  incx  sy{  incy  sa{{  lda  sger  ->  }t

\ 3 sa{{ }}set-columns   \ resize the matrix to the new dimensions

t{  sa{{ 0 0 }} sf@  ->  1.5e  r}t
t{  sa{{ 1 0 }} sf@  ->  2.5e  r}t
t{  sa{{ 2 0 }} sf@  ->  3.5e  r}t
t{  sa{{ 0 1 }} sf@  ->  1.5e  r}t
t{  sa{{ 1 1 }} sf@  ->  2.5e  r}t
t{  sa{{ 2 1 }} sf@  ->  3.5e  r}t

0 [IF]
\ TESTING DGEMM
set-near
2 3 FLOAT matrix A{{
0.11e 0.12e 0.13e
0.21e 0.22e 0.23e 
2 3 A{{ }}fput

3 2 FLOAT matrix B{{
1011e 1012e
1021e 1022e
1031e 1032e
3 2 B{{ }}fput

2 2 FLOAT matrix C{{

[THEN]


