\ stem-test.4th
\
\ Test Wil Baden's version of the Porter Stemmer
\   for test cases provided at the Porter Stemmer website
\
\

include stem
include files
include utils

c" porter/stem-input.txt"  ptr input-words
c" porter/stem-output.txt" ptr proper-output-words

variable infile1
variable infile2

create lbuf1 256 allot
create lbuf2 256 allot

variable npass
variable nfail

: test
    input-words count R/O open-file 
    abort" Unable to open input-words file"
    infile1 !
    proper-output-words count R/O open-file
    abort" Unable to open proper-input-words file"
    infile2 !

    0 npass !
    0 nfail !

    begin
      lbuf1 255 infile1 @ read-line drop
    while
      lbuf1 swap -trailing 2dup
      stem
      2dup
      lbuf2 255 infile2 @ read-line drop drop
      lbuf2 swap 2dup 2>r
      compare if
	2swap type 9 emit 9 emit type
	9 emit 9 emit 2r> type cr
	1 nfail +!
      else
	2r> 2drop 2drop 2drop
	1 npass +!
      then
    repeat
    drop
    infile2 @ close-file drop
    infile1 @ close-file drop

    ." Total number of words checked = " npass @ nfail @ + . cr
    ." Number of failed stems = " nfail @ . cr
;

	  
