C     VXPDISP.INC
C
C     Include file for VAXPLOT display variable declarations
C       and common block definitions.
C
C     Created: 6 Feb 90
C
C     Updated: 12 Sep 90; changed color maps -- KM
C
C ------------------------------------------------------------------
C
C     Note: The file 'VAXPLOT.INC' must be included prior to
C           the include call for this file.
C
C ------------------------------------------------------------------
C
C
        PARAMETER (N_COLORS = 11)     ! number of colors in color map

        RECORD /GRAPHICS_WINDOW/ GW(MAX_DISPLAYS)
        RECORD /DISPLAY/ HW
        RECORD /EXPANSION/ EX
C
C       Set up color arrays and cursor
C        
        DIMENSION R_MAP (N_COLORS)
        DIMENSION G_MAP (N_COLORS)
        DIMENSION B_MAP (N_COLORS)

        INTEGER*2 CURSOR (16, 2)
C
C       Initialize red, blue, and green color maps
C
        DATA R_MAP /1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.6,
     +              0.0, 0.8, 1.0/
        DATA G_MAP /1.0, 0.0, 0.9, 0.0, 0.0, 0.0, 0.7, 0.0,
     +              0.7, 0.0, 0.4/
        DATA B_MAP /1.0, 0.0, 0.9, 0.0, 1.0, 0.0, 0.0, 0.5,
     +              0.7, 0.8, 0.0/

C
C       Indices 0 - 9 represent the following colors
C
C         Index       Item                            Default Color
C
C           0         Graphics Window Background      white
C           1         Graphics Window Foreground      black
C           2         Menu Window Background          peach
C           3         Menu Window Foreground          black
C           4         Plot 1                          blue
C           5         Plot 2                          red
C           6         Plot 3                          green
C           7         Plot 4                          burgundy
C           8         Plot 5                          marine
C           9         Plot 6                          violet
C          10         Plot 7                          orange
C

C  Initialize cursor pattern to be a cross.

        DATA CURSOR /7*256, 65535, 8*256, 16*0/


C -----------------------------------------------------------------
C                 DATA STRUCTURES
C -----------------------------------------------------------------

      STRUCTURE /WINDOW_PLACEMENT/
         INTEGER*4 CODE_1
         REAL*4 ATTRIB_1
         INTEGER*4 CODE_2
         REAL*4 ATTRIB_2
         INTEGER*4 CODE_3
         INTEGER*4 ATTRIB_3
         INTEGER*4 END
      END STRUCTURE

C
C -----------------------------------------------------------------
C
C
C       Set up the display variables common block.
C
        COMMON /DISPLAY_VARIABLES/ GW, HW, EX, R_MAP, G_MAP,
     +     B_MAP, CURSOR, WINDOW_WIDTH, WINDOW_HEIGHT, KEYBUF
C
C ------------------------------------------------------------------
