C     VXPMENU.INC
C
C     Include file for VAXPLOT options menu routines.
C
C     Created: 7 Feb 90
C
C     Updated: 13 Feb 90
C     Updated: 20 July 90 -- KM
C     Updated: 23 Aug 90; added POLY FIT to MATH MENU -- KM
C     Updated: 29 Aug 90; added AREA to MATH MENU -- KM	
C     Updated: 31 Aug 90; added DERIV to MATH MENU -- KM
C
C
C     NOTE: The files VAXPLOT.INC and VXPDISP.INC must be included 
C           before the include call for this file.
C
C -----------------------------------------------------------------
C                 CONFIGURABLE CONSTANTS
C -----------------------------------------------------------------
      
      PARAMETER (MAX_OPTS = 10)           ! maximum options in a menu
      PARAMETER (N_MAIN_OPTS = 7)         ! number of main options
      PARAMETER (N_FILE_OPTS = 7)         ! no. of file menu options
      PARAMETER (N_PLOT_OPTS = 6)         !  "     plot  "
      PARAMETER (N_MATH_OPTS = 6)	  !  "     math  "
      PARAMETER (N_SYMBOL_OPTS = 4)       ! no. of symbol menu options
      PARAMETER (DEF_MENU_HEIGHT = 6.0)   ! default menu height (cm)
      PARAMETER (DEF_MENU_WIDTH = 4.0)    ! default menu width (cm)

C ----------------------------------------------------------------
C                 ARRAYS AND VARIABLES
C ----------------------------------------------------------------

      CHARACTER*20 OP (MAX_OPTS)
      CHARACTER*20 MAIN_OP (N_MAIN_OPTS)
      CHARACTER*20 FILE_OP (N_FILE_OPTS)
      CHARACTER*20 PLOT_OP (N_PLOT_OPTS)
      CHARACTER*20 MATH_OP (N_MATH_OPTS)
      CHARACTER*20 SYMBOL_OP (N_SYMBOL_OPTS)	         

      DATA OP /MAX_OPTS*'      '/

      DATA MAIN_OP /' HELP ', ' FILE ', ' PLOT ', ' MATH ',
     +              ' COMMAND ', ' QUIT ',
     +              ' EXIT MENU '/

      DATA FILE_OP /' NEW ', ' OVERLAY ', ' OPEN ', ' REMOVE ', 
     +              ' INCLUDE ', ' SAVE ', ' EXIT MENU ' /

      DATA PLOT_OP /' DROP ', ' HEADER ', ' EXPAND ', ' FREEZE ', 
     +              ' SYMBOL ', ' EXIT MENU '/

      DATA MATH_OP /' RESCALE ', ' SMOOTH ', ' POLY FIT ',
     +              ' AREA ', ' DERIV ', ' EXIT MENU ' /

      DATA SYMBOL_OP /' LINE ', ' POINT ', ' STICK ', ' EXIT MENU '/
	
      RECORD /DISPLAY/ MW
      INTEGER OPTION_NUMBER

C -------------------------------------------------------------------
C                COMMON BLOCK
C -------------------------------------------------------------------

      COMMON /MENU_VARIABLES/ JCW, MW, OP, N_OPTS, OPTION_NUMBER,
     +   MENU_KEYBUF

C -----------------------------------------------------------------
