\ arithmetic.4th
\
\ xyplot module for dataset arithmetic functions
\
\ (c) 1999--2005 Krishna Myneni
\
\ This software is released under the terms of the GNU
\ General Public License
\ 
\ Revisions: 
\	1-18-2000
\	6-21-2000 updated for new features of kforth  KM
\       1-13-2005 updated for new DatasetInfo data structure  KM
\       8-03-2005 updated to use submenu in Math Menu  KM
\ Requires:
\
\	matrix.4th
\	xyplot.4th
\	xutils.4th

DatasetInfo ds3

2 8000 fmatrix result


: make_result ( ^name  -- n | make dataset resulting from an arithmetic operation )
	
	\ Set up the info structure for a new dataset

	1+ ds3 DNAME !
	c"  " 1+ ds3 DHEADER !
	256 ds3 DTYPE !
	result mat_size@ drop ds3 DNPTS !
	2 ds3 DSIZE !
	result cell+ cell+ ds3 DDATA !
		 	      
	ds3 make_ds ;

variable rcntr
variable ar_operator 

: do_arithmetic ( n1 n2 addr -- flag | loop over index range n1 to n2 and apply operator )
	ar_operator !			\ store execution address of operator
	1 rcntr !
	index_range
	2dup <>
	if
	  swap
	  2dup - 2 result mat_size!	\ set size of result matrix	
	  do
	    i ds1 @xy
	    fover ds2 findx		\ find nearest point in ds2
	    ds2 @xy
	    fswap fdrop
	    ar_operator a@ execute
	    2 rcntr @ result frow!
	    1 rcntr +!
	  loop
	  true
	else
	  2drop
	  false
	then ;

 
: add_ds ( -- | add the operand set and the active set )
	['] f+ do_arithmetic
	if " Sum" make_result drop then ;

   
: sub_ds ( -- | add the operand set and the active set )
	['] f- do_arithmetic
	if " Difference" make_result drop then ;
   	   
     	        
: mul_ds ( -- | add the operand set and the active set )
	['] f* do_arithmetic
	if " Product" make_result drop then ;

   
: div_ds ( -- | add the operand set and the active set )
	['] f/ do_arithmetic
	if " Quotient" make_result drop then ;
   

\ add arithmetic functions to submenu of Math Menu

MN_MATH  c" Arithmetic"  make_submenu  CONSTANT  MN_ARITHMETIC

MN_ARITHMETIC  c" Add"		" add_ds"  add_menu_item
MN_ARITHMETIC  c" Subtract"	" sub_ds"  add_menu_item
MN_ARITHMETIC  c" Multiply"	" mul_ds"  add_menu_item
MN_ARITHMETIC  c" Divide"	" div_ds"  add_menu_item

