/*
CDeviceContext.cpp

Copyright (c) 1998--2001 Creative Consulting for Research and Education

Provided under the terms of the GNU General Public License.

Revisions:
  8-30-1998
  11-6-1999 initialize and delete m_pColors and m_pColorNames
  03-05-2001 include string.h
*/
#include <string.h>
#include "CDeviceContext.h"

CDeviceContext::CDeviceContext (int dev_type, int xres, int yres)
{
  m_nDevType = dev_type;
  m_nXres = xres;
  m_nYres = yres;
  m_bInverted = false;
  m_nColors = 0;
  m_nForeground = 0;
  m_pColors = NULL;
  m_pColorNames = NULL;
}
//---------------------------------------------------------------

CDeviceContext::~CDeviceContext ()
{
  delete [] m_pColors;

  for (int i = 0; i < m_nColors; i++)
    delete [] m_pColorNames[i];

  delete [] m_pColorNames;
}
//----------------------------------------------------------------

unsigned CDeviceContext::GetColor (char* name)
{
  // Search the color table for specified color and return
  //   its color value; in this case an index into m_pColors

  for (int i = 0; i < m_nColors; i++)
    {
      if (strcmp(m_pColorNames[i], name) == 0) return i;
    }
  return (m_nColors + 1);  // return invalid color number if not found
}
//---------------------------------------------------------------

void CDeviceContext::Rectangle (CRect rect)
{

	int ix1 = rect.TopLeft().x;
	int iy1 = rect.TopLeft().y;
	int ix2 = rect.BottomRight().x;
	int iy2 = rect.BottomRight().y;

	MoveTo(ix1,iy1);
	LineTo(ix2, iy1);
	LineTo(ix2, iy2);
	LineTo(ix1, iy2);
	LineTo(ix1, iy1);
}
