\ arithmetic.4th
\
\ xyplot module for dataset arithmetic functions
\
\ (c) 1999--2007 Krishna Myneni
\
\ This software is released under the terms of the GNU
\ General Public License
\ 
\ Revisions: 
\	2000-01-18
\	2000-06-21 updated for new features of kforth  KM
\       2005-01-13  updated for new DatasetInfo data structure  KM
\       2005-08-03  updated to use submenu in Math Menu  KM
\       2007-06-02  now using FSL arrays and matrices; removed requirement for matrix.4th
\
\ Requires:
\
\	xyplot.4th
\	xutils.4th

DatasetInfo ds3

FLOAT DMATRIX result{{
0 value Npts

: make_result ( ^name  -- n | make dataset resulting from an arithmetic operation )
	
    \ Set up the info structure for a new dataset

    1+       ds3  DNAME !
    c"  " 1+ ds3  DHEADER !
    256      ds3  DTYPE !
    Npts     ds3  DNPTS !
    2        ds3  DSIZE !
    result{{ ds3  DDATA !
		 	      
    ds3 make_ds

    & result{{ }}free
;

0 value ridx
0 ptr   ar_operator 

: do_arithmetic ( addr -- flag | loop over index range n1 to n2 and apply operator )
    to ar_operator                      \ store execution address of operator
    0 to ridx
    index_range
    2dup <>
    IF
	swap
	2dup - to Npts
	& result{{ Npts 2 }}malloc      \ allocate the result matrix
	DO
	    I ds1 @xy
	    fover ds2 findx		\ find nearest point in ds2
	    ds2 @xy
	    fswap fdrop
	    ar_operator execute
	    result{{ ridx 1 }} F!  result{{ ridx 0 }} F!
	    ridx 1+ to ridx
	LOOP  true
    ELSE
	2drop false
    THEN ;

 
: add_ds ( -- | add the operand set and the active set )
	['] f+ do_arithmetic  IF c" Sum" make_result drop THEN ;

: sub_ds ( -- | add the operand set and the active set )
	['] f- do_arithmetic  IF c" Difference" make_result drop THEN ;
     	        
: mul_ds ( -- | add the operand set and the active set )
	['] f* do_arithmetic  IF c" Product" make_result drop THEN ;
   
: div_ds ( -- | add the operand set and the active set )
	['] f/ do_arithmetic  IF c" Quotient" make_result drop THEN ;
   

\ add arithmetic functions to submenu of Math Menu

MN_MATH  c" Arithmetic"  make_submenu  CONSTANT  MN_ARITHMETIC

MN_ARITHMETIC  c" Add"		" add_ds"  add_menu_item
MN_ARITHMETIC  c" Subtract"	" sub_ds"  add_menu_item
MN_ARITHMETIC  c" Multiply"	" mul_ds"  add_menu_item
MN_ARITHMETIC  c" Divide"	" div_ds"  add_menu_item

