\ xyderiv.4th
\
\ xyplot module for derivative computation
\
\ Copyright (c) 2001--2007 Krishna Myneni, Creative Consulting
\   for Research and Education.
\
\ Provided under the GNU General Public License
\
\ Requires:
\	derivative.4th
\
\ Revisions:
\       2001        created
\       2005-01-14  updated for new DatasetInfo data structure  km
\       2007-06-02  updated to use FSL-style arrays  km

DatasetInfo dsder
FLOAT DMATRIX deriv{{
0 value np

: xyderiv ( -- )
    ?active dup 0 >= IF
	ds1 get_ds 0 >= IF
	    ds1 ->npts to np
	    & deriv{{ np 2 }}malloc
	    malloc-fail? IF ." Unable to alloc derivative matrix." cr EXIT THEN
	    
	    \ Copy dataset x,y values to the derivative matrix

	    np 0 DO
		I ds1 @xy  deriv{{ I 1 }} F!  deriv{{ I 0 }} F!
	    LOOP

	    deriv{{  np derivative  IF
	      ." Error computing derivative" EXIT
	    THEN

	    \ Make a new dataset

	    c" Derivative" 1+ dsder DNAME !
	    c" Derivative" 1+ dsder DHEADER !
	    256 dsder DTYPE !		\ double precision fp type
	    np  dsder DNPTS !
	    2   dsder DSIZE !
	    deriv{{ dsder DDATA !

	    dsder make_ds drop
	    & deriv{{ }}free
	THEN
    ELSE  drop  THEN ;
	       
MN_MATH " Derivative"	" xyderiv" add_menu_item
