\ template.4th
\
\  Provide a Math Menu function to generate a dataset and plot
\  of the function y=x. Such a set may be operated upon, using
\  "Expression" from the Math Menu to generate plots of simple
\  functions.
\
\  Copyright (c) 2007 Krishna Myneni
\  Provided under the GNU General Public License
\
\  Revisions:
\

DatasetInfo ds_template 
PlotInfo    pl_template 

FLOAT DMATRIX templ{{ 

\ Fill out a dataset info structure on the template dataset

c" Template" 1+ ds_template DNAME ! \ name of new dataset
c" Y=X" 1+      ds_template DHEADER !
256 ds_template DTYPE  !		\ real dataset
2 ds_template DSIZE  !		\ dimension is 2 (x, y)


\ Fill out a plot info structure on the new plot

0 pl_template PTYPE  !		\ plot type
1 pl_template PSYM  !		\ plot symbol

	   
fvariable fx1
fvariable fx2
fvariable fxdel

0 value Npts

\ Get template parameters from the user, generate the function, and
\   make a dataset and plot.
: xy_template ( -- )
    c" Enter x1, x2, and delta x:" get_input
    0= IF drop EXIT THEN

    \ Sanity checks on the user's input parameters
    
    count parse_args
    3 <> IF
	s" Incorrect number of arguments for Template." message_box
	abort
    THEN
    fxdel f! fx2 f! fx1 f!

    fxdel f@ F0= IF
	s" Delta x cannot be zero." message_box
	abort
    THEN

    fx1 f@ fx2 f@ f> IF fx1 f@ fx2 f@ fx1 f! fx2 f! THEN
    fxdel f@ fabs fxdel f!
    
    fx2 f@ fx1 f@ f- fxdel f@ f/ fround>s 1+ to Npts
  
    & templ{{ Npts 2 }}malloc

    fx1 f@
    Npts 0 DO  fdup templ{{ I 0 }} F!  fdup templ{{ I 1 }} F! fxdel f@ f+ LOOP
    fdrop

    Npts ds_template DNPTS !
    templ{{ ds_template DDATA !
 
    ds_template make_ds         \ make the dataset ( set number returned )
    dup pl_template PDSET  !  pl_template PCOLOR  ! 
    pl_template make_plot	\ make the corresponding plot  

    \ cleanup
    & templ{{ }}free
;


MN_MATH  c" Template"  c" xy_template reset_window"  add_menu_item
