\ fft.4th
\
\ Compute Fourier transform of complex data
\
\ Notes:
\
\	The number of rows in the input matrix must be a power of 2.
\
\ Revisions:
\	8-16-2000 added inverse FFT routine  KM
\
0 value Nvals
0 ptr arr{

0 value jj
0 value mm
0 value mmax
0 value istep

fvariable wr
fvariable wi
fvariable wpr
fvariable wpi

: }fft ( a n -- | replace an array of n complex values with its FFT )
    to Nvals  to arr{
    0 to jj

    Nvals 0 DO
	jj I > IF		\ exchange two complex numbers
	    arr{ jj } F@     arr{ jj 1+ } F@
	    arr{ I  } F@     arr{ I 1+ } F@
	    arr{ jj 1+ } F!  arr{ jj } F!
	    arr{ I 1+ } F!   arr{ I } F!	
	THEN
	
	Nvals  2/  to mm

	BEGIN
	    mm 2 >=  jj mm >  and
	WHILE
		mm negate jj + to jj
		mm 2/ to mm
	REPEAT

	mm jj + to jj
    2 +LOOP

    2 to mmax

    BEGIN
	Nvals mmax >
    WHILE
	    mmax dup 2* to istep
	    >r 6.28318530717959e0 r> s>f F/
	    fdup
	    0.5e F* fsin fdup F* -2e F* wpr F!
	    fsin wpi F!
	    
	    1e wr F!  0e wi F!
	  
	    mmax 1+ 1 DO
		Nvals 0 DO
		    I mmax + to jj
		    arr{ jj } F@    wr F@ F* 
		    arr{ jj 1+ } F@ wi F@ F*
		    F-
		    arr{ jj 1+ } F@ wr F@ F*
		    arr{ jj }    F@ wi F@ F*
		    F+			
		    fover
		    arr{ I }    F@ fswap F-  arr{ jj }    F!
		    arr{ I 1+ } F@ fover F-  arr{ jj 1+ } F!
		    arr{ I 1+ } F@ F+  arr{ I 1+ } F!
		    arr{ I }    F@ F+  arr{ I }    F!
		istep +LOOP
		wr F@ fdup fdup  wpr F@ F* F+ wi F@ wpi F@ F* F- wr F!
		wpi F@ F* wi F@  wpr F@ F* F+ wi F@ F+ wi F!
	    2 +LOOP
	  
	    istep to mmax
    REPEAT
;


 

: inv_fft ( a -- | replace a with inverse FFT )
	dup fft_arr !
	mat_size@ drop nvals !

	1 jj !

	nvals @ 1+ 1 do

	  jj @ i > if		\ exchange two complex numbers
	    jj @ @a_n
	    jj @ 1+ @a_n
	    i @a_n jj @ !a_n
	    i 1+ @a_n jj @ 1+ !a_n
	    i 1+ !a_n
	    i !a_n	
	  then

	  nvals @ 2/ mm !

	  begin
	    mm @ 2 >= jj @ mm @ > and
	  while
	    mm @ negate jj +!
	    mm @ 2/ mm !
	  repeat

	  mm @ jj +!
	2 +loop

	2 mmax !

	begin
	  nvals @ mmax @ >
	while
	  mmax @ dup 2* istep !
	  >r 6.28318530717959e0 r> negate s>f f/
	  fdup
	  0.5e f* fsin fdup f* -2e f* wpr f!
	  fsin wpi f!
	  1e wr f!
	  0e wi f!
	  
	  mmax @ 1+ 1 do
	    nvals @ 1+ i do
	      i mmax @ + jj !
	      jj @ @a_n wr f@ f* 
	      jj @ 1+ @a_n wi f@ f*
	      f-
	      jj @ 1+ @a_n wr f@ f*
	      jj @ @a_n wi f@ f*
	      f+			
	      fover
	      i @a_n fswap f- jj @ !a_n
	      i 1+ @a_n fover f- jj @ 1+ !a_n
	      i 1+ @a_n f+ i 1+ !a_n
	      i @a_n f+ i !a_n
	    istep @ +loop
	    
	    wr f@
	    fdup fdup wpr f@ f* f+ wi f@ wpi f@ f* f- wr f!
	    wpi f@ f* wi f@ wpr f@ f* f+ wi f@ f+ wi f!
	  2 +loop
	  
	  istep @ mmax !
	repeat
;
 	  
	