\ xyexpfit.4th
\
\ Fit data to the function:
\
\	y = a*exp(-x/b) + c
\
\ Parameter array is 3x1 and ordering is:
\
\	1 1  a
\	2 1  b
\	3 1  c
\
\ Requires:
\	matrix.4th
\	curvefit.4th
\

: functn ( fx a -- fy )
	>r 2 1 r@ fmat@ f/ fnegate fexp
	1 1 r@ fmat@ f* 
	3 1 r> fmat@ f+ ;

include curvefit.4th

MAX_POINTS 1 fmatrix x
MAX_POINTS 1 fmatrix y
MAX_POINTS 2 fmatrix fit_data

3 1 fmatrix params
3 1 fmatrix increments

: expfit ( -- )
	?active dup 0 >= 
	if
	  ds1 get_ds
	  0 >= if
	    ds1 ->npts MAX_POINTS > if
	      ." Too many points in data set. Resize MAX_POINTS." cr
	      exit
	    then
	    ds1 ->npts 1 x mat_size!
	    ds1 ->npts 1 y mat_size!

	    ds1 ->npts 1+ 1 ?do
	      i 1- ds1 @xy
	      i 1 y fmat!
	      i 1 x fmat!
	    loop
	    5 0 do
	      x y params increments curfit
	    loop
	    ." Reduced Chi^2 = " f. cr
	    ." a = " 1 1 params fmat@ f. cr
	    ." b = " 2 1 params fmat@ f. cr
	    ." c = " 3 1 params fmat@ f. cr
	    
	    \ Make a dataset with the fit data

	    ds1 ->npts 2 fit_data mat_size!
	    ds1 ->npts 1+ 1 ?do
	      i 1 x fmat@ i 1 fit_data fmat!
	      i 1 yfit fmat@ i 2 fit_data fmat!
	    loop
	    
	    c"  " 1+ ds2 DHEADER + !
	    c" Exp Fit" 1+ ds2 DNAME + !
	    256 ds2 DTYPE + !
	    ds1 ->npts ds2 DNPTS + !
	    2 ds2 DSIZE + !
	    fit_data 2 cells + ds2 DDATA + !

	    ds2 make_ds drop

	  then
	else
	  drop
	then ;


: xyexpfit ( -- )
	?active 0 >= 
	if
	  c" Enter initial a, b, c for y=a*exp(-x/b) + c:" get_input
	  if
	    count parse_args 3 <> abort" Entered wrong number of parameters!"
	    3 1 params fmat!
	    2 1 params fmat!
	    1 1 params fmat!
	    c" Enter initial increments da, db, dc:" get_input
	    if
	      count parse_args 3 <> abort" Entered wrong number of params!"
	      3 1 increments fmat!
	      2 1 increments fmat!
	      1 1 increments fmat!
	    else
	      exit
	    then
	    ." Initial parameters and increments:" cr
	    4 1 do i 1 params fmat@ f. 2 spaces i 1 increments fmat@ f. cr loop
	    expfit
	  else
	    drop
	  then
	then ;

MN_MATH " Exponential Fit"  " xyexpfit draw_window" add_menu_item
