/*
xyplot.h

Header file for XYPLOT (C++/Linux/X Windows version)

Copyright (c) 1995--2000 Krishna Myneni 
Creative Consulting for Research & Education

This software is provided under the terms of the GNU General Public
License.
Created: 21-Mar-93
Last Update: 4-11-2000
*/

#include "CPlotWindow.h"
#include <strstream.h>

#define ANNOTATION_PREFIX "==XYPLOT==> "

// Function prototypes:

int BlankLine (char*);
int NumberParse (float*, char*);
void SortRect (CRect*);
char* LabelFormat (float, float, char);
char* DisplayFormat (float x1, float x2);
int AddToHeader (char*, char*, bool);
void LoadInitializationFile();
vector<char*> GetStartupFileList (int, char**);
void InitForthInterface();
int LoadForthFile(char*);
int ExecuteForthExpression (char*, ostrstream*, int*, int*);

// The following functions provide the interface between
// the C++ functions and the Forth environment. They
// should not be called by C, C++, or assembler routines.
//
int get_active();
int get_operand();
int get_ds();
int set_ds_extrema();
int make_ds();
int get_plot();
int make_plot();
int set_plot_symbol();
int set_plot_color();
int draw_plot();
int set_grid_tics();
int set_grid_lines();
int clear_window();
int draw_window();
int reset_window();
int get_window_limits();
int set_window_limits();
int add_menu_item();
int set_background();
int set_foreground();
int get_input();
